/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import { ServiceClientOptions } from "@azure/ms-rest-js";
import * as msRest from "@azure/ms-rest-js";

/**
 * APIError is an api error with a message
 */
export interface APIError {
  message?: string;
  url?: string;
}

/**
 * An interface representing AccessToken.
 * @summary AccessToken represents an API access token.
 */
export interface AccessToken {
  id?: number;
  name?: string;
  sha1?: string;
  tokenLastEight?: string;
}

/**
 * AddCollaboratorOption options when adding a user as a collaborator of a repository
 */
export interface AddCollaboratorOption {
  permission?: string;
}

/**
 * AddTimeOption options for adding time to an issue
 */
export interface AddTimeOption {
  created?: Date;
  /**
   * time in seconds
   */
  time: number;
  /**
   * User who spent the time (optional)
   */
  userName?: string;
}

/**
 * AnnotatedTagObject contains meta information of the tag object
 */
export interface AnnotatedTagObject {
  sha?: string;
  type?: string;
  url?: string;
}

/**
 * An interface representing CommitUser.
 * @summary CommitUser contains information of a user in the context of a commit.
 */
export interface CommitUser {
  date?: string;
  email?: string;
  name?: string;
}

/**
 * PayloadUser represents the author or committer of a commit
 */
export interface PayloadUser {
  email?: string;
  /**
   * Full name of the commit author
   */
  name?: string;
  username?: string;
}

/**
 * PayloadCommitVerification represents the GPG verification of a commit
 */
export interface PayloadCommitVerification {
  payload?: string;
  reason?: string;
  signature?: string;
  signer?: PayloadUser;
  verified?: boolean;
}

/**
 * AnnotatedTag represents an annotated tag
 */
export interface AnnotatedTag {
  message?: string;
  object?: AnnotatedTagObject;
  sha?: string;
  tag?: string;
  tagger?: CommitUser;
  url?: string;
  verification?: PayloadCommitVerification;
}

/**
 * Attachment a generic attachment
 */
export interface Attachment {
  browserDownloadUrl?: string;
  createdAt?: Date;
  downloadCount?: number;
  id?: number;
  name?: string;
  size?: number;
  uuid?: string;
}

/**
 * PayloadCommit represents a commit
 */
export interface PayloadCommit {
  added?: string[];
  author?: PayloadUser;
  committer?: PayloadUser;
  /**
   * sha1 hash of the commit
   */
  id?: string;
  message?: string;
  modified?: string[];
  removed?: string[];
  timestamp?: Date;
  url?: string;
  verification?: PayloadCommitVerification;
}

/**
 * Branch represents a repository branch
 */
export interface Branch {
  commit?: PayloadCommit;
  effectiveBranchProtectionName?: string;
  enableStatusCheck?: boolean;
  name?: string;
  protectedProperty?: boolean;
  requiredApprovals?: number;
  statusCheckContexts?: string[];
  userCanMerge?: boolean;
  userCanPush?: boolean;
}

/**
 * BranchProtection represents a branch protection for a repository
 */
export interface BranchProtection {
  approvalsWhitelistTeams?: string[];
  approvalsWhitelistUsername?: string[];
  blockOnOutdatedBranch?: boolean;
  blockOnRejectedReviews?: boolean;
  branchName?: string;
  createdAt?: Date;
  dismissStaleApprovals?: boolean;
  enableApprovalsWhitelist?: boolean;
  enableMergeWhitelist?: boolean;
  enablePush?: boolean;
  enablePushWhitelist?: boolean;
  enableStatusCheck?: boolean;
  mergeWhitelistTeams?: string[];
  mergeWhitelistUsernames?: string[];
  protectedFilePatterns?: string;
  pushWhitelistDeployKeys?: boolean;
  pushWhitelistTeams?: string[];
  pushWhitelistUsernames?: string[];
  requireSignedCommits?: boolean;
  requiredApprovals?: number;
  statusCheckContexts?: string[];
  updatedAt?: Date;
}

/**
 * User represents a user
 */
export interface User {
  /**
   * URL to the user's avatar
   */
  avatarUrl?: string;
  created?: Date;
  email?: string;
  /**
   * the user's full name
   */
  fullName?: string;
  /**
   * the user's id
   */
  id?: number;
  /**
   * Is the user an administrator
   */
  isAdmin?: boolean;
  /**
   * User locale
   */
  language?: string;
  lastLogin?: Date;
  /**
   * the user's username
   */
  login?: string;
}

/**
 * Comment represents a comment on a commit or issue
 */
export interface Comment {
  body?: string;
  createdAt?: Date;
  htmlUrl?: string;
  id?: number;
  issueUrl?: string;
  originalAuthor?: string;
  originalAuthorId?: number;
  pullRequestUrl?: string;
  updatedAt?: Date;
  user?: User;
}

/**
 * An interface representing CommitMeta.
 * @summary CommitMeta contains meta information of a commit in terms of API.
 */
export interface CommitMeta {
  sha?: string;
  url?: string;
}

/**
 * An interface representing RepoCommit.
 * @summary RepoCommit contains information of a commit in the context of a repository.
 */
export interface RepoCommit {
  author?: CommitUser;
  committer?: CommitUser;
  message?: string;
  tree?: CommitMeta;
  url?: string;
}

/**
 * An interface representing Commit.
 * @summary Commit contains information generated from a Git commit.
 */
export interface Commit {
  author?: User;
  commit?: RepoCommit;
  committer?: User;
  htmlUrl?: string;
  parents?: CommitMeta[];
  sha?: string;
  url?: string;
}

/**
 * CommitDateOptions store dates for GIT_AUTHOR_DATE and GIT_COMMITTER_DATE
 */
export interface CommitDateOptions {
  author?: Date;
  committer?: Date;
}

/**
 * FileLinksResponse contains the links for a repo's file
 */
export interface FileLinksResponse {
  git?: string;
  html?: string;
  self?: string;
}

/**
 * ContentsResponse contains information about a repo's entry's (dir, file, symlink, submodule)
 * metadata and content
 */
export interface ContentsResponse {
  _links?: FileLinksResponse;
  /**
   * `content` is populated when `type` is `file`, otherwise null
   */
  content?: string;
  downloadUrl?: string;
  /**
   * `encoding` is populated when `type` is `file`, otherwise null
   */
  encoding?: string;
  gitUrl?: string;
  htmlUrl?: string;
  name?: string;
  path?: string;
  sha?: string;
  size?: number;
  /**
   * `submodule_git_url` is populated when `type` is `submodule`, otherwise null
   */
  submoduleGitUrl?: string;
  /**
   * `target` is populated when `type` is `symlink`, otherwise null
   */
  target?: string;
  /**
   * `type` will be `file`, `dir`, `symlink`, or `submodule`
   */
  type?: string;
  url?: string;
}

/**
 * CreateBranchProtectionOption options for creating a branch protection
 */
export interface CreateBranchProtectionOption {
  approvalsWhitelistTeams?: string[];
  approvalsWhitelistUsername?: string[];
  blockOnOutdatedBranch?: boolean;
  blockOnRejectedReviews?: boolean;
  branchName?: string;
  dismissStaleApprovals?: boolean;
  enableApprovalsWhitelist?: boolean;
  enableMergeWhitelist?: boolean;
  enablePush?: boolean;
  enablePushWhitelist?: boolean;
  enableStatusCheck?: boolean;
  mergeWhitelistTeams?: string[];
  mergeWhitelistUsernames?: string[];
  protectedFilePatterns?: string;
  pushWhitelistDeployKeys?: boolean;
  pushWhitelistTeams?: string[];
  pushWhitelistUsernames?: string[];
  requireSignedCommits?: boolean;
  requiredApprovals?: number;
  statusCheckContexts?: string[];
}

/**
 * CreateEmailOption options when creating email addresses
 */
export interface CreateEmailOption {
  /**
   * email addresses to add
   */
  emails?: string[];
}

/**
 * Identity for a person's identity like an author or committer
 */
export interface Identity {
  email?: string;
  name?: string;
}

/**
 * CreateFileOptions options for creating files
 * Note: `author` and `committer` are optional (if only one is given, it will be used for the
 * other, otherwise the authenticated user will be used)
 */
export interface CreateFileOptions {
  author?: Identity;
  /**
   * branch (optional) to base this file from. if not given, the default branch is used
   */
  branch?: string;
  committer?: Identity;
  /**
   * content must be base64 encoded
   */
  content: string;
  dates?: CommitDateOptions;
  /**
   * message (optional) for the commit of this file. if not supplied, a default message will be
   * used
   */
  message?: string;
  /**
   * new_branch (optional) will make a new branch from `branch` before creating the file
   */
  newBranch?: string;
}

/**
 * CreateForkOption options for creating a fork
 */
export interface CreateForkOption {
  /**
   * organization name, if forking into an organization
   */
  organization?: string;
}

/**
 * CreateGPGKeyOption options create user GPG key
 */
export interface CreateGPGKeyOption {
  /**
   * An armored GPG key to add
   */
  armoredPublicKey: string;
}

/**
 * CreateHookOption options when create a hook
 */
export interface CreateHookOption {
  /**
   * Default value: false.
   */
  active?: boolean;
  branchFilter?: string;
  config: { [propertyName: string]: string };
  events?: string[];
  /**
   * Possible values include: 'dingtalk', 'discord', 'gitea', 'gogs', 'msteams', 'slack',
   * 'telegram', 'feishu'
   */
  type: Type;
}

/**
 * CreateIssueCommentOption options for creating a comment on an issue
 */
export interface CreateIssueCommentOption {
  body: string;
}

/**
 * CreateIssueOption options to create one issue
 */
export interface CreateIssueOption {
  /**
   * username of assignee
   */
  assignee?: string;
  assignees?: string[];
  body?: string;
  closed?: boolean;
  dueDate?: Date;
  /**
   * list of label ids
   */
  labels?: number[];
  /**
   * milestone id
   */
  milestone?: number;
  title: string;
}

/**
 * CreateKeyOption options when creating a key
 */
export interface CreateKeyOption {
  /**
   * An armored SSH key to add
   */
  key: string;
  /**
   * Describe if the key has only read access or read/write
   */
  readOnly?: boolean;
  /**
   * Title of the key to add
   */
  title: string;
}

/**
 * CreateLabelOption options for creating a label
 */
export interface CreateLabelOption {
  color: string;
  description?: string;
  name: string;
}

/**
 * CreateMilestoneOption options for creating a milestone
 */
export interface CreateMilestoneOption {
  description?: string;
  dueOn?: Date;
  title?: string;
}

/**
 * CreateOAuth2ApplicationOptions holds options to create an oauth2 application
 */
export interface CreateOAuth2ApplicationOptions {
  name?: string;
  redirectUris?: string[];
}

/**
 * CreateOrgOption options for creating an organization
 */
export interface CreateOrgOption {
  description?: string;
  fullName?: string;
  location?: string;
  repoAdminChangeTeamAccess?: boolean;
  username: string;
  /**
   * possible values are `public` (default), `limited` or `private`. Possible values include:
   * 'public', 'limited', 'private'
   */
  visibility?: Visibility;
  website?: string;
}

/**
 * CreatePullRequestOption options when creating a pull request
 */
export interface CreatePullRequestOption {
  assignee?: string;
  assignees?: string[];
  base?: string;
  body?: string;
  dueDate?: Date;
  head?: string;
  labels?: number[];
  milestone?: number;
  title?: string;
}

/**
 * CreatePullReviewComment represent a review comment for creation api
 */
export interface CreatePullReviewComment {
  body?: string;
  /**
   * if comment to new file line or 0
   */
  newPosition?: number;
  /**
   * if comment to old file line or 0
   */
  oldPosition?: number;
  /**
   * the tree path
   */
  path?: string;
}

/**
 * CreatePullReviewOptions are options to create a pull review
 */
export interface CreatePullReviewOptions {
  body?: string;
  comments?: CreatePullReviewComment[];
  commitId?: string;
  event?: string;
}

/**
 * CreateReleaseOption options when creating a release
 */
export interface CreateReleaseOption {
  body?: string;
  draft?: boolean;
  name?: string;
  prerelease?: boolean;
  tagName: string;
  targetCommitish?: string;
}

/**
 * CreateRepoOption options when creating repository
 */
export interface CreateRepoOption {
  /**
   * Whether the repository should be auto-intialized?
   */
  autoInit?: boolean;
  /**
   * DefaultBranch of the repository (used when initializes and in template)
   */
  defaultBranch?: string;
  /**
   * Description of the repository to create
   */
  description?: string;
  /**
   * Gitignores to use
   */
  gitignores?: string;
  /**
   * Issue Label set to use
   */
  issueLabels?: string;
  /**
   * License to use
   */
  license?: string;
  /**
   * Name of the repository to create
   */
  name: string;
  /**
   * Whether the repository is private
   */
  privateProperty?: boolean;
  /**
   * Readme of the repository to create
   */
  readme?: string;
}

/**
 * CreateStatusOption holds the information needed to create a new Status for a Commit
 */
export interface CreateStatusOption {
  context?: string;
  description?: string;
  state?: string;
  targetUrl?: string;
}

/**
 * CreateTeamOption options for creating a team
 */
export interface CreateTeamOption {
  canCreateOrgRepo?: boolean;
  description?: string;
  includesAllRepositories?: boolean;
  name: string;
  /**
   * Possible values include: 'read', 'write', 'admin'
   */
  permission?: PermissionEnum;
  units?: string[];
}

/**
 * CreateUserOption create user options
 */
export interface CreateUserOption {
  email: string;
  fullName?: string;
  loginName?: string;
  mustChangePassword?: boolean;
  password: string;
  sendNotify?: boolean;
  sourceId?: number;
  username: string;
}

/**
 * DeleteEmailOption options when deleting email addresses
 */
export interface DeleteEmailOption {
  /**
   * email addresses to delete
   */
  emails?: string[];
}

/**
 * DeleteFileOptions options for deleting files (used for other File structs below)
 * Note: `author` and `committer` are optional (if only one is given, it will be used for the
 * other, otherwise the authenticated user will be used)
 */
export interface DeleteFileOptions {
  author?: Identity;
  /**
   * branch (optional) to base this file from. if not given, the default branch is used
   */
  branch?: string;
  committer?: Identity;
  dates?: CommitDateOptions;
  /**
   * message (optional) for the commit of this file. if not supplied, a default message will be
   * used
   */
  message?: string;
  /**
   * new_branch (optional) will make a new branch from `branch` before creating the file
   */
  newBranch?: string;
  /**
   * sha is the SHA for the file that already exists
   */
  sha: string;
}

/**
 * ExternalTracker represents settings for external tracker
 */
export interface ExternalTracker {
  /**
   * External Issue Tracker URL Format. Use the placeholders {user}, {repo} and {index} for the
   * username, repository name and issue index.
   */
  externalTrackerFormat?: string;
  /**
   * External Issue Tracker Number Format, either `numeric` or `alphanumeric`
   */
  externalTrackerStyle?: string;
  /**
   * URL of external issue tracker.
   */
  externalTrackerUrl?: string;
}

/**
 * ExternalWiki represents setting for external wiki
 */
export interface ExternalWiki {
  /**
   * URL of external wiki.
   */
  externalWikiUrl?: string;
}

/**
 * InternalTracker represents settings for internal tracker
 */
export interface InternalTracker {
  /**
   * Let only contributors track time (Built-in issue tracker)
   */
  allowOnlyContributorsToTrackTime?: boolean;
  /**
   * Enable dependencies for issues and pull requests (Built-in issue tracker)
   */
  enableIssueDependencies?: boolean;
  /**
   * Enable time tracking (Built-in issue tracker)
   */
  enableTimeTracker?: boolean;
}

/**
 * Permission represents a set of permissions
 */
export interface Permission {
  admin?: boolean;
  pull?: boolean;
  push?: boolean;
}

/**
 * Repository represents a repository
 */
export interface Repository {
  allowMergeCommits?: boolean;
  allowRebase?: boolean;
  allowRebaseExplicit?: boolean;
  allowSquashMerge?: boolean;
  archived?: boolean;
  avatarUrl?: string;
  cloneUrl?: string;
  createdAt?: Date;
  defaultBranch?: string;
  description?: string;
  empty?: boolean;
  externalTracker?: ExternalTracker;
  externalWiki?: ExternalWiki;
  fork?: boolean;
  forksCount?: number;
  fullName?: string;
  hasIssues?: boolean;
  hasPullRequests?: boolean;
  hasWiki?: boolean;
  htmlUrl?: string;
  id?: number;
  ignoreWhitespaceConflicts?: boolean;
  internalTracker?: InternalTracker;
  mirror?: boolean;
  name?: string;
  openIssuesCount?: number;
  openPrCounter?: number;
  originalUrl?: string;
  owner?: User;
  parent?: Repository;
  permissions?: Permission;
  privateProperty?: boolean;
  releaseCounter?: number;
  size?: number;
  sshUrl?: string;
  starsCount?: number;
  template?: boolean;
  updatedAt?: Date;
  watchersCount?: number;
  website?: string;
}

/**
 * DeployKey a deploy key
 */
export interface DeployKey {
  createdAt?: Date;
  fingerprint?: string;
  id?: number;
  key?: string;
  keyId?: number;
  readOnly?: boolean;
  repository?: Repository;
  title?: string;
  url?: string;
}

/**
 * EditAttachmentOptions options for editing attachments
 */
export interface EditAttachmentOptions {
  name?: string;
}

/**
 * EditBranchProtectionOption options for editing a branch protection
 */
export interface EditBranchProtectionOption {
  approvalsWhitelistTeams?: string[];
  approvalsWhitelistUsername?: string[];
  blockOnOutdatedBranch?: boolean;
  blockOnRejectedReviews?: boolean;
  dismissStaleApprovals?: boolean;
  enableApprovalsWhitelist?: boolean;
  enableMergeWhitelist?: boolean;
  enablePush?: boolean;
  enablePushWhitelist?: boolean;
  enableStatusCheck?: boolean;
  mergeWhitelistTeams?: string[];
  mergeWhitelistUsernames?: string[];
  protectedFilePatterns?: string;
  pushWhitelistDeployKeys?: boolean;
  pushWhitelistTeams?: string[];
  pushWhitelistUsernames?: string[];
  requireSignedCommits?: boolean;
  requiredApprovals?: number;
  statusCheckContexts?: string[];
}

/**
 * EditDeadlineOption options for creating a deadline
 */
export interface EditDeadlineOption {
  dueDate: Date;
}

/**
 * EditGitHookOption options when modifying one Git hook
 */
export interface EditGitHookOption {
  content?: string;
}

/**
 * EditHookOption options when modify one hook
 */
export interface EditHookOption {
  active?: boolean;
  branchFilter?: string;
  config?: { [propertyName: string]: string };
  events?: string[];
}

/**
 * EditIssueCommentOption options for editing a comment
 */
export interface EditIssueCommentOption {
  body: string;
}

/**
 * EditIssueOption options for editing an issue
 */
export interface EditIssueOption {
  assignee?: string;
  assignees?: string[];
  body?: string;
  dueDate?: Date;
  milestone?: number;
  state?: string;
  title?: string;
  unsetDueDate?: boolean;
}

/**
 * EditLabelOption options for editing a label
 */
export interface EditLabelOption {
  color?: string;
  description?: string;
  name?: string;
}

/**
 * EditMilestoneOption options for editing a milestone
 */
export interface EditMilestoneOption {
  description?: string;
  dueOn?: Date;
  state?: string;
  title?: string;
}

/**
 * EditOrgOption options for editing an organization
 */
export interface EditOrgOption {
  description?: string;
  fullName?: string;
  location?: string;
  repoAdminChangeTeamAccess?: boolean;
  /**
   * possible values are `public`, `limited` or `private`. Possible values include: 'public',
   * 'limited', 'private'
   */
  visibility?: Visibility1;
  website?: string;
}

/**
 * EditPullRequestOption options when modify pull request
 */
export interface EditPullRequestOption {
  assignee?: string;
  assignees?: string[];
  body?: string;
  dueDate?: Date;
  labels?: number[];
  milestone?: number;
  state?: string;
  title?: string;
  unsetDueDate?: boolean;
}

/**
 * EditReactionOption contain the reaction type
 */
export interface EditReactionOption {
  content?: string;
}

/**
 * EditReleaseOption options when editing a release
 */
export interface EditReleaseOption {
  body?: string;
  draft?: boolean;
  name?: string;
  prerelease?: boolean;
  tagName?: string;
  targetCommitish?: string;
}

/**
 * EditRepoOption options when editing a repository's properties
 */
export interface EditRepoOption {
  /**
   * either `true` to allow merging pull requests with a merge commit, or `false` to prevent
   * merging pull requests with merge commits. `has_pull_requests` must be `true`.
   */
  allowMergeCommits?: boolean;
  /**
   * either `true` to allow rebase-merging pull requests, or `false` to prevent rebase-merging.
   * `has_pull_requests` must be `true`.
   */
  allowRebase?: boolean;
  /**
   * either `true` to allow rebase with explicit merge commits (--no-ff), or `false` to prevent
   * rebase with explicit merge commits. `has_pull_requests` must be `true`.
   */
  allowRebaseExplicit?: boolean;
  /**
   * either `true` to allow squash-merging pull requests, or `false` to prevent squash-merging.
   * `has_pull_requests` must be `true`.
   */
  allowSquashMerge?: boolean;
  /**
   * set to `true` to archive this repository.
   */
  archived?: boolean;
  /**
   * sets the default branch for this repository.
   */
  defaultBranch?: string;
  /**
   * a short description of the repository.
   */
  description?: string;
  externalTracker?: ExternalTracker;
  externalWiki?: ExternalWiki;
  /**
   * either `true` to enable issues for this repository or `false` to disable them.
   */
  hasIssues?: boolean;
  /**
   * either `true` to allow pull requests, or `false` to prevent pull request.
   */
  hasPullRequests?: boolean;
  /**
   * either `true` to enable the wiki for this repository or `false` to disable it.
   */
  hasWiki?: boolean;
  /**
   * either `true` to ignore whitespace for conflicts, or `false` to not ignore whitespace.
   * `has_pull_requests` must be `true`.
   */
  ignoreWhitespaceConflicts?: boolean;
  internalTracker?: InternalTracker;
  /**
   * name of the repository
   */
  name?: string;
  /**
   * either `true` to make the repository private or `false` to make it public.
   * Note: you will get a 422 error if the organization restricts changing repository visibility to
   * organization
   * owners and a non-owner tries to change the value of private.
   */
  privateProperty?: boolean;
  /**
   * either `true` to make this repository a template or `false` to make it a normal repository
   */
  template?: boolean;
  /**
   * a URL with more information about the repository.
   */
  website?: string;
}

/**
 * EditTeamOption options for editing a team
 */
export interface EditTeamOption {
  canCreateOrgRepo?: boolean;
  description?: string;
  includesAllRepositories?: boolean;
  name: string;
  /**
   * Possible values include: 'read', 'write', 'admin'
   */
  permission?: PermissionEnum1;
  units?: string[];
}

/**
 * EditUserOption edit user options
 */
export interface EditUserOption {
  active?: boolean;
  admin?: boolean;
  allowCreateOrganization?: boolean;
  allowGitHook?: boolean;
  allowImportLocal?: boolean;
  email: string;
  fullName?: string;
  location?: string;
  loginName?: string;
  maxRepoCreation?: number;
  mustChangePassword?: boolean;
  password?: string;
  prohibitLogin?: boolean;
  sourceId?: number;
  website?: string;
}

/**
 * Email an email address belonging to a user
 */
export interface Email {
  email?: string;
  primary?: boolean;
  verified?: boolean;
}

/**
 * An interface representing FileCommitResponse.
 * @summary FileCommitResponse contains information generated from a Git commit for a repo's file.
 */
export interface FileCommitResponse {
  author?: CommitUser;
  committer?: CommitUser;
  htmlUrl?: string;
  message?: string;
  parents?: CommitMeta[];
  sha?: string;
  tree?: CommitMeta;
  url?: string;
}

/**
 * FileDeleteResponse contains information about a repo's file that was deleted
 */
export interface FileDeleteResponse {
  commit?: FileCommitResponse;
  content?: any;
  verification?: PayloadCommitVerification;
}

/**
 * FileResponse contains information about a repo's file
 */
export interface FileResponse {
  commit?: FileCommitResponse;
  content?: ContentsResponse;
  verification?: PayloadCommitVerification;
}

/**
 * GPGKeyEmail an email attached to a GPGKey
 */
export interface GPGKeyEmail {
  email?: string;
  verified?: boolean;
}

/**
 * GPGKey a user GPG key to sign commit and tag in repository
 */
export interface GPGKey {
  canCertify?: boolean;
  canEncryptComms?: boolean;
  canEncryptStorage?: boolean;
  canSign?: boolean;
  createdAt?: Date;
  emails?: GPGKeyEmail[];
  expiresAt?: Date;
  id?: number;
  keyId?: string;
  primaryKeyId?: string;
  publicKey?: string;
  subkeys?: GPGKey[];
}

/**
 * GitBlobResponse represents a git blob
 */
export interface GitBlobResponse {
  content?: string;
  encoding?: string;
  sha?: string;
  size?: number;
  url?: string;
}

/**
 * GitEntry represents a git tree
 */
export interface GitEntry {
  mode?: string;
  path?: string;
  sha?: string;
  size?: number;
  type?: string;
  url?: string;
}

/**
 * GitHook represents a Git repository hook
 */
export interface GitHook {
  content?: string;
  isActive?: boolean;
  name?: string;
}

/**
 * An interface representing GitObject.
 * @summary GitObject represents a Git object.
 */
export interface GitObject {
  sha?: string;
  type?: string;
  url?: string;
}

/**
 * GitTreeResponse returns a git tree
 */
export interface GitTreeResponse {
  page?: number;
  sha?: string;
  totalCount?: number;
  tree?: GitEntry[];
  truncated?: boolean;
  url?: string;
}

/**
 * Hook a hook is a web hook when one repository changed
 */
export interface Hook {
  active?: boolean;
  config?: { [propertyName: string]: string };
  createdAt?: Date;
  events?: string[];
  id?: number;
  type?: string;
  updatedAt?: Date;
}

/**
 * Label a label to an issue or a pr
 */
export interface Label {
  color?: string;
  description?: string;
  id?: number;
  name?: string;
  url?: string;
}

/**
 * Milestone milestone is a collection of issues on one repository
 */
export interface Milestone {
  closedAt?: Date;
  closedIssues?: number;
  description?: string;
  dueOn?: Date;
  id?: number;
  openIssues?: number;
  state?: string;
  title?: string;
}

/**
 * PullRequestMeta PR info if an issue is a PR
 */
export interface PullRequestMeta {
  merged?: boolean;
  mergedAt?: Date;
}

/**
 * RepositoryMeta basic repository information
 */
export interface RepositoryMeta {
  fullName?: string;
  id?: number;
  name?: string;
  owner?: string;
}

/**
 * Issue represents an issue in a repository
 */
export interface Issue {
  assignee?: User;
  assignees?: User[];
  body?: string;
  closedAt?: Date;
  comments?: number;
  createdAt?: Date;
  dueDate?: Date;
  htmlUrl?: string;
  id?: number;
  labels?: Label[];
  milestone?: Milestone;
  number?: number;
  originalAuthor?: string;
  originalAuthorId?: number;
  pullRequest?: PullRequestMeta;
  repository?: RepositoryMeta;
  state?: string;
  title?: string;
  updatedAt?: Date;
  url?: string;
  user?: User;
}

/**
 * IssueDeadline represents an issue deadline
 */
export interface IssueDeadline {
  dueDate?: Date;
}

/**
 * IssueLabelsOption a collection of labels
 */
export interface IssueLabelsOption {
  /**
   * list of label IDs
   */
  labels?: number[];
}

/**
 * MarkdownOption markdown options
 */
export interface MarkdownOption {
  /**
   * Context to render
   *
   * in: body
   */
  context?: string;
  /**
   * Mode to render
   *
   * in: body
   */
  mode?: string;
  /**
   * Text markdown to render
   *
   * in: body
   */
  text?: string;
  /**
   * Is it a wiki page ?
   *
   * in: body
   */
  wiki?: boolean;
}

/**
 * MergePullRequestForm form for merging Pull Request
 */
export interface MergePullRequestOption {
  /**
   * Possible values include: 'merge', 'rebase', 'rebase-merge', 'squash'
   */
  doProperty: DoProperty;
  mergeMessageField?: string;
  mergeTitleField?: string;
  forceMerge?: boolean;
}

/**
 * MigrateRepoForm form for migrating repository
 */
export interface MigrateRepoForm {
  authPassword?: string;
  authUsername?: string;
  cloneAddr: string;
  description?: string;
  issues?: boolean;
  labels?: boolean;
  milestones?: boolean;
  mirror?: boolean;
  privateProperty?: boolean;
  pullRequests?: boolean;
  releases?: boolean;
  repoName: string;
  uid: number;
  wiki?: boolean;
}

/**
 * NotificationCount number of unread notifications
 */
export interface NotificationCount {
  newProperty?: number;
}

/**
 * NotificationSubject contains the notification subject (Issue/Pull/Commit)
 */
export interface NotificationSubject {
  latestCommentUrl?: string;
  title?: string;
  type?: string;
  url?: string;
}

/**
 * NotificationThread expose Notification on API
 */
export interface NotificationThread {
  id?: number;
  pinned?: boolean;
  repository?: Repository;
  subject?: NotificationSubject;
  unread?: boolean;
  updatedAt?: Date;
  url?: string;
}

/**
 * An interface representing OAuth2Application.
 * @summary OAuth2Application represents an OAuth2 application.
 */
export interface OAuth2Application {
  clientId?: string;
  clientSecret?: string;
  created?: Date;
  id?: number;
  name?: string;
  redirectUris?: string[];
}

/**
 * Organization represents an organization
 */
export interface Organization {
  avatarUrl?: string;
  description?: string;
  fullName?: string;
  id?: number;
  location?: string;
  repoAdminChangeTeamAccess?: boolean;
  username?: string;
  visibility?: string;
  website?: string;
}

/**
 * PRBranchInfo information about a branch
 */
export interface PRBranchInfo {
  label?: string;
  ref?: string;
  repo?: Repository;
  repoId?: number;
  sha?: string;
}

/**
 * PublicKey publickey is a user key to push code to repository
 */
export interface PublicKey {
  createdAt?: Date;
  fingerprint?: string;
  id?: number;
  key?: string;
  keyType?: string;
  readOnly?: boolean;
  title?: string;
  url?: string;
  user?: User;
}

/**
 * PullRequest represents a pull request
 */
export interface PullRequest {
  assignee?: User;
  assignees?: User[];
  base?: PRBranchInfo;
  body?: string;
  closedAt?: Date;
  comments?: number;
  createdAt?: Date;
  diffUrl?: string;
  dueDate?: Date;
  head?: PRBranchInfo;
  htmlUrl?: string;
  id?: number;
  labels?: Label[];
  mergeBase?: string;
  mergeCommitSha?: string;
  mergeable?: boolean;
  merged?: boolean;
  mergedAt?: Date;
  mergedBy?: User;
  milestone?: Milestone;
  number?: number;
  patchUrl?: string;
  state?: string;
  title?: string;
  updatedAt?: Date;
  url?: string;
  user?: User;
}

/**
 * PullReview represents a pull request review
 */
export interface PullReview {
  body?: string;
  commentsCount?: number;
  commitId?: string;
  htmlUrl?: string;
  id?: number;
  official?: boolean;
  pullRequestUrl?: string;
  stale?: boolean;
  state?: string;
  submittedAt?: Date;
  user?: User;
}

/**
 * PullReviewComment represents a comment on a pull request review
 */
export interface PullReviewComment {
  body?: string;
  commitId?: string;
  createdAt?: Date;
  diffHunk?: string;
  htmlUrl?: string;
  id?: number;
  originalCommitId?: string;
  originalPosition?: number;
  path?: string;
  position?: number;
  pullRequestReviewId?: number;
  pullRequestUrl?: string;
  updatedAt?: Date;
  user?: User;
}

/**
 * Reaction contain one reaction
 */
export interface Reaction {
  content?: string;
  createdAt?: Date;
  user?: User;
}

/**
 * An interface representing Reference.
 * @summary Reference represents a Git reference.
 */
export interface Reference {
  object?: GitObject;
  ref?: string;
  url?: string;
}

/**
 * Release represents a repository release
 */
export interface Release {
  assets?: Attachment[];
  author?: User;
  body?: string;
  createdAt?: Date;
  draft?: boolean;
  htmlUrl?: string;
  id?: number;
  name?: string;
  prerelease?: boolean;
  publishedAt?: Date;
  tagName?: string;
  tarballUrl?: string;
  targetCommitish?: string;
  url?: string;
  zipballUrl?: string;
}

/**
 * RepoTopicOptions a collection of repo topic names
 */
export interface RepoTopicOptions {
  /**
   * list of topic names
   */
  topics?: string[];
}

/**
 * SearchResults results of a successful search
 */
export interface SearchResults {
  data?: Repository[];
  ok?: boolean;
}

/**
 * ServerVersion wraps the version of the server
 */
export interface ServerVersion {
  version?: string;
}

/**
 * Status holds a single Status of a single Commit
 */
export interface Status {
  context?: string;
  createdAt?: Date;
  creator?: User;
  description?: string;
  id?: number;
  status?: string;
  targetUrl?: string;
  updatedAt?: Date;
  url?: string;
}

/**
 * StopWatch represent a running stopwatch
 */
export interface StopWatch {
  created?: Date;
  issueIndex?: number;
}

/**
 * SubmitPullReviewOptions are options to submit a pending pull review
 */
export interface SubmitPullReviewOptions {
  body?: string;
  event?: string;
}

/**
 * Tag represents a repository tag
 */
export interface Tag {
  commit?: CommitMeta;
  id?: string;
  name?: string;
  tarballUrl?: string;
  zipballUrl?: string;
}

/**
 * Team represents a team in an organization
 */
export interface Team {
  canCreateOrgRepo?: boolean;
  description?: string;
  id?: number;
  includesAllRepositories?: boolean;
  name?: string;
  organization?: Organization;
  /**
   * Possible values include: 'none', 'read', 'write', 'admin', 'owner'
   */
  permission?: PermissionEnum2;
  units?: string[];
}

/**
 * TopicName a list of repo topic names
 */
export interface TopicName {
  topics?: string[];
}

/**
 * TopicResponse for returning topics
 */
export interface TopicResponse {
  created?: Date;
  id?: number;
  repoCount?: number;
  topicName?: string;
  updated?: Date;
}

/**
 * TrackedTime worked time for an issue / pr
 */
export interface TrackedTime {
  created?: Date;
  id?: number;
  issue?: Issue;
  /**
   * deprecated (only for backwards compatibility)
   */
  issueId?: number;
  /**
   * Time in seconds
   */
  time?: number;
  /**
   * deprecated (only for backwards compatibility)
   */
  userId?: number;
  userName?: string;
}

/**
 * TransferRepoOption options when transfer a repository's ownership
 */
export interface TransferRepoOption {
  newOwner: string;
  /**
   * ID of the team or teams to add to the repository. Teams can only be added to
   * organization-owned repositories.
   */
  teamIds?: number[];
}

/**
 * UpdateFileOptions options for updating files
 * Note: `author` and `committer` are optional (if only one is given, it will be used for the
 * other, otherwise the authenticated user will be used)
 */
export interface UpdateFileOptions {
  author?: Identity;
  /**
   * branch (optional) to base this file from. if not given, the default branch is used
   */
  branch?: string;
  committer?: Identity;
  /**
   * content must be base64 encoded
   */
  content: string;
  dates?: CommitDateOptions;
  /**
   * from_path (optional) is the path of the original file which will be moved/renamed to the path
   * in the URL
   */
  fromPath?: string;
  /**
   * message (optional) for the commit of this file. if not supplied, a default message will be
   * used
   */
  message?: string;
  /**
   * new_branch (optional) will make a new branch from `branch` before creating the file
   */
  newBranch?: string;
  /**
   * sha is the SHA for the file that already exists
   */
  sha: string;
}

/**
 * UserHeatmapData represents the data needed to create a heatmap
 */
export interface UserHeatmapData {
  contributions?: number;
  timestamp?: number;
}

/**
 * WatchInfo represents an API watch status of one repository
 */
export interface WatchInfo {
  createdAt?: Date;
  ignored?: boolean;
  reason?: any;
  repositoryUrl?: string;
  subscribed?: boolean;
  url?: string;
}

/**
 * An interface representing TeamSearchOKResponse.
 */
export interface TeamSearchOKResponse {
  data?: Team[];
  ok?: boolean;
}

/**
 * An interface representing UserSearchOKResponse.
 */
export interface UserSearchOKResponse {
  data?: User[];
  ok?: boolean;
}

/**
 * An interface representing AccessTokenModel.
 */
export interface AccessTokenModel {
  name: string;
}

/**
 * An interface representing GiteaAPIOptions.
 */
export interface GiteaAPIOptions extends ServiceClientOptions {
  baseUri?: string;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIAdminGetAllOrgsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIAdminGetAllUsersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIAdminCreateUserOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateUserOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIAdminEditUserOptionalParams extends msRest.RequestOptionsBase {
  body?: EditUserOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIAdminCreatePublicKeyOptionalParams extends msRest.RequestOptionsBase {
  key?: CreateKeyOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRenderMarkdownOptionalParams extends msRest.RequestOptionsBase {
  body?: MarkdownOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPINotifyGetListOptionalParams extends msRest.RequestOptionsBase {
  /**
   * If true, show notifications marked as read. Default value is false
   */
  all?: string;
  /**
   * Only show notifications updated after the given time. This is a timestamp in RFC 3339 format
   */
  since?: Date;
  /**
   * Only show notifications updated before the given time. This is a timestamp in RFC 3339 format
   */
  before?: Date;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPINotifyReadListOptionalParams extends msRest.RequestOptionsBase {
  /**
   * Describes the last point that notifications were checked. Anything updated since this time
   * will not be updated.
   */
  lastReadAt?: Date;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPICreateOrgRepoDeprecatedOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateRepoOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgGetAllOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListHooksOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgEditHookOptionalParams extends msRest.RequestOptionsBase {
  body?: EditHookOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListLabelsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgCreateLabelOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateLabelOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgEditLabelOptionalParams extends msRest.RequestOptionsBase {
  body?: EditLabelOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListMembersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListPublicMembersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListReposOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPICreateOrgRepoOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateRepoOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListTeamsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgCreateTeamOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateTeamOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPITeamSearchOptionalParams extends msRest.RequestOptionsBase {
  /**
   * keywords to search
   */
  q?: string;
  /**
   * include search within team description (defaults to true)
   */
  includeDesc?: boolean;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueSearchIssuesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * whether issue is open or closed
   */
  state?: string;
  /**
   * comma separated list of labels. Fetch only issues that have any of this labels. Non existent
   * labels are discarded
   */
  labels?: string;
  /**
   * search string
   */
  q?: string;
  /**
   * repository to prioritize in the results
   */
  priorityRepoId?: number;
  /**
   * filter by type (issues / pulls) if set
   */
  type?: string;
  /**
   * page number of requested issues
   */
  page?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoMigrateOptionalParams extends msRest.RequestOptionsBase {
  body?: MigrateRepoForm;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoSearchOptionalParams extends msRest.RequestOptionsBase {
  /**
   * keyword
   */
  q?: string;
  /**
   * Limit search to repositories with keyword as topic
   */
  topic?: boolean;
  /**
   * include search of keyword within repository description
   */
  includeDesc?: boolean;
  /**
   * search only for repos that the user with the given id owns or contributes to
   */
  uid?: number;
  /**
   * repo owner to prioritize in the results
   */
  priorityOwnerId?: number;
  /**
   * search only for repos that the user with the given id has starred
   */
  starredBy?: number;
  /**
   * include private repositories this user has access to (defaults to true)
   */
  privateParameter?: boolean;
  /**
   * show only pubic, private or all repositories (defaults to all)
   */
  isPrivate?: boolean;
  /**
   * include template repositories this user has access to (defaults to true)
   */
  template?: boolean;
  /**
   * show only archived, non-archived or all repositories (defaults to all)
   */
  archived?: boolean;
  /**
   * type of repository to search for. Supported values are "fork", "source", "mirror" and
   * "collaborative"
   */
  mode?: string;
  /**
   * if `uid` is given, search only for repos that the user owns
   */
  exclusive?: boolean;
  /**
   * sort repos by attribute. Supported values are "alpha", "created", "updated", "size", and "id".
   * Default is "alpha"
   */
  sort?: string;
  /**
   * sort order, either "asc" (ascending) or "desc" (descending). Default is "asc", ignored if
   * "sort" is not specified.
   */
  order?: string;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoEditOptionalParams extends msRest.RequestOptionsBase {
  /**
   * Properties of a repo that you can edit
   */
  body?: EditRepoOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoCreateBranchProtectionOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateBranchProtectionOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoEditBranchProtectionOptionalParams extends msRest.RequestOptionsBase {
  body?: EditBranchProtectionOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListCollaboratorsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoAddCollaboratorOptionalParams extends msRest.RequestOptionsBase {
  body?: AddCollaboratorOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoGetAllCommitsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * SHA or branch to start listing commits from (usually 'master')
   */
  sha?: string;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoGetCombinedStatusByRefOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results
   */
  page?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoGetContentsListOptionalParams extends msRest.RequestOptionsBase {
  /**
   * The name of the commit/branch/tag. Default the repository’s default branch (usually master)
   */
  ref?: string;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoGetContentsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * The name of the commit/branch/tag. Default the repository’s default branch (usually master)
   */
  ref?: string;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIListForksOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPICreateForkOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateForkOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIGetTreeOptionalParams extends msRest.RequestOptionsBase {
  /**
   * show all directories and files
   */
  recursive?: boolean;
  /**
   * page number; the 'truncated' field in the response will be true if there are still more items
   * after this page, false if the last page
   */
  page?: number;
  /**
   * number of items per page; default is 1000 or what is set in app.ini as
   * DEFAULT_GIT_TREES_PER_PAGE
   */
  perPage?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListHooksOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoCreateHookOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateHookOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoEditGitHookOptionalParams extends msRest.RequestOptionsBase {
  body?: EditGitHookOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoEditHookOptionalParams extends msRest.RequestOptionsBase {
  body?: EditHookOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueListIssuesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * whether issue is open or closed
   */
  state?: string;
  /**
   * comma separated list of labels. Fetch only issues that have any of this labels. Non existent
   * labels are discarded
   */
  labels?: string;
  /**
   * search string
   */
  q?: string;
  /**
   * filter by type (issues / pulls) if set
   */
  type?: string;
  /**
   * comma separated list of milestone names or ids. It uses names and fall back to ids. Fetch only
   * issues that have any of this milestones. Non existent milestones are discarded
   */
  milestones?: string;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueCreateIssueOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateIssueOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueGetRepoCommentsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * if provided, only comments updated since the provided time are returned.
   */
  since?: Date;
  /**
   * if provided, only comments updated before the provided time are returned.
   */
  before?: Date;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueEditCommentOptionalParams extends msRest.RequestOptionsBase {
  body?: EditIssueCommentOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssuePostCommentReactionOptionalParams extends msRest.RequestOptionsBase {
  content?: EditReactionOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueDeleteCommentReactionOptionalParams extends msRest.RequestOptionsBase {
  content?: EditReactionOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueEditIssueOptionalParams extends msRest.RequestOptionsBase {
  body?: EditIssueOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueGetCommentsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * if provided, only comments updated since the specified time are returned.
   */
  since?: Date;
  /**
   * if provided, only comments updated before the provided time are returned.
   */
  before?: Date;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueCreateCommentOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateIssueCommentOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueEditCommentDeprecatedOptionalParams extends msRest.RequestOptionsBase {
  body?: EditIssueCommentOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueEditIssueDeadlineOptionalParams extends msRest.RequestOptionsBase {
  body?: EditDeadlineOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueReplaceLabelsOptionalParams extends msRest.RequestOptionsBase {
  body?: IssueLabelsOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueAddLabelOptionalParams extends msRest.RequestOptionsBase {
  body?: IssueLabelsOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueGetIssueReactionsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssuePostIssueReactionOptionalParams extends msRest.RequestOptionsBase {
  content?: EditReactionOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueDeleteIssueReactionOptionalParams extends msRest.RequestOptionsBase {
  content?: EditReactionOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueSubscriptionsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueTrackedTimesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * Only show times updated after the given time. This is a timestamp in RFC 3339 format
   */
  since?: Date;
  /**
   * Only show times updated before the given time. This is a timestamp in RFC 3339 format
   */
  before?: Date;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueAddTimeOptionalParams extends msRest.RequestOptionsBase {
  body?: AddTimeOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListKeysOptionalParams extends msRest.RequestOptionsBase {
  /**
   * the key_id to search for
   */
  keyId?: number;
  /**
   * fingerprint of the key
   */
  fingerprint?: string;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoCreateKeyOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateKeyOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueListLabelsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueCreateLabelOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateLabelOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueEditLabelOptionalParams extends msRest.RequestOptionsBase {
  body?: EditLabelOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueGetMilestonesListOptionalParams extends msRest.RequestOptionsBase {
  /**
   * Milestone state, Recognised values are open, closed and all. Defaults to "open"
   */
  state?: string;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueCreateMilestoneOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateMilestoneOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIIssueEditMilestoneOptionalParams extends msRest.RequestOptionsBase {
  body?: EditMilestoneOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPINotifyGetRepoListOptionalParams extends msRest.RequestOptionsBase {
  /**
   * If true, show notifications marked as read. Default value is false
   */
  all?: string;
  /**
   * Only show notifications updated after the given time. This is a timestamp in RFC 3339 format
   */
  since?: Date;
  /**
   * Only show notifications updated before the given time. This is a timestamp in RFC 3339 format
   */
  before?: Date;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPINotifyReadRepoListOptionalParams extends msRest.RequestOptionsBase {
  /**
   * Describes the last point that notifications were checked. Anything updated since this time
   * will not be updated.
   */
  lastReadAt?: Date;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListPullRequestsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * State of pull request: open or closed (optional). Possible values include: 'closed', 'open',
   * 'all'
   */
  state?: State;
  /**
   * Type of sort. Possible values include: 'oldest', 'recentupdate', 'leastupdate', 'mostcomment',
   * 'leastcomment', 'priority'
   */
  sort?: Sort;
  /**
   * ID of the milestone
   */
  milestone?: number;
  /**
   * Label IDs
   */
  labels?: number[];
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoCreatePullRequestOptionalParams extends msRest.RequestOptionsBase {
  body?: CreatePullRequestOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoEditPullRequestOptionalParams extends msRest.RequestOptionsBase {
  body?: EditPullRequestOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoMergePullRequestOptionalParams extends msRest.RequestOptionsBase {
  body?: MergePullRequestOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListPullReviewsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListReleasesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * items count every page wants to load
   */
  perPage?: number;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoCreateReleaseOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateReleaseOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoEditReleaseOptionalParams extends msRest.RequestOptionsBase {
  body?: EditReleaseOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoCreateReleaseAttachmentOptionalParams extends msRest.RequestOptionsBase {
  /**
   * name of the attachment
   */
  name?: string;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoEditReleaseAttachmentOptionalParams extends msRest.RequestOptionsBase {
  body?: EditAttachmentOptions;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListStargazersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListStatusesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * type of sort. Possible values include: 'oldest', 'recentupdate', 'leastupdate', 'leastindex',
   * 'highestindex'
   */
  sort?: Sort1;
  /**
   * type of state. Possible values include: 'pending', 'success', 'error', 'failure', 'warning'
   */
  state?: State1;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoCreateStatusOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateStatusOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListSubscribersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListTagsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, default maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoTrackedTimesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * optional filter by user
   */
  user?: string;
  /**
   * Only show times updated after the given time. This is a timestamp in RFC 3339 format
   */
  since?: Date;
  /**
   * Only show times updated before the given time. This is a timestamp in RFC 3339 format
   */
  before?: Date;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoListTopicsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIRepoUpdateTopicsOptionalParams extends msRest.RequestOptionsBase {
  body?: RepoTopicOptions;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgEditTeamOptionalParams extends msRest.RequestOptionsBase {
  body?: EditTeamOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListTeamMembersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListTeamReposOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPITopicSearchOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserGetOauth2ApplicationOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserAddEmailOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateEmailOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserDeleteEmailOptionalParams extends msRest.RequestOptionsBase {
  body?: DeleteEmailOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentListFollowersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentListFollowingOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentListGPGKeysOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentPostGPGKeyOptionalParams extends msRest.RequestOptionsBase {
  form?: CreateGPGKeyOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentListKeysOptionalParams extends msRest.RequestOptionsBase {
  /**
   * fingerprint of the key
   */
  fingerprint?: string;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentPostKeyOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateKeyOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListCurrentUserOrgsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentListReposOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPICreateCurrentUserRepoOptionalParams extends msRest.RequestOptionsBase {
  body?: CreateRepoOption;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentListStarredOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserGetStopWatchesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentListSubscriptionsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListTeamsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCurrentTrackedTimesOptionalParams extends msRest.RequestOptionsBase {
  /**
   * Only show times updated after the given time. This is a timestamp in RFC 3339 format
   */
  since?: Date;
  /**
   * Only show times updated before the given time. This is a timestamp in RFC 3339 format
   */
  before?: Date;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserSearchOptionalParams extends msRest.RequestOptionsBase {
  /**
   * keyword
   */
  q?: string;
  /**
   * ID of the user to search for
   */
  uid?: number;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListFollowersOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListFollowingOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListGPGKeysOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListKeysOptionalParams extends msRest.RequestOptionsBase {
  /**
   * fingerprint of the key
   */
  fingerprint?: string;
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIOrgListUserOrgsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListReposOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListStarredOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserListSubscriptionsOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserGetTokensOptionalParams extends msRest.RequestOptionsBase {
  /**
   * page number of results to return (1-based)
   */
  page?: number;
  /**
   * page size of results, maximum page size is 50
   */
  limit?: number;
}

/**
 * Optional Parameters.
 */
export interface GiteaAPIUserCreateTokenOptionalParams extends msRest.RequestOptionsBase {
  accessToken?: AccessTokenModel;
}

/**
 * Defines headers for adminGetAllOrgs operation.
 */
export interface AdminGetAllOrgsHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for adminGetAllUsers operation.
 */
export interface AdminGetAllUsersHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for adminCreateUser operation.
 */
export interface AdminCreateUserHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for adminDeleteUser operation.
 */
export interface AdminDeleteUserHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for adminEditUser operation.
 */
export interface AdminEditUserHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for adminCreatePublicKey operation.
 */
export interface AdminCreatePublicKeyHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for adminDeleteUserPublicKey operation.
 */
export interface AdminDeleteUserPublicKeyHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for adminCreateOrg operation.
 */
export interface AdminCreateOrgHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for adminCreateRepo operation.
 */
export interface AdminCreateRepoHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for renderMarkdown operation.
 */
export interface RenderMarkdownHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for renderMarkdownRaw operation.
 */
export interface RenderMarkdownRawHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for notifyGetThread operation.
 */
export interface NotifyGetThreadHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for notifyReadThread operation.
 */
export interface NotifyReadThreadHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for createOrgRepoDeprecated operation.
 */
export interface CreateOrgRepoDeprecatedHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for orgCreate operation.
 */
export interface OrgCreateHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for orgCreateLabel operation.
 */
export interface OrgCreateLabelHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for orgEditLabel operation.
 */
export interface OrgEditLabelHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for orgPublicizeMember operation.
 */
export interface OrgPublicizeMemberHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for orgConcealMember operation.
 */
export interface OrgConcealMemberHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for createOrgRepo operation.
 */
export interface CreateOrgRepoHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for orgCreateTeam operation.
 */
export interface OrgCreateTeamHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoMigrate operation.
 */
export interface RepoMigrateHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoSearch operation.
 */
export interface RepoSearchHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoDelete operation.
 */
export interface RepoDeleteHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoEdit operation.
 */
export interface RepoEditHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoCreateBranchProtection operation.
 */
export interface RepoCreateBranchProtectionHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoEditBranchProtection operation.
 */
export interface RepoEditBranchProtectionHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoDeleteBranch operation.
 */
export interface RepoDeleteBranchHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoCheckCollaborator operation.
 */
export interface RepoCheckCollaboratorHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoAddCollaborator operation.
 */
export interface RepoAddCollaboratorHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoDeleteCollaborator operation.
 */
export interface RepoDeleteCollaboratorHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoGetAllCommits operation.
 */
export interface RepoGetAllCommitsHeaders {
  /**
   * True if there is another page
   */
  xHasMore: boolean;
  /**
   * The current page
   */
  xPage: number;
  /**
   * Total number of pages
   */
  xPageCount: number;
  /**
   * Commits per page
   */
  xPerPage: number;
  /**
   * Total commit count
   */
  xTotal: number;
}

/**
 * Defines headers for repoGetCombinedStatusByRef operation.
 */
export interface RepoGetCombinedStatusByRefHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoDeleteFile operation.
 */
export interface RepoDeleteFileHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for createFork operation.
 */
export interface CreateForkHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for GetBlob operation.
 */
export interface GetBlobHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoGetSingleCommit operation.
 */
export interface RepoGetSingleCommitHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for GetTag operation.
 */
export interface GetTagHeaders {
  messageHeader: string;
  urlHeader: string;
}

/**
 * Defines headers for GetTree operation.
 */
export interface GetTreeHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for issueCreateIssue operation.
 */
export interface IssueCreateIssueHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for issueGetComment operation.
 */
export interface IssueGetCommentHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueDeleteComment operation.
 */
export interface IssueDeleteCommentHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueEditComment operation.
 */
export interface IssueEditCommentHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueGetCommentReactions operation.
 */
export interface IssueGetCommentReactionsHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issuePostCommentReaction operation.
 */
export interface IssuePostCommentReactionHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueDeleteCommentReaction operation.
 */
export interface IssueDeleteCommentReactionHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueEditIssue operation.
 */
export interface IssueEditIssueHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for issueCreateComment operation.
 */
export interface IssueCreateCommentHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueDeleteCommentDeprecated operation.
 */
export interface IssueDeleteCommentDeprecatedHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueEditCommentDeprecated operation.
 */
export interface IssueEditCommentDeprecatedHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueEditIssueDeadline operation.
 */
export interface IssueEditIssueDeadlineHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueReplaceLabels operation.
 */
export interface IssueReplaceLabelsHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueAddLabel operation.
 */
export interface IssueAddLabelHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueClearLabels operation.
 */
export interface IssueClearLabelsHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueRemoveLabel operation.
 */
export interface IssueRemoveLabelHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueGetIssueReactions operation.
 */
export interface IssueGetIssueReactionsHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issuePostIssueReaction operation.
 */
export interface IssuePostIssueReactionHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueDeleteIssueReaction operation.
 */
export interface IssueDeleteIssueReactionHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueAddTime operation.
 */
export interface IssueAddTimeHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueResetTime operation.
 */
export interface IssueResetTimeHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueDeleteTime operation.
 */
export interface IssueDeleteTimeHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoCreateKey operation.
 */
export interface RepoCreateKeyHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoDeleteKey operation.
 */
export interface RepoDeleteKeyHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for issueCreateLabel operation.
 */
export interface IssueCreateLabelHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for issueEditLabel operation.
 */
export interface IssueEditLabelHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoMirrorSync operation.
 */
export interface RepoMirrorSyncHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoCreatePullRequest operation.
 */
export interface RepoCreatePullRequestHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoEditPullRequest operation.
 */
export interface RepoEditPullRequestHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoMergePullRequest operation.
 */
export interface RepoMergePullRequestHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoCreatePullReview operation.
 */
export interface RepoCreatePullReviewHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoSubmitPullReview operation.
 */
export interface RepoSubmitPullReviewHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoDeletePullReview operation.
 */
export interface RepoDeletePullReviewHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoCreateRelease operation.
 */
export interface RepoCreateReleaseHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoCreateReleaseAttachment operation.
 */
export interface RepoCreateReleaseAttachmentHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoListStatuses operation.
 */
export interface RepoListStatusesHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoCreateStatus operation.
 */
export interface RepoCreateStatusHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for repoTrackedTimes operation.
 */
export interface RepoTrackedTimesHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for userTrackedTimes operation.
 */
export interface UserTrackedTimesHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for repoUpdateTopics operation.
 */
export interface RepoUpdateTopicsHeaders {
  invalidTopics: string[];
  message: string;
}

/**
 * Defines headers for repoAddTopíc operation.
 */
export interface RepoAddTopícHeaders {
  invalidTopics: string[];
  message: string;
}

/**
 * Defines headers for repoDeleteTopic operation.
 */
export interface RepoDeleteTopicHeaders {
  invalidTopics: string[];
  message: string;
}

/**
 * Defines headers for repoTransfer operation.
 */
export interface RepoTransferHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for orgAddTeamRepository operation.
 */
export interface OrgAddTeamRepositoryHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for orgRemoveTeamRepository operation.
 */
export interface OrgRemoveTeamRepositoryHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for topicSearch operation.
 */
export interface TopicSearchHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for userAddEmail operation.
 */
export interface UserAddEmailHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for userCurrentPostGPGKey operation.
 */
export interface UserCurrentPostGPGKeyHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for userCurrentDeleteGPGKey operation.
 */
export interface UserCurrentDeleteGPGKeyHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for userCurrentPostKey operation.
 */
export interface UserCurrentPostKeyHeaders {
  message: string;
  urlHeader: string;
}

/**
 * Defines headers for userCurrentDeleteKey operation.
 */
export interface UserCurrentDeleteKeyHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for createCurrentUserRepo operation.
 */
export interface CreateCurrentUserRepoHeaders {
  message: string;
  url: string;
}

/**
 * Defines headers for userCreateToken operation.
 */
export interface UserCreateTokenHeaders {
  id: number;
  name: string;
  sha1: string;
  tokenLastEight: string;
}

/**
 * Defines values for Type.
 * Possible values include: 'dingtalk', 'discord', 'gitea', 'gogs', 'msteams', 'slack', 'telegram',
 * 'feishu'
 * @readonly
 * @enum {string}
 */
export type Type = 'dingtalk' | 'discord' | 'gitea' | 'gogs' | 'msteams' | 'slack' | 'telegram' | 'feishu';

/**
 * Defines values for Visibility.
 * Possible values include: 'public', 'limited', 'private'
 * @readonly
 * @enum {string}
 */
export type Visibility = 'public' | 'limited' | 'private';

/**
 * Defines values for PermissionEnum.
 * Possible values include: 'read', 'write', 'admin'
 * @readonly
 * @enum {string}
 */
export type PermissionEnum = 'read' | 'write' | 'admin';

/**
 * Defines values for Visibility1.
 * Possible values include: 'public', 'limited', 'private'
 * @readonly
 * @enum {string}
 */
export type Visibility1 = 'public' | 'limited' | 'private';

/**
 * Defines values for PermissionEnum1.
 * Possible values include: 'read', 'write', 'admin'
 * @readonly
 * @enum {string}
 */
export type PermissionEnum1 = 'read' | 'write' | 'admin';

/**
 * Defines values for DoProperty.
 * Possible values include: 'merge', 'rebase', 'rebase-merge', 'squash'
 * @readonly
 * @enum {string}
 */
export type DoProperty = 'merge' | 'rebase' | 'rebase-merge' | 'squash';

/**
 * Defines values for PermissionEnum2.
 * Possible values include: 'none', 'read', 'write', 'admin', 'owner'
 * @readonly
 * @enum {string}
 */
export type PermissionEnum2 = 'none' | 'read' | 'write' | 'admin' | 'owner';

/**
 * Defines values for State.
 * Possible values include: 'closed', 'open', 'all'
 * @readonly
 * @enum {string}
 */
export type State = 'closed' | 'open' | 'all';

/**
 * Defines values for Sort.
 * Possible values include: 'oldest', 'recentupdate', 'leastupdate', 'mostcomment', 'leastcomment',
 * 'priority'
 * @readonly
 * @enum {string}
 */
export type Sort = 'oldest' | 'recentupdate' | 'leastupdate' | 'mostcomment' | 'leastcomment' | 'priority';

/**
 * Defines values for Sort1.
 * Possible values include: 'oldest', 'recentupdate', 'leastupdate', 'leastindex', 'highestindex'
 * @readonly
 * @enum {string}
 */
export type Sort1 = 'oldest' | 'recentupdate' | 'leastupdate' | 'leastindex' | 'highestindex';

/**
 * Defines values for State1.
 * Possible values include: 'pending', 'success', 'error', 'failure', 'warning'
 * @readonly
 * @enum {string}
 */
export type State1 = 'pending' | 'success' | 'error' | 'failure' | 'warning';

/**
 * Contains response data for the adminGetAllOrgs operation.
 */
export type AdminGetAllOrgsResponse = Array<Organization> & AdminGetAllOrgsHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminGetAllOrgsHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization[];
    };
};

/**
 * Contains response data for the adminGetAllUsers operation.
 */
export type AdminGetAllUsersResponse = Array<User> & AdminGetAllUsersHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminGetAllUsersHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the adminCreateUser operation.
 */
export type AdminCreateUserResponse = User & AdminCreateUserHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminCreateUserHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User;
    };
};

/**
 * Contains response data for the adminDeleteUser operation.
 */
export type AdminDeleteUserResponse = AdminDeleteUserHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminDeleteUserHeaders;
    };
};

/**
 * Contains response data for the adminEditUser operation.
 */
export type AdminEditUserResponse = User & AdminEditUserHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminEditUserHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User;
    };
};

/**
 * Contains response data for the adminCreatePublicKey operation.
 */
export type AdminCreatePublicKeyResponse = PublicKey & AdminCreatePublicKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminCreatePublicKeyHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PublicKey;
    };
};

/**
 * Contains response data for the adminDeleteUserPublicKey operation.
 */
export type AdminDeleteUserPublicKeyResponse = AdminDeleteUserPublicKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminDeleteUserPublicKeyHeaders;
    };
};

/**
 * Contains response data for the adminCreateOrg operation.
 */
export type AdminCreateOrgResponse = Organization & AdminCreateOrgHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminCreateOrgHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization;
    };
};

/**
 * Contains response data for the adminCreateRepo operation.
 */
export type AdminCreateRepoResponse = Repository & AdminCreateRepoHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: AdminCreateRepoHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the renderMarkdown operation.
 */
export type RenderMarkdownResponse = RenderMarkdownHeaders & {
  /**
   * The parsed response body.
   */
  body: string;

  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RenderMarkdownHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: string;
    };
};

/**
 * Contains response data for the renderMarkdownRaw operation.
 */
export type RenderMarkdownRawResponse = RenderMarkdownRawHeaders & {
  /**
   * The parsed response body.
   */
  body: string;

  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RenderMarkdownRawHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: string;
    };
};

/**
 * Contains response data for the notifyGetList operation.
 */
export type NotifyGetListResponse = Array<NotificationThread> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: NotificationThread[];
    };
};

/**
 * Contains response data for the notifyNewAvailable operation.
 */
export type NotifyNewAvailableResponse = NotificationCount & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: NotificationCount;
    };
};

/**
 * Contains response data for the notifyGetThread operation.
 */
export type NotifyGetThreadResponse = NotificationThread & NotifyGetThreadHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: NotifyGetThreadHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: NotificationThread;
    };
};

/**
 * Contains response data for the notifyReadThread operation.
 */
export type NotifyReadThreadResponse = NotifyReadThreadHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: NotifyReadThreadHeaders;
    };
};

/**
 * Contains response data for the createOrgRepoDeprecated operation.
 */
export type CreateOrgRepoDeprecatedResponse = Repository & CreateOrgRepoDeprecatedHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: CreateOrgRepoDeprecatedHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the orgGetAll operation.
 */
export type OrgGetAllResponse = Array<Organization> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization[];
    };
};

/**
 * Contains response data for the orgCreate operation.
 */
export type OrgCreateResponse = Organization & OrgCreateHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgCreateHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization;
    };
};

/**
 * Contains response data for the orgGet operation.
 */
export type OrgGetResponse = Organization & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization;
    };
};

/**
 * Contains response data for the orgEdit operation.
 */
export type OrgEditResponse = Organization & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization;
    };
};

/**
 * Contains response data for the orgListHooks operation.
 */
export type OrgListHooksResponse = Array<Hook> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook[];
    };
};

/**
 * Contains response data for the orgCreateHook operation.
 */
export type OrgCreateHookResponse = Hook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook;
    };
};

/**
 * Contains response data for the orgGetHook operation.
 */
export type OrgGetHookResponse = Hook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook;
    };
};

/**
 * Contains response data for the orgEditHook operation.
 */
export type OrgEditHookResponse = Hook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook;
    };
};

/**
 * Contains response data for the orgListLabels operation.
 */
export type OrgListLabelsResponse = Array<Label> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label[];
    };
};

/**
 * Contains response data for the orgCreateLabel operation.
 */
export type OrgCreateLabelResponse = Label & OrgCreateLabelHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgCreateLabelHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label;
    };
};

/**
 * Contains response data for the orgGetLabel operation.
 */
export type OrgGetLabelResponse = Label & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label;
    };
};

/**
 * Contains response data for the orgEditLabel operation.
 */
export type OrgEditLabelResponse = Label & OrgEditLabelHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgEditLabelHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label;
    };
};

/**
 * Contains response data for the orgListMembers operation.
 */
export type OrgListMembersResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the orgListPublicMembers operation.
 */
export type OrgListPublicMembersResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the orgPublicizeMember operation.
 */
export type OrgPublicizeMemberResponse = OrgPublicizeMemberHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgPublicizeMemberHeaders;
    };
};

/**
 * Contains response data for the orgConcealMember operation.
 */
export type OrgConcealMemberResponse = OrgConcealMemberHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgConcealMemberHeaders;
    };
};

/**
 * Contains response data for the orgListRepos operation.
 */
export type OrgListReposResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the createOrgRepo operation.
 */
export type CreateOrgRepoResponse = Repository & CreateOrgRepoHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: CreateOrgRepoHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the orgListTeams operation.
 */
export type OrgListTeamsResponse = Array<Team> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Team[];
    };
};

/**
 * Contains response data for the orgCreateTeam operation.
 */
export type OrgCreateTeamResponse = Team & OrgCreateTeamHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgCreateTeamHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Team;
    };
};

/**
 * Contains response data for the teamSearch operation.
 */
export type TeamSearchResponse = TeamSearchOKResponse & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TeamSearchOKResponse;
    };
};

/**
 * Contains response data for the issueSearchIssues operation.
 */
export type IssueSearchIssuesResponse = Array<Issue> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Issue[];
    };
};

/**
 * Contains response data for the repoMigrate operation.
 */
export type RepoMigrateResponse = Repository & RepoMigrateHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoMigrateHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the repoSearch operation.
 */
export type RepoSearchResponse = SearchResults & RepoSearchHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoSearchHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: SearchResults;
    };
};

/**
 * Contains response data for the repoGet operation.
 */
export type RepoGetResponse = Repository & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the repoDelete operation.
 */
export type RepoDeleteResponse = RepoDeleteHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoDeleteHeaders;
    };
};

/**
 * Contains response data for the repoEdit operation.
 */
export type RepoEditResponse = Repository & RepoEditHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoEditHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the repoListBranchProtection operation.
 */
export type RepoListBranchProtectionResponse = Array<BranchProtection> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: BranchProtection[];
    };
};

/**
 * Contains response data for the repoCreateBranchProtection operation.
 */
export type RepoCreateBranchProtectionResponse = BranchProtection & RepoCreateBranchProtectionHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCreateBranchProtectionHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: BranchProtection;
    };
};

/**
 * Contains response data for the repoGetBranchProtection operation.
 */
export type RepoGetBranchProtectionResponse = BranchProtection & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: BranchProtection;
    };
};

/**
 * Contains response data for the repoEditBranchProtection operation.
 */
export type RepoEditBranchProtectionResponse = BranchProtection & RepoEditBranchProtectionHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoEditBranchProtectionHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: BranchProtection;
    };
};

/**
 * Contains response data for the repoListBranches operation.
 */
export type RepoListBranchesResponse = Array<Branch> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Branch[];
    };
};

/**
 * Contains response data for the repoGetBranch operation.
 */
export type RepoGetBranchResponse = Branch & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Branch;
    };
};

/**
 * Contains response data for the repoDeleteBranch operation.
 */
export type RepoDeleteBranchResponse = RepoDeleteBranchHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoDeleteBranchHeaders;
    };
};

/**
 * Contains response data for the repoListCollaborators operation.
 */
export type RepoListCollaboratorsResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the repoCheckCollaborator operation.
 */
export type RepoCheckCollaboratorResponse = RepoCheckCollaboratorHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCheckCollaboratorHeaders;
    };
};

/**
 * Contains response data for the repoAddCollaborator operation.
 */
export type RepoAddCollaboratorResponse = RepoAddCollaboratorHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoAddCollaboratorHeaders;
    };
};

/**
 * Contains response data for the repoDeleteCollaborator operation.
 */
export type RepoDeleteCollaboratorResponse = RepoDeleteCollaboratorHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoDeleteCollaboratorHeaders;
    };
};

/**
 * Contains response data for the repoGetAllCommits operation.
 */
export type RepoGetAllCommitsResponse = RepoGetAllCommitsHeaders & {
  /**
   * The parsed response body.
   */
  body: any;

  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoGetAllCommitsHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: any;
    };
};

/**
 * Contains response data for the repoGetCombinedStatusByRef operation.
 */
export type RepoGetCombinedStatusByRefResponse = Status & RepoGetCombinedStatusByRefHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoGetCombinedStatusByRefHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Status;
    };
};

/**
 * Contains response data for the repoGetContentsList operation.
 */
export type RepoGetContentsListResponse = Array<ContentsResponse> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: ContentsResponse[];
    };
};

/**
 * Contains response data for the repoGetContents operation.
 */
export type RepoGetContentsResponse = ContentsResponse & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: ContentsResponse;
    };
};

/**
 * Contains response data for the repoUpdateFile operation.
 */
export type RepoUpdateFileResponse = FileResponse & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: FileResponse;
    };
};

/**
 * Contains response data for the repoCreateFile operation.
 */
export type RepoCreateFileResponse = FileResponse & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: FileResponse;
    };
};

/**
 * Contains response data for the repoDeleteFile operation.
 */
export type RepoDeleteFileResponse = FileDeleteResponse & RepoDeleteFileHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoDeleteFileHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: FileDeleteResponse;
    };
};

/**
 * Contains response data for the listForks operation.
 */
export type ListForksResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the createFork operation.
 */
export type CreateForkResponse = Repository & CreateForkHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: CreateForkHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the getBlob operation.
 */
export type GetBlobResponse = GitBlobResponse & GetBlobHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: GetBlobHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GitBlobResponse;
    };
};

/**
 * Contains response data for the repoGetSingleCommit operation.
 */
export type RepoGetSingleCommitResponse = Commit & RepoGetSingleCommitHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoGetSingleCommitHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Commit;
    };
};

/**
 * Contains response data for the repoListAllGitRefs operation.
 */
export type RepoListAllGitRefsResponse = Array<Reference> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Reference[];
    };
};

/**
 * Contains response data for the repoListGitRefs operation.
 */
export type RepoListGitRefsResponse = Array<Reference> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Reference[];
    };
};

/**
 * Contains response data for the getTag operation.
 */
export type GetTagResponse = AnnotatedTag & GetTagHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: GetTagHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: AnnotatedTag;
    };
};

/**
 * Contains response data for the getTree operation.
 */
export type GetTreeResponse = GitTreeResponse & GetTreeHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: GetTreeHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GitTreeResponse;
    };
};

/**
 * Contains response data for the repoListHooks operation.
 */
export type RepoListHooksResponse = Array<Hook> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook[];
    };
};

/**
 * Contains response data for the repoCreateHook operation.
 */
export type RepoCreateHookResponse = Hook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook;
    };
};

/**
 * Contains response data for the repoListGitHooks operation.
 */
export type RepoListGitHooksResponse = Array<GitHook> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GitHook[];
    };
};

/**
 * Contains response data for the repoGetGitHook operation.
 */
export type RepoGetGitHookResponse = GitHook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GitHook;
    };
};

/**
 * Contains response data for the repoEditGitHook operation.
 */
export type RepoEditGitHookResponse = GitHook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GitHook;
    };
};

/**
 * Contains response data for the repoGetHook operation.
 */
export type RepoGetHookResponse = Hook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook;
    };
};

/**
 * Contains response data for the repoEditHook operation.
 */
export type RepoEditHookResponse = Hook & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Hook;
    };
};

/**
 * Contains response data for the issueListIssues operation.
 */
export type IssueListIssuesResponse = Array<Issue> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Issue[];
    };
};

/**
 * Contains response data for the issueCreateIssue operation.
 */
export type IssueCreateIssueResponse = Issue & IssueCreateIssueHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueCreateIssueHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Issue;
    };
};

/**
 * Contains response data for the issueGetRepoComments operation.
 */
export type IssueGetRepoCommentsResponse = Array<Comment> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Comment[];
    };
};

/**
 * Contains response data for the issueGetComment operation.
 */
export type IssueGetCommentResponse = Comment & IssueGetCommentHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueGetCommentHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Comment;
    };
};

/**
 * Contains response data for the issueDeleteComment operation.
 */
export type IssueDeleteCommentResponse = IssueDeleteCommentHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueDeleteCommentHeaders;
    };
};

/**
 * Contains response data for the issueEditComment operation.
 */
export type IssueEditCommentResponse = Comment & IssueEditCommentHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueEditCommentHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Comment;
    };
};

/**
 * Contains response data for the issueGetCommentReactions operation.
 */
export type IssueGetCommentReactionsResponse = Array<Reaction> & IssueGetCommentReactionsHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueGetCommentReactionsHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Reaction[];
    };
};

/**
 * Contains response data for the issuePostCommentReaction operation.
 */
export type IssuePostCommentReactionResponse = Reaction & IssuePostCommentReactionHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssuePostCommentReactionHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Reaction;
    };
};

/**
 * Contains response data for the issueDeleteCommentReaction operation.
 */
export type IssueDeleteCommentReactionResponse = IssueDeleteCommentReactionHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueDeleteCommentReactionHeaders;
    };
};

/**
 * Contains response data for the issueGetIssue operation.
 */
export type IssueGetIssueResponse = Issue & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Issue;
    };
};

/**
 * Contains response data for the issueEditIssue operation.
 */
export type IssueEditIssueResponse = Issue & IssueEditIssueHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueEditIssueHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Issue;
    };
};

/**
 * Contains response data for the issueGetComments operation.
 */
export type IssueGetCommentsResponse = Array<Comment> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Comment[];
    };
};

/**
 * Contains response data for the issueCreateComment operation.
 */
export type IssueCreateCommentResponse = Comment & IssueCreateCommentHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueCreateCommentHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Comment;
    };
};

/**
 * Contains response data for the issueDeleteCommentDeprecated operation.
 */
export type IssueDeleteCommentDeprecatedResponse = IssueDeleteCommentDeprecatedHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueDeleteCommentDeprecatedHeaders;
    };
};

/**
 * Contains response data for the issueEditCommentDeprecated operation.
 */
export type IssueEditCommentDeprecatedResponse = Comment & IssueEditCommentDeprecatedHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueEditCommentDeprecatedHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Comment;
    };
};

/**
 * Contains response data for the issueEditIssueDeadline operation.
 */
export type IssueEditIssueDeadlineResponse = IssueDeadline & IssueEditIssueDeadlineHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueEditIssueDeadlineHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: IssueDeadline;
    };
};

/**
 * Contains response data for the issueGetLabels operation.
 */
export type IssueGetLabelsResponse = Array<Label> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label[];
    };
};

/**
 * Contains response data for the issueReplaceLabels operation.
 */
export type IssueReplaceLabelsResponse = Array<Label> & IssueReplaceLabelsHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueReplaceLabelsHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label[];
    };
};

/**
 * Contains response data for the issueAddLabel operation.
 */
export type IssueAddLabelResponse = Array<Label> & IssueAddLabelHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueAddLabelHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label[];
    };
};

/**
 * Contains response data for the issueClearLabels operation.
 */
export type IssueClearLabelsResponse = IssueClearLabelsHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueClearLabelsHeaders;
    };
};

/**
 * Contains response data for the issueRemoveLabel operation.
 */
export type IssueRemoveLabelResponse = IssueRemoveLabelHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueRemoveLabelHeaders;
    };
};

/**
 * Contains response data for the issueGetIssueReactions operation.
 */
export type IssueGetIssueReactionsResponse = Array<Reaction> & IssueGetIssueReactionsHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueGetIssueReactionsHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Reaction[];
    };
};

/**
 * Contains response data for the issuePostIssueReaction operation.
 */
export type IssuePostIssueReactionResponse = Reaction & IssuePostIssueReactionHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssuePostIssueReactionHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Reaction;
    };
};

/**
 * Contains response data for the issueDeleteIssueReaction operation.
 */
export type IssueDeleteIssueReactionResponse = IssueDeleteIssueReactionHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueDeleteIssueReactionHeaders;
    };
};

/**
 * Contains response data for the issueSubscriptions operation.
 */
export type IssueSubscriptionsResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the issueCheckSubscription operation.
 */
export type IssueCheckSubscriptionResponse = WatchInfo & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: WatchInfo;
    };
};

/**
 * Contains response data for the issueTrackedTimes operation.
 */
export type IssueTrackedTimesResponse = Array<TrackedTime> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TrackedTime[];
    };
};

/**
 * Contains response data for the issueAddTime operation.
 */
export type IssueAddTimeResponse = TrackedTime & IssueAddTimeHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueAddTimeHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TrackedTime;
    };
};

/**
 * Contains response data for the issueResetTime operation.
 */
export type IssueResetTimeResponse = IssueResetTimeHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueResetTimeHeaders;
    };
};

/**
 * Contains response data for the issueDeleteTime operation.
 */
export type IssueDeleteTimeResponse = IssueDeleteTimeHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueDeleteTimeHeaders;
    };
};

/**
 * Contains response data for the repoListKeys operation.
 */
export type RepoListKeysResponse = Array<DeployKey> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: DeployKey[];
    };
};

/**
 * Contains response data for the repoCreateKey operation.
 */
export type RepoCreateKeyResponse = DeployKey & RepoCreateKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCreateKeyHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: DeployKey;
    };
};

/**
 * Contains response data for the repoGetKey operation.
 */
export type RepoGetKeyResponse = DeployKey & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: DeployKey;
    };
};

/**
 * Contains response data for the repoDeleteKey operation.
 */
export type RepoDeleteKeyResponse = RepoDeleteKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoDeleteKeyHeaders;
    };
};

/**
 * Contains response data for the issueListLabels operation.
 */
export type IssueListLabelsResponse = Array<Label> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label[];
    };
};

/**
 * Contains response data for the issueCreateLabel operation.
 */
export type IssueCreateLabelResponse = Label & IssueCreateLabelHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueCreateLabelHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label;
    };
};

/**
 * Contains response data for the issueGetLabel operation.
 */
export type IssueGetLabelResponse = Label & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label;
    };
};

/**
 * Contains response data for the issueEditLabel operation.
 */
export type IssueEditLabelResponse = Label & IssueEditLabelHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: IssueEditLabelHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Label;
    };
};

/**
 * Contains response data for the issueGetMilestonesList operation.
 */
export type IssueGetMilestonesListResponse = Array<Milestone> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Milestone[];
    };
};

/**
 * Contains response data for the issueCreateMilestone operation.
 */
export type IssueCreateMilestoneResponse = Milestone & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Milestone;
    };
};

/**
 * Contains response data for the issueGetMilestone operation.
 */
export type IssueGetMilestoneResponse = Milestone & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Milestone;
    };
};

/**
 * Contains response data for the issueEditMilestone operation.
 */
export type IssueEditMilestoneResponse = Milestone & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Milestone;
    };
};

/**
 * Contains response data for the repoMirrorSync operation.
 */
export type RepoMirrorSyncResponse = RepoMirrorSyncHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoMirrorSyncHeaders;
    };
};

/**
 * Contains response data for the notifyGetRepoList operation.
 */
export type NotifyGetRepoListResponse = Array<NotificationThread> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: NotificationThread[];
    };
};

/**
 * Contains response data for the repoListPullRequests operation.
 */
export type RepoListPullRequestsResponse = Array<PullRequest> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullRequest[];
    };
};

/**
 * Contains response data for the repoCreatePullRequest operation.
 */
export type RepoCreatePullRequestResponse = PullRequest & RepoCreatePullRequestHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCreatePullRequestHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullRequest;
    };
};

/**
 * Contains response data for the repoGetPullRequest operation.
 */
export type RepoGetPullRequestResponse = PullRequest & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullRequest;
    };
};

/**
 * Contains response data for the repoEditPullRequest operation.
 */
export type RepoEditPullRequestResponse = PullRequest & RepoEditPullRequestHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoEditPullRequestHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullRequest;
    };
};

/**
 * Contains response data for the repoMergePullRequest operation.
 */
export type RepoMergePullRequestResponse = RepoMergePullRequestHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoMergePullRequestHeaders;
    };
};

/**
 * Contains response data for the repoListPullReviews operation.
 */
export type RepoListPullReviewsResponse = Array<PullReview> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullReview[];
    };
};

/**
 * Contains response data for the repoCreatePullReview operation.
 */
export type RepoCreatePullReviewResponse = PullReview & RepoCreatePullReviewHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCreatePullReviewHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullReview;
    };
};

/**
 * Contains response data for the repoGetPullReview operation.
 */
export type RepoGetPullReviewResponse = PullReview & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullReview;
    };
};

/**
 * Contains response data for the repoSubmitPullReview operation.
 */
export type RepoSubmitPullReviewResponse = PullReview & RepoSubmitPullReviewHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoSubmitPullReviewHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullReview;
    };
};

/**
 * Contains response data for the repoDeletePullReview operation.
 */
export type RepoDeletePullReviewResponse = RepoDeletePullReviewHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoDeletePullReviewHeaders;
    };
};

/**
 * Contains response data for the repoGetPullReviewComments operation.
 */
export type RepoGetPullReviewCommentsResponse = Array<PullReviewComment> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PullReviewComment[];
    };
};

/**
 * Contains response data for the repoListReleases operation.
 */
export type RepoListReleasesResponse = Array<Release> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Release[];
    };
};

/**
 * Contains response data for the repoCreateRelease operation.
 */
export type RepoCreateReleaseResponse = Release & RepoCreateReleaseHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCreateReleaseHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Release;
    };
};

/**
 * Contains response data for the repoGetRelease operation.
 */
export type RepoGetReleaseResponse = Release & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Release;
    };
};

/**
 * Contains response data for the repoEditRelease operation.
 */
export type RepoEditReleaseResponse = Release & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Release;
    };
};

/**
 * Contains response data for the repoListReleaseAttachments operation.
 */
export type RepoListReleaseAttachmentsResponse = Array<Attachment> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Attachment[];
    };
};

/**
 * Contains response data for the repoCreateReleaseAttachment operation.
 */
export type RepoCreateReleaseAttachmentResponse = Attachment & RepoCreateReleaseAttachmentHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCreateReleaseAttachmentHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Attachment;
    };
};

/**
 * Contains response data for the repoGetReleaseAttachment operation.
 */
export type RepoGetReleaseAttachmentResponse = Attachment & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Attachment;
    };
};

/**
 * Contains response data for the repoEditReleaseAttachment operation.
 */
export type RepoEditReleaseAttachmentResponse = Attachment & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Attachment;
    };
};

/**
 * Contains response data for the repoSigningKey operation.
 */
export type RepoSigningKeyResponse = {
  /**
   * The parsed response body.
   */
  body: string;

  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: string;
    };
};

/**
 * Contains response data for the repoListStargazers operation.
 */
export type RepoListStargazersResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the repoListStatuses operation.
 */
export type RepoListStatusesResponse = Array<Status> & RepoListStatusesHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoListStatusesHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Status[];
    };
};

/**
 * Contains response data for the repoCreateStatus operation.
 */
export type RepoCreateStatusResponse = Status & RepoCreateStatusHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoCreateStatusHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Status;
    };
};

/**
 * Contains response data for the repoListSubscribers operation.
 */
export type RepoListSubscribersResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the userCurrentCheckSubscription operation.
 */
export type UserCurrentCheckSubscriptionResponse = WatchInfo & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: WatchInfo;
    };
};

/**
 * Contains response data for the userCurrentPutSubscription operation.
 */
export type UserCurrentPutSubscriptionResponse = WatchInfo & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: WatchInfo;
    };
};

/**
 * Contains response data for the repoListTags operation.
 */
export type RepoListTagsResponse = Array<Tag> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Tag[];
    };
};

/**
 * Contains response data for the repoTrackedTimes operation.
 */
export type RepoTrackedTimesResponse = Array<TrackedTime> & RepoTrackedTimesHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoTrackedTimesHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TrackedTime[];
    };
};

/**
 * Contains response data for the userTrackedTimes operation.
 */
export type UserTrackedTimesResponse = Array<TrackedTime> & UserTrackedTimesHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: UserTrackedTimesHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TrackedTime[];
    };
};

/**
 * Contains response data for the repoListTopics operation.
 */
export type RepoListTopicsResponse = TopicName & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TopicName;
    };
};

/**
 * Contains response data for the repoUpdateTopics operation.
 */
export type RepoUpdateTopicsResponse = RepoUpdateTopicsHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoUpdateTopicsHeaders;
    };
};

/**
 * Contains response data for the repoAddTopíc operation.
 */
export type RepoAddTopícResponse = RepoAddTopícHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoAddTopícHeaders;
    };
};

/**
 * Contains response data for the repoDeleteTopic operation.
 */
export type RepoDeleteTopicResponse = RepoDeleteTopicHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoDeleteTopicHeaders;
    };
};

/**
 * Contains response data for the repoTransfer operation.
 */
export type RepoTransferResponse = Repository & RepoTransferHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: RepoTransferHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the repoGetByID operation.
 */
export type RepoGetByIDResponse = Repository & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the getSigningKey operation.
 */
export type GetSigningKeyResponse = {
  /**
   * The parsed response body.
   */
  body: string;

  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: string;
    };
};

/**
 * Contains response data for the orgGetTeam operation.
 */
export type OrgGetTeamResponse = Team & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Team;
    };
};

/**
 * Contains response data for the orgEditTeam operation.
 */
export type OrgEditTeamResponse = Team & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Team;
    };
};

/**
 * Contains response data for the orgListTeamMembers operation.
 */
export type OrgListTeamMembersResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the orgListTeamMember operation.
 */
export type OrgListTeamMemberResponse = User & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User;
    };
};

/**
 * Contains response data for the orgListTeamRepos operation.
 */
export type OrgListTeamReposResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the orgAddTeamRepository operation.
 */
export type OrgAddTeamRepositoryResponse = OrgAddTeamRepositoryHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgAddTeamRepositoryHeaders;
    };
};

/**
 * Contains response data for the orgRemoveTeamRepository operation.
 */
export type OrgRemoveTeamRepositoryResponse = OrgRemoveTeamRepositoryHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: OrgRemoveTeamRepositoryHeaders;
    };
};

/**
 * Contains response data for the topicSearch operation.
 */
export type TopicSearchResponse = Array<TopicResponse> & TopicSearchHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: TopicSearchHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TopicResponse[];
    };
};

/**
 * Contains response data for the userGetCurrent operation.
 */
export type UserGetCurrentResponse = User & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User;
    };
};

/**
 * Contains response data for the userGetOauth2Application operation.
 */
export type UserGetOauth2ApplicationResponse = Array<OAuth2Application> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: OAuth2Application[];
    };
};

/**
 * Contains response data for the userCreateOAuth2Application operation.
 */
export type UserCreateOAuth2ApplicationResponse = OAuth2Application & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: OAuth2Application;
    };
};

/**
 * Contains response data for the userGetOAuth2Application operation.
 */
export type UserGetOAuth2ApplicationResponse = OAuth2Application & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: OAuth2Application;
    };
};

/**
 * Contains response data for the userUpdateOAuth2Application operation.
 */
export type UserUpdateOAuth2ApplicationResponse = OAuth2Application & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: OAuth2Application;
    };
};

/**
 * Contains response data for the userListEmails operation.
 */
export type UserListEmailsResponse = Array<Email> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Email[];
    };
};

/**
 * Contains response data for the userAddEmail operation.
 */
export type UserAddEmailResponse = Array<Email> & UserAddEmailHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: UserAddEmailHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Email[];
    };
};

/**
 * Contains response data for the userCurrentListFollowers operation.
 */
export type UserCurrentListFollowersResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the userCurrentListFollowing operation.
 */
export type UserCurrentListFollowingResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the userCurrentListGPGKeys operation.
 */
export type UserCurrentListGPGKeysResponse = Array<GPGKey> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GPGKey[];
    };
};

/**
 * Contains response data for the userCurrentPostGPGKey operation.
 */
export type UserCurrentPostGPGKeyResponse = GPGKey & UserCurrentPostGPGKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: UserCurrentPostGPGKeyHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GPGKey;
    };
};

/**
 * Contains response data for the userCurrentGetGPGKey operation.
 */
export type UserCurrentGetGPGKeyResponse = GPGKey & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GPGKey;
    };
};

/**
 * Contains response data for the userCurrentDeleteGPGKey operation.
 */
export type UserCurrentDeleteGPGKeyResponse = UserCurrentDeleteGPGKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: UserCurrentDeleteGPGKeyHeaders;
    };
};

/**
 * Contains response data for the userCurrentListKeys operation.
 */
export type UserCurrentListKeysResponse = Array<PublicKey> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PublicKey[];
    };
};

/**
 * Contains response data for the userCurrentPostKey operation.
 */
export type UserCurrentPostKeyResponse = PublicKey & UserCurrentPostKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: UserCurrentPostKeyHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PublicKey;
    };
};

/**
 * Contains response data for the userCurrentGetKey operation.
 */
export type UserCurrentGetKeyResponse = PublicKey & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PublicKey;
    };
};

/**
 * Contains response data for the userCurrentDeleteKey operation.
 */
export type UserCurrentDeleteKeyResponse = UserCurrentDeleteKeyHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: UserCurrentDeleteKeyHeaders;
    };
};

/**
 * Contains response data for the orgListCurrentUserOrgs operation.
 */
export type OrgListCurrentUserOrgsResponse = Array<Organization> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization[];
    };
};

/**
 * Contains response data for the userCurrentListRepos operation.
 */
export type UserCurrentListReposResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the createCurrentUserRepo operation.
 */
export type CreateCurrentUserRepoResponse = Repository & CreateCurrentUserRepoHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: CreateCurrentUserRepoHeaders;

      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository;
    };
};

/**
 * Contains response data for the userCurrentListStarred operation.
 */
export type UserCurrentListStarredResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the userGetStopWatches operation.
 */
export type UserGetStopWatchesResponse = Array<StopWatch> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: StopWatch[];
    };
};

/**
 * Contains response data for the userCurrentListSubscriptions operation.
 */
export type UserCurrentListSubscriptionsResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the userListTeams operation.
 */
export type UserListTeamsResponse = Array<Team> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Team[];
    };
};

/**
 * Contains response data for the userCurrentTrackedTimes operation.
 */
export type UserCurrentTrackedTimesResponse = Array<TrackedTime> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: TrackedTime[];
    };
};

/**
 * Contains response data for the userSearch operation.
 */
export type UserSearchResponse = UserSearchOKResponse & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: UserSearchOKResponse;
    };
};

/**
 * Contains response data for the userGet operation.
 */
export type UserGetResponse = User & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User;
    };
};

/**
 * Contains response data for the userListFollowers operation.
 */
export type UserListFollowersResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the userListFollowing operation.
 */
export type UserListFollowingResponse = Array<User> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: User[];
    };
};

/**
 * Contains response data for the userListGPGKeys operation.
 */
export type UserListGPGKeysResponse = Array<GPGKey> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: GPGKey[];
    };
};

/**
 * Contains response data for the userGetHeatmapData operation.
 */
export type UserGetHeatmapDataResponse = Array<UserHeatmapData> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: UserHeatmapData[];
    };
};

/**
 * Contains response data for the userListKeys operation.
 */
export type UserListKeysResponse = Array<PublicKey> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: PublicKey[];
    };
};

/**
 * Contains response data for the orgListUserOrgs operation.
 */
export type OrgListUserOrgsResponse = Array<Organization> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Organization[];
    };
};

/**
 * Contains response data for the userListRepos operation.
 */
export type UserListReposResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the userListStarred operation.
 */
export type UserListStarredResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the userListSubscriptions operation.
 */
export type UserListSubscriptionsResponse = Array<Repository> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: Repository[];
    };
};

/**
 * Contains response data for the userGetTokens operation.
 */
export type UserGetTokensResponse = Array<AccessToken> & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: AccessToken[];
    };
};

/**
 * Contains response data for the userCreateToken operation.
 */
export type UserCreateTokenResponse = UserCreateTokenHeaders & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The parsed HTTP response headers.
       */
      parsedHeaders: UserCreateTokenHeaders;
    };
};

/**
 * Contains response data for the getVersion operation.
 */
export type GetVersionResponse = ServerVersion & {
  /**
   * The underlying HTTP response.
   */
  _response: msRest.HttpResponse & {
      /**
       * The response body as text (string format)
       */
      bodyAsText: string;

      /**
       * The response body as parsed JSON or XML
       */
      parsedBody: ServerVersion;
    };
};
