/*
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import * as msRest from "@azure/ms-rest-js";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as Parameters from "./models/parameters";
import { GiteaAPIContext } from "./giteaAPIContext";

class GiteaAPI extends GiteaAPIContext {
  /**
   * Initializes a new instance of the GiteaAPI class.
   * @param [options] The parameter options
   */
  constructor(options?: Models.GiteaAPIOptions) {
    super(options);
  }

  /**
   * @summary List all organizations
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminGetAllOrgsResponse>
   */
  adminGetAllOrgs(options?: Models.GiteaAPIAdminGetAllOrgsOptionalParams): Promise<Models.AdminGetAllOrgsResponse>;
  /**
   * @param callback The callback
   */
  adminGetAllOrgs(callback: msRest.ServiceCallback<Models.Organization[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  adminGetAllOrgs(options: Models.GiteaAPIAdminGetAllOrgsOptionalParams, callback: msRest.ServiceCallback<Models.Organization[]>): void;
  adminGetAllOrgs(options?: Models.GiteaAPIAdminGetAllOrgsOptionalParams | msRest.ServiceCallback<Models.Organization[]>, callback?: msRest.ServiceCallback<Models.Organization[]>): Promise<Models.AdminGetAllOrgsResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      adminGetAllOrgsOperationSpec,
      callback) as Promise<Models.AdminGetAllOrgsResponse>;
  }

  /**
   * @summary List all users
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminGetAllUsersResponse>
   */
  adminGetAllUsers(options?: Models.GiteaAPIAdminGetAllUsersOptionalParams): Promise<Models.AdminGetAllUsersResponse>;
  /**
   * @param callback The callback
   */
  adminGetAllUsers(callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  adminGetAllUsers(options: Models.GiteaAPIAdminGetAllUsersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  adminGetAllUsers(options?: Models.GiteaAPIAdminGetAllUsersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.AdminGetAllUsersResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      adminGetAllUsersOperationSpec,
      callback) as Promise<Models.AdminGetAllUsersResponse>;
  }

  /**
   * @summary Create a user
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminCreateUserResponse>
   */
  adminCreateUser(options?: Models.GiteaAPIAdminCreateUserOptionalParams): Promise<Models.AdminCreateUserResponse>;
  /**
   * @param callback The callback
   */
  adminCreateUser(callback: msRest.ServiceCallback<Models.User>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  adminCreateUser(options: Models.GiteaAPIAdminCreateUserOptionalParams, callback: msRest.ServiceCallback<Models.User>): void;
  adminCreateUser(options?: Models.GiteaAPIAdminCreateUserOptionalParams | msRest.ServiceCallback<Models.User>, callback?: msRest.ServiceCallback<Models.User>): Promise<Models.AdminCreateUserResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      adminCreateUserOperationSpec,
      callback) as Promise<Models.AdminCreateUserResponse>;
  }

  /**
   * @summary Delete a user
   * @param username username of user to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminDeleteUserResponse>
   */
  adminDeleteUser(username: string, options?: msRest.RequestOptionsBase): Promise<Models.AdminDeleteUserResponse>;
  /**
   * @param username username of user to delete
   * @param callback The callback
   */
  adminDeleteUser(username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param username username of user to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  adminDeleteUser(username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  adminDeleteUser(username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.AdminDeleteUserResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      adminDeleteUserOperationSpec,
      callback) as Promise<Models.AdminDeleteUserResponse>;
  }

  /**
   * @summary Edit an existing user
   * @param username username of user to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminEditUserResponse>
   */
  adminEditUser(username: string, options?: Models.GiteaAPIAdminEditUserOptionalParams): Promise<Models.AdminEditUserResponse>;
  /**
   * @param username username of user to edit
   * @param callback The callback
   */
  adminEditUser(username: string, callback: msRest.ServiceCallback<Models.User>): void;
  /**
   * @param username username of user to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  adminEditUser(username: string, options: Models.GiteaAPIAdminEditUserOptionalParams, callback: msRest.ServiceCallback<Models.User>): void;
  adminEditUser(username: string, options?: Models.GiteaAPIAdminEditUserOptionalParams | msRest.ServiceCallback<Models.User>, callback?: msRest.ServiceCallback<Models.User>): Promise<Models.AdminEditUserResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      adminEditUserOperationSpec,
      callback) as Promise<Models.AdminEditUserResponse>;
  }

  /**
   * @summary Add a public key on behalf of a user
   * @param username username of the user
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminCreatePublicKeyResponse>
   */
  adminCreatePublicKey(username: string, options?: Models.GiteaAPIAdminCreatePublicKeyOptionalParams): Promise<Models.AdminCreatePublicKeyResponse>;
  /**
   * @param username username of the user
   * @param callback The callback
   */
  adminCreatePublicKey(username: string, callback: msRest.ServiceCallback<Models.PublicKey>): void;
  /**
   * @param username username of the user
   * @param options The optional parameters
   * @param callback The callback
   */
  adminCreatePublicKey(username: string, options: Models.GiteaAPIAdminCreatePublicKeyOptionalParams, callback: msRest.ServiceCallback<Models.PublicKey>): void;
  adminCreatePublicKey(username: string, options?: Models.GiteaAPIAdminCreatePublicKeyOptionalParams | msRest.ServiceCallback<Models.PublicKey>, callback?: msRest.ServiceCallback<Models.PublicKey>): Promise<Models.AdminCreatePublicKeyResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      adminCreatePublicKeyOperationSpec,
      callback) as Promise<Models.AdminCreatePublicKeyResponse>;
  }

  /**
   * @summary Delete a user's public key
   * @param username username of user
   * @param id id of the key to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminDeleteUserPublicKeyResponse>
   */
  adminDeleteUserPublicKey(username: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.AdminDeleteUserPublicKeyResponse>;
  /**
   * @param username username of user
   * @param id id of the key to delete
   * @param callback The callback
   */
  adminDeleteUserPublicKey(username: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param username username of user
   * @param id id of the key to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  adminDeleteUserPublicKey(username: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  adminDeleteUserPublicKey(username: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.AdminDeleteUserPublicKeyResponse> {
    return this.sendOperationRequest(
      {
        username,
        id,
        options
      },
      adminDeleteUserPublicKeyOperationSpec,
      callback) as Promise<Models.AdminDeleteUserPublicKeyResponse>;
  }

  /**
   * @summary Create an organization
   * @param username username of the user that will own the created organization
   * @param organization
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminCreateOrgResponse>
   */
  adminCreateOrg(username: string, organization: Models.CreateOrgOption, options?: msRest.RequestOptionsBase): Promise<Models.AdminCreateOrgResponse>;
  /**
   * @param username username of the user that will own the created organization
   * @param organization
   * @param callback The callback
   */
  adminCreateOrg(username: string, organization: Models.CreateOrgOption, callback: msRest.ServiceCallback<Models.Organization>): void;
  /**
   * @param username username of the user that will own the created organization
   * @param organization
   * @param options The optional parameters
   * @param callback The callback
   */
  adminCreateOrg(username: string, organization: Models.CreateOrgOption, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Organization>): void;
  adminCreateOrg(username: string, organization: Models.CreateOrgOption, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Organization>, callback?: msRest.ServiceCallback<Models.Organization>): Promise<Models.AdminCreateOrgResponse> {
    return this.sendOperationRequest(
      {
        username,
        organization,
        options
      },
      adminCreateOrgOperationSpec,
      callback) as Promise<Models.AdminCreateOrgResponse>;
  }

  /**
   * @summary Create a repository on behalf of a user
   * @param username username of the user. This user will own the created repository
   * @param repository
   * @param [options] The optional parameters
   * @returns Promise<Models.AdminCreateRepoResponse>
   */
  adminCreateRepo(username: string, repository: Models.CreateRepoOption, options?: msRest.RequestOptionsBase): Promise<Models.AdminCreateRepoResponse>;
  /**
   * @param username username of the user. This user will own the created repository
   * @param repository
   * @param callback The callback
   */
  adminCreateRepo(username: string, repository: Models.CreateRepoOption, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param username username of the user. This user will own the created repository
   * @param repository
   * @param options The optional parameters
   * @param callback The callback
   */
  adminCreateRepo(username: string, repository: Models.CreateRepoOption, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Repository>): void;
  adminCreateRepo(username: string, repository: Models.CreateRepoOption, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.AdminCreateRepoResponse> {
    return this.sendOperationRequest(
      {
        username,
        repository,
        options
      },
      adminCreateRepoOperationSpec,
      callback) as Promise<Models.AdminCreateRepoResponse>;
  }

  /**
   * @summary Render a markdown document as HTML
   * @param [options] The optional parameters
   * @returns Promise<Models.RenderMarkdownResponse>
   */
  renderMarkdown(options?: Models.GiteaAPIRenderMarkdownOptionalParams): Promise<Models.RenderMarkdownResponse>;
  /**
   * @param callback The callback
   */
  renderMarkdown(callback: msRest.ServiceCallback<string>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  renderMarkdown(options: Models.GiteaAPIRenderMarkdownOptionalParams, callback: msRest.ServiceCallback<string>): void;
  renderMarkdown(options?: Models.GiteaAPIRenderMarkdownOptionalParams | msRest.ServiceCallback<string>, callback?: msRest.ServiceCallback<string>): Promise<Models.RenderMarkdownResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      renderMarkdownOperationSpec,
      callback) as Promise<Models.RenderMarkdownResponse>;
  }

  /**
   * @summary Render raw markdown as HTML
   * @param body Request body to render
   * @param [options] The optional parameters
   * @returns Promise<Models.RenderMarkdownRawResponse>
   */
  renderMarkdownRaw(body: string, options?: msRest.RequestOptionsBase): Promise<Models.RenderMarkdownRawResponse>;
  /**
   * @param body Request body to render
   * @param callback The callback
   */
  renderMarkdownRaw(body: string, callback: msRest.ServiceCallback<string>): void;
  /**
   * @param body Request body to render
   * @param options The optional parameters
   * @param callback The callback
   */
  renderMarkdownRaw(body: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<string>): void;
  renderMarkdownRaw(body: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<string>, callback?: msRest.ServiceCallback<string>): Promise<Models.RenderMarkdownRawResponse> {
    return this.sendOperationRequest(
      {
        body,
        options
      },
      renderMarkdownRawOperationSpec,
      callback) as Promise<Models.RenderMarkdownRawResponse>;
  }

  /**
   * @summary List users's notification threads
   * @param [options] The optional parameters
   * @returns Promise<Models.NotifyGetListResponse>
   */
  notifyGetList(options?: Models.GiteaAPINotifyGetListOptionalParams): Promise<Models.NotifyGetListResponse>;
  /**
   * @param callback The callback
   */
  notifyGetList(callback: msRest.ServiceCallback<Models.NotificationThread[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  notifyGetList(options: Models.GiteaAPINotifyGetListOptionalParams, callback: msRest.ServiceCallback<Models.NotificationThread[]>): void;
  notifyGetList(options?: Models.GiteaAPINotifyGetListOptionalParams | msRest.ServiceCallback<Models.NotificationThread[]>, callback?: msRest.ServiceCallback<Models.NotificationThread[]>): Promise<Models.NotifyGetListResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      notifyGetListOperationSpec,
      callback) as Promise<Models.NotifyGetListResponse>;
  }

  /**
   * @summary Mark notification threads as read
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  notifyReadList(options?: Models.GiteaAPINotifyReadListOptionalParams): Promise<msRest.RestResponse>;
  /**
   * @param callback The callback
   */
  notifyReadList(callback: msRest.ServiceCallback<void>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  notifyReadList(options: Models.GiteaAPINotifyReadListOptionalParams, callback: msRest.ServiceCallback<void>): void;
  notifyReadList(options?: Models.GiteaAPINotifyReadListOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      notifyReadListOperationSpec,
      callback);
  }

  /**
   * @summary Check if unread notifications exist
   * @param [options] The optional parameters
   * @returns Promise<Models.NotifyNewAvailableResponse>
   */
  notifyNewAvailable(options?: msRest.RequestOptionsBase): Promise<Models.NotifyNewAvailableResponse>;
  /**
   * @param callback The callback
   */
  notifyNewAvailable(callback: msRest.ServiceCallback<Models.NotificationCount>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  notifyNewAvailable(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.NotificationCount>): void;
  notifyNewAvailable(options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.NotificationCount>, callback?: msRest.ServiceCallback<Models.NotificationCount>): Promise<Models.NotifyNewAvailableResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      notifyNewAvailableOperationSpec,
      callback) as Promise<Models.NotifyNewAvailableResponse>;
  }

  /**
   * @summary Get notification thread by ID
   * @param id id of notification thread
   * @param [options] The optional parameters
   * @returns Promise<Models.NotifyGetThreadResponse>
   */
  notifyGetThread(id: string, options?: msRest.RequestOptionsBase): Promise<Models.NotifyGetThreadResponse>;
  /**
   * @param id id of notification thread
   * @param callback The callback
   */
  notifyGetThread(id: string, callback: msRest.ServiceCallback<Models.NotificationThread>): void;
  /**
   * @param id id of notification thread
   * @param options The optional parameters
   * @param callback The callback
   */
  notifyGetThread(id: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.NotificationThread>): void;
  notifyGetThread(id: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.NotificationThread>, callback?: msRest.ServiceCallback<Models.NotificationThread>): Promise<Models.NotifyGetThreadResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      notifyGetThreadOperationSpec,
      callback) as Promise<Models.NotifyGetThreadResponse>;
  }

  /**
   * @summary Mark notification thread as read by ID
   * @param id id of notification thread
   * @param [options] The optional parameters
   * @returns Promise<Models.NotifyReadThreadResponse>
   */
  notifyReadThread(id: string, options?: msRest.RequestOptionsBase): Promise<Models.NotifyReadThreadResponse>;
  /**
   * @param id id of notification thread
   * @param callback The callback
   */
  notifyReadThread(id: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of notification thread
   * @param options The optional parameters
   * @param callback The callback
   */
  notifyReadThread(id: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  notifyReadThread(id: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.NotifyReadThreadResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      notifyReadThreadOperationSpec,
      callback) as Promise<Models.NotifyReadThreadResponse>;
  }

  /**
   * @summary Create a repository in an organization
   * @param org name of organization
   * @param [options] The optional parameters
   * @deprecated This operation is deprecated. Please do not use it any longer.
   * @returns Promise<Models.CreateOrgRepoDeprecatedResponse>
   */
  createOrgRepoDeprecated(org: string, options?: Models.GiteaAPICreateOrgRepoDeprecatedOptionalParams): Promise<Models.CreateOrgRepoDeprecatedResponse>;
  /**
   * @param org name of organization
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  createOrgRepoDeprecated(org: string, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param org name of organization
   * @param options The optional parameters
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  createOrgRepoDeprecated(org: string, options: Models.GiteaAPICreateOrgRepoDeprecatedOptionalParams, callback: msRest.ServiceCallback<Models.Repository>): void;
  createOrgRepoDeprecated(org: string, options?: Models.GiteaAPICreateOrgRepoDeprecatedOptionalParams | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.CreateOrgRepoDeprecatedResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      createOrgRepoDeprecatedOperationSpec,
      callback) as Promise<Models.CreateOrgRepoDeprecatedResponse>;
  }

  /**
   * @summary Get list of organizations
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgGetAllResponse>
   */
  orgGetAll(options?: Models.GiteaAPIOrgGetAllOptionalParams): Promise<Models.OrgGetAllResponse>;
  /**
   * @param callback The callback
   */
  orgGetAll(callback: msRest.ServiceCallback<Models.Organization[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  orgGetAll(options: Models.GiteaAPIOrgGetAllOptionalParams, callback: msRest.ServiceCallback<Models.Organization[]>): void;
  orgGetAll(options?: Models.GiteaAPIOrgGetAllOptionalParams | msRest.ServiceCallback<Models.Organization[]>, callback?: msRest.ServiceCallback<Models.Organization[]>): Promise<Models.OrgGetAllResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      orgGetAllOperationSpec,
      callback) as Promise<Models.OrgGetAllResponse>;
  }

  /**
   * @summary Create an organization
   * @param organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgCreateResponse>
   */
  orgCreate(organization: Models.CreateOrgOption, options?: msRest.RequestOptionsBase): Promise<Models.OrgCreateResponse>;
  /**
   * @param organization
   * @param callback The callback
   */
  orgCreate(organization: Models.CreateOrgOption, callback: msRest.ServiceCallback<Models.Organization>): void;
  /**
   * @param organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgCreate(organization: Models.CreateOrgOption, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Organization>): void;
  orgCreate(organization: Models.CreateOrgOption, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Organization>, callback?: msRest.ServiceCallback<Models.Organization>): Promise<Models.OrgCreateResponse> {
    return this.sendOperationRequest(
      {
        organization,
        options
      },
      orgCreateOperationSpec,
      callback) as Promise<Models.OrgCreateResponse>;
  }

  /**
   * @summary Get an organization
   * @param org name of the organization to get
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgGetResponse>
   */
  orgGet(org: string, options?: msRest.RequestOptionsBase): Promise<Models.OrgGetResponse>;
  /**
   * @param org name of the organization to get
   * @param callback The callback
   */
  orgGet(org: string, callback: msRest.ServiceCallback<Models.Organization>): void;
  /**
   * @param org name of the organization to get
   * @param options The optional parameters
   * @param callback The callback
   */
  orgGet(org: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Organization>): void;
  orgGet(org: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Organization>, callback?: msRest.ServiceCallback<Models.Organization>): Promise<Models.OrgGetResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgGetOperationSpec,
      callback) as Promise<Models.OrgGetResponse>;
  }

  /**
   * @summary Delete an organization
   * @param org organization that is to be deleted
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgDelete(org: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param org organization that is to be deleted
   * @param callback The callback
   */
  orgDelete(org: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org organization that is to be deleted
   * @param options The optional parameters
   * @param callback The callback
   */
  orgDelete(org: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgDelete(org: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgDeleteOperationSpec,
      callback);
  }

  /**
   * @summary Edit an organization
   * @param org name of the organization to edit
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgEditResponse>
   */
  orgEdit(org: string, body: Models.EditOrgOption, options?: msRest.RequestOptionsBase): Promise<Models.OrgEditResponse>;
  /**
   * @param org name of the organization to edit
   * @param body
   * @param callback The callback
   */
  orgEdit(org: string, body: Models.EditOrgOption, callback: msRest.ServiceCallback<Models.Organization>): void;
  /**
   * @param org name of the organization to edit
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  orgEdit(org: string, body: Models.EditOrgOption, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Organization>): void;
  orgEdit(org: string, body: Models.EditOrgOption, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Organization>, callback?: msRest.ServiceCallback<Models.Organization>): Promise<Models.OrgEditResponse> {
    return this.sendOperationRequest(
      {
        org,
        body,
        options
      },
      orgEditOperationSpec,
      callback) as Promise<Models.OrgEditResponse>;
  }

  /**
   * @summary List an organization's webhooks
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListHooksResponse>
   */
  orgListHooks(org: string, options?: Models.GiteaAPIOrgListHooksOptionalParams): Promise<Models.OrgListHooksResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgListHooks(org: string, callback: msRest.ServiceCallback<Models.Hook[]>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListHooks(org: string, options: Models.GiteaAPIOrgListHooksOptionalParams, callback: msRest.ServiceCallback<Models.Hook[]>): void;
  orgListHooks(org: string, options?: Models.GiteaAPIOrgListHooksOptionalParams | msRest.ServiceCallback<Models.Hook[]>, callback?: msRest.ServiceCallback<Models.Hook[]>): Promise<Models.OrgListHooksResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgListHooksOperationSpec,
      callback) as Promise<Models.OrgListHooksResponse>;
  }

  /**
   * @summary Create a hook
   * @param org name of the organization
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgCreateHookResponse>
   */
  orgCreateHook(org: string, body: Models.CreateHookOption, options?: msRest.RequestOptionsBase): Promise<Models.OrgCreateHookResponse>;
  /**
   * @param org name of the organization
   * @param body
   * @param callback The callback
   */
  orgCreateHook(org: string, body: Models.CreateHookOption, callback: msRest.ServiceCallback<Models.Hook>): void;
  /**
   * @param org name of the organization
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  orgCreateHook(org: string, body: Models.CreateHookOption, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Hook>): void;
  orgCreateHook(org: string, body: Models.CreateHookOption, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Hook>, callback?: msRest.ServiceCallback<Models.Hook>): Promise<Models.OrgCreateHookResponse> {
    return this.sendOperationRequest(
      {
        org,
        body,
        options
      },
      orgCreateHookOperationSpec,
      callback) as Promise<Models.OrgCreateHookResponse>;
  }

  /**
   * @summary Get a hook
   * @param org name of the organization
   * @param id id of the hook to get
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgGetHookResponse>
   */
  orgGetHook(org: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.OrgGetHookResponse>;
  /**
   * @param org name of the organization
   * @param id id of the hook to get
   * @param callback The callback
   */
  orgGetHook(org: string, id: number, callback: msRest.ServiceCallback<Models.Hook>): void;
  /**
   * @param org name of the organization
   * @param id id of the hook to get
   * @param options The optional parameters
   * @param callback The callback
   */
  orgGetHook(org: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Hook>): void;
  orgGetHook(org: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Hook>, callback?: msRest.ServiceCallback<Models.Hook>): Promise<Models.OrgGetHookResponse> {
    return this.sendOperationRequest(
      {
        org,
        id,
        options
      },
      orgGetHookOperationSpec,
      callback) as Promise<Models.OrgGetHookResponse>;
  }

  /**
   * @summary Delete a hook
   * @param org name of the organization
   * @param id id of the hook to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgDeleteHook(org: string, id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param org name of the organization
   * @param id id of the hook to delete
   * @param callback The callback
   */
  orgDeleteHook(org: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org name of the organization
   * @param id id of the hook to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  orgDeleteHook(org: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgDeleteHook(org: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        org,
        id,
        options
      },
      orgDeleteHookOperationSpec,
      callback);
  }

  /**
   * @summary Update a hook
   * @param org name of the organization
   * @param id id of the hook to update
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgEditHookResponse>
   */
  orgEditHook(org: string, id: number, options?: Models.GiteaAPIOrgEditHookOptionalParams): Promise<Models.OrgEditHookResponse>;
  /**
   * @param org name of the organization
   * @param id id of the hook to update
   * @param callback The callback
   */
  orgEditHook(org: string, id: number, callback: msRest.ServiceCallback<Models.Hook>): void;
  /**
   * @param org name of the organization
   * @param id id of the hook to update
   * @param options The optional parameters
   * @param callback The callback
   */
  orgEditHook(org: string, id: number, options: Models.GiteaAPIOrgEditHookOptionalParams, callback: msRest.ServiceCallback<Models.Hook>): void;
  orgEditHook(org: string, id: number, options?: Models.GiteaAPIOrgEditHookOptionalParams | msRest.ServiceCallback<Models.Hook>, callback?: msRest.ServiceCallback<Models.Hook>): Promise<Models.OrgEditHookResponse> {
    return this.sendOperationRequest(
      {
        org,
        id,
        options
      },
      orgEditHookOperationSpec,
      callback) as Promise<Models.OrgEditHookResponse>;
  }

  /**
   * @summary List an organization's labels
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListLabelsResponse>
   */
  orgListLabels(org: string, options?: Models.GiteaAPIOrgListLabelsOptionalParams): Promise<Models.OrgListLabelsResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgListLabels(org: string, callback: msRest.ServiceCallback<Models.Label[]>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListLabels(org: string, options: Models.GiteaAPIOrgListLabelsOptionalParams, callback: msRest.ServiceCallback<Models.Label[]>): void;
  orgListLabels(org: string, options?: Models.GiteaAPIOrgListLabelsOptionalParams | msRest.ServiceCallback<Models.Label[]>, callback?: msRest.ServiceCallback<Models.Label[]>): Promise<Models.OrgListLabelsResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgListLabelsOperationSpec,
      callback) as Promise<Models.OrgListLabelsResponse>;
  }

  /**
   * @summary Create a label for an organization
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgCreateLabelResponse>
   */
  orgCreateLabel(org: string, options?: Models.GiteaAPIOrgCreateLabelOptionalParams): Promise<Models.OrgCreateLabelResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgCreateLabel(org: string, callback: msRest.ServiceCallback<Models.Label>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgCreateLabel(org: string, options: Models.GiteaAPIOrgCreateLabelOptionalParams, callback: msRest.ServiceCallback<Models.Label>): void;
  orgCreateLabel(org: string, options?: Models.GiteaAPIOrgCreateLabelOptionalParams | msRest.ServiceCallback<Models.Label>, callback?: msRest.ServiceCallback<Models.Label>): Promise<Models.OrgCreateLabelResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgCreateLabelOperationSpec,
      callback) as Promise<Models.OrgCreateLabelResponse>;
  }

  /**
   * @summary Get a single label
   * @param org name of the organization
   * @param id id of the label to get
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgGetLabelResponse>
   */
  orgGetLabel(org: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.OrgGetLabelResponse>;
  /**
   * @param org name of the organization
   * @param id id of the label to get
   * @param callback The callback
   */
  orgGetLabel(org: string, id: number, callback: msRest.ServiceCallback<Models.Label>): void;
  /**
   * @param org name of the organization
   * @param id id of the label to get
   * @param options The optional parameters
   * @param callback The callback
   */
  orgGetLabel(org: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Label>): void;
  orgGetLabel(org: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Label>, callback?: msRest.ServiceCallback<Models.Label>): Promise<Models.OrgGetLabelResponse> {
    return this.sendOperationRequest(
      {
        org,
        id,
        options
      },
      orgGetLabelOperationSpec,
      callback) as Promise<Models.OrgGetLabelResponse>;
  }

  /**
   * @summary Delete a label
   * @param org name of the organization
   * @param id id of the label to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgDeleteLabel(org: string, id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param org name of the organization
   * @param id id of the label to delete
   * @param callback The callback
   */
  orgDeleteLabel(org: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org name of the organization
   * @param id id of the label to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  orgDeleteLabel(org: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgDeleteLabel(org: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        org,
        id,
        options
      },
      orgDeleteLabelOperationSpec,
      callback);
  }

  /**
   * @summary Update a label
   * @param org name of the organization
   * @param id id of the label to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgEditLabelResponse>
   */
  orgEditLabel(org: string, id: number, options?: Models.GiteaAPIOrgEditLabelOptionalParams): Promise<Models.OrgEditLabelResponse>;
  /**
   * @param org name of the organization
   * @param id id of the label to edit
   * @param callback The callback
   */
  orgEditLabel(org: string, id: number, callback: msRest.ServiceCallback<Models.Label>): void;
  /**
   * @param org name of the organization
   * @param id id of the label to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  orgEditLabel(org: string, id: number, options: Models.GiteaAPIOrgEditLabelOptionalParams, callback: msRest.ServiceCallback<Models.Label>): void;
  orgEditLabel(org: string, id: number, options?: Models.GiteaAPIOrgEditLabelOptionalParams | msRest.ServiceCallback<Models.Label>, callback?: msRest.ServiceCallback<Models.Label>): Promise<Models.OrgEditLabelResponse> {
    return this.sendOperationRequest(
      {
        org,
        id,
        options
      },
      orgEditLabelOperationSpec,
      callback) as Promise<Models.OrgEditLabelResponse>;
  }

  /**
   * @summary List an organization's members
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListMembersResponse>
   */
  orgListMembers(org: string, options?: Models.GiteaAPIOrgListMembersOptionalParams): Promise<Models.OrgListMembersResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgListMembers(org: string, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListMembers(org: string, options: Models.GiteaAPIOrgListMembersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  orgListMembers(org: string, options?: Models.GiteaAPIOrgListMembersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.OrgListMembersResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgListMembersOperationSpec,
      callback) as Promise<Models.OrgListMembersResponse>;
  }

  /**
   * @summary Check if a user is a member of an organization
   * @param org name of the organization
   * @param username username of the user
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgIsMember(org: string, username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param callback The callback
   */
  orgIsMember(org: string, username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param options The optional parameters
   * @param callback The callback
   */
  orgIsMember(org: string, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgIsMember(org: string, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        org,
        username,
        options
      },
      orgIsMemberOperationSpec,
      callback);
  }

  /**
   * @summary Remove a member from an organization
   * @param org name of the organization
   * @param username username of the user
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgDeleteMember(org: string, username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param callback The callback
   */
  orgDeleteMember(org: string, username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param options The optional parameters
   * @param callback The callback
   */
  orgDeleteMember(org: string, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgDeleteMember(org: string, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        org,
        username,
        options
      },
      orgDeleteMemberOperationSpec,
      callback);
  }

  /**
   * @summary List an organization's public members
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListPublicMembersResponse>
   */
  orgListPublicMembers(org: string, options?: Models.GiteaAPIOrgListPublicMembersOptionalParams): Promise<Models.OrgListPublicMembersResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgListPublicMembers(org: string, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListPublicMembers(org: string, options: Models.GiteaAPIOrgListPublicMembersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  orgListPublicMembers(org: string, options?: Models.GiteaAPIOrgListPublicMembersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.OrgListPublicMembersResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgListPublicMembersOperationSpec,
      callback) as Promise<Models.OrgListPublicMembersResponse>;
  }

  /**
   * @summary Check if a user is a public member of an organization
   * @param org name of the organization
   * @param username username of the user
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgIsPublicMember(org: string, username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param callback The callback
   */
  orgIsPublicMember(org: string, username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param options The optional parameters
   * @param callback The callback
   */
  orgIsPublicMember(org: string, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgIsPublicMember(org: string, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        org,
        username,
        options
      },
      orgIsPublicMemberOperationSpec,
      callback);
  }

  /**
   * @summary Publicize a user's membership
   * @param org name of the organization
   * @param username username of the user
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgPublicizeMemberResponse>
   */
  orgPublicizeMember(org: string, username: string, options?: msRest.RequestOptionsBase): Promise<Models.OrgPublicizeMemberResponse>;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param callback The callback
   */
  orgPublicizeMember(org: string, username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param options The optional parameters
   * @param callback The callback
   */
  orgPublicizeMember(org: string, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgPublicizeMember(org: string, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.OrgPublicizeMemberResponse> {
    return this.sendOperationRequest(
      {
        org,
        username,
        options
      },
      orgPublicizeMemberOperationSpec,
      callback) as Promise<Models.OrgPublicizeMemberResponse>;
  }

  /**
   * @summary Conceal a user's membership
   * @param org name of the organization
   * @param username username of the user
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgConcealMemberResponse>
   */
  orgConcealMember(org: string, username: string, options?: msRest.RequestOptionsBase): Promise<Models.OrgConcealMemberResponse>;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param callback The callback
   */
  orgConcealMember(org: string, username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param org name of the organization
   * @param username username of the user
   * @param options The optional parameters
   * @param callback The callback
   */
  orgConcealMember(org: string, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgConcealMember(org: string, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.OrgConcealMemberResponse> {
    return this.sendOperationRequest(
      {
        org,
        username,
        options
      },
      orgConcealMemberOperationSpec,
      callback) as Promise<Models.OrgConcealMemberResponse>;
  }

  /**
   * @summary List an organization's repos
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListReposResponse>
   */
  orgListRepos(org: string, options?: Models.GiteaAPIOrgListReposOptionalParams): Promise<Models.OrgListReposResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgListRepos(org: string, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListRepos(org: string, options: Models.GiteaAPIOrgListReposOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  orgListRepos(org: string, options?: Models.GiteaAPIOrgListReposOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.OrgListReposResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgListReposOperationSpec,
      callback) as Promise<Models.OrgListReposResponse>;
  }

  /**
   * @summary Create a repository in an organization
   * @param org name of organization
   * @param [options] The optional parameters
   * @returns Promise<Models.CreateOrgRepoResponse>
   */
  createOrgRepo(org: string, options?: Models.GiteaAPICreateOrgRepoOptionalParams): Promise<Models.CreateOrgRepoResponse>;
  /**
   * @param org name of organization
   * @param callback The callback
   */
  createOrgRepo(org: string, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param org name of organization
   * @param options The optional parameters
   * @param callback The callback
   */
  createOrgRepo(org: string, options: Models.GiteaAPICreateOrgRepoOptionalParams, callback: msRest.ServiceCallback<Models.Repository>): void;
  createOrgRepo(org: string, options?: Models.GiteaAPICreateOrgRepoOptionalParams | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.CreateOrgRepoResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      createOrgRepoOperationSpec,
      callback) as Promise<Models.CreateOrgRepoResponse>;
  }

  /**
   * @summary List an organization's teams
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListTeamsResponse>
   */
  orgListTeams(org: string, options?: Models.GiteaAPIOrgListTeamsOptionalParams): Promise<Models.OrgListTeamsResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgListTeams(org: string, callback: msRest.ServiceCallback<Models.Team[]>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListTeams(org: string, options: Models.GiteaAPIOrgListTeamsOptionalParams, callback: msRest.ServiceCallback<Models.Team[]>): void;
  orgListTeams(org: string, options?: Models.GiteaAPIOrgListTeamsOptionalParams | msRest.ServiceCallback<Models.Team[]>, callback?: msRest.ServiceCallback<Models.Team[]>): Promise<Models.OrgListTeamsResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgListTeamsOperationSpec,
      callback) as Promise<Models.OrgListTeamsResponse>;
  }

  /**
   * @summary Create a team
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgCreateTeamResponse>
   */
  orgCreateTeam(org: string, options?: Models.GiteaAPIOrgCreateTeamOptionalParams): Promise<Models.OrgCreateTeamResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  orgCreateTeam(org: string, callback: msRest.ServiceCallback<Models.Team>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  orgCreateTeam(org: string, options: Models.GiteaAPIOrgCreateTeamOptionalParams, callback: msRest.ServiceCallback<Models.Team>): void;
  orgCreateTeam(org: string, options?: Models.GiteaAPIOrgCreateTeamOptionalParams | msRest.ServiceCallback<Models.Team>, callback?: msRest.ServiceCallback<Models.Team>): Promise<Models.OrgCreateTeamResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      orgCreateTeamOperationSpec,
      callback) as Promise<Models.OrgCreateTeamResponse>;
  }

  /**
   * @summary Search for teams within an organization
   * @param org name of the organization
   * @param [options] The optional parameters
   * @returns Promise<Models.TeamSearchResponse>
   */
  teamSearch(org: string, options?: Models.GiteaAPITeamSearchOptionalParams): Promise<Models.TeamSearchResponse>;
  /**
   * @param org name of the organization
   * @param callback The callback
   */
  teamSearch(org: string, callback: msRest.ServiceCallback<Models.TeamSearchOKResponse>): void;
  /**
   * @param org name of the organization
   * @param options The optional parameters
   * @param callback The callback
   */
  teamSearch(org: string, options: Models.GiteaAPITeamSearchOptionalParams, callback: msRest.ServiceCallback<Models.TeamSearchOKResponse>): void;
  teamSearch(org: string, options?: Models.GiteaAPITeamSearchOptionalParams | msRest.ServiceCallback<Models.TeamSearchOKResponse>, callback?: msRest.ServiceCallback<Models.TeamSearchOKResponse>): Promise<Models.TeamSearchResponse> {
    return this.sendOperationRequest(
      {
        org,
        options
      },
      teamSearchOperationSpec,
      callback) as Promise<Models.TeamSearchResponse>;
  }

  /**
   * @summary Search for issues across the repositories that the user has access to
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueSearchIssuesResponse>
   */
  issueSearchIssues(options?: Models.GiteaAPIIssueSearchIssuesOptionalParams): Promise<Models.IssueSearchIssuesResponse>;
  /**
   * @param callback The callback
   */
  issueSearchIssues(callback: msRest.ServiceCallback<Models.Issue[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  issueSearchIssues(options: Models.GiteaAPIIssueSearchIssuesOptionalParams, callback: msRest.ServiceCallback<Models.Issue[]>): void;
  issueSearchIssues(options?: Models.GiteaAPIIssueSearchIssuesOptionalParams | msRest.ServiceCallback<Models.Issue[]>, callback?: msRest.ServiceCallback<Models.Issue[]>): Promise<Models.IssueSearchIssuesResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      issueSearchIssuesOperationSpec,
      callback) as Promise<Models.IssueSearchIssuesResponse>;
  }

  /**
   * @summary Migrate a remote git repository
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoMigrateResponse>
   */
  repoMigrate(options?: Models.GiteaAPIRepoMigrateOptionalParams): Promise<Models.RepoMigrateResponse>;
  /**
   * @param callback The callback
   */
  repoMigrate(callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  repoMigrate(options: Models.GiteaAPIRepoMigrateOptionalParams, callback: msRest.ServiceCallback<Models.Repository>): void;
  repoMigrate(options?: Models.GiteaAPIRepoMigrateOptionalParams | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.RepoMigrateResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      repoMigrateOperationSpec,
      callback) as Promise<Models.RepoMigrateResponse>;
  }

  /**
   * @summary Search for repositories
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoSearchResponse>
   */
  repoSearch(options?: Models.GiteaAPIRepoSearchOptionalParams): Promise<Models.RepoSearchResponse>;
  /**
   * @param callback The callback
   */
  repoSearch(callback: msRest.ServiceCallback<Models.SearchResults>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  repoSearch(options: Models.GiteaAPIRepoSearchOptionalParams, callback: msRest.ServiceCallback<Models.SearchResults>): void;
  repoSearch(options?: Models.GiteaAPIRepoSearchOptionalParams | msRest.ServiceCallback<Models.SearchResults>, callback?: msRest.ServiceCallback<Models.SearchResults>): Promise<Models.RepoSearchResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      repoSearchOperationSpec,
      callback) as Promise<Models.RepoSearchResponse>;
  }

  /**
   * @summary Get a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetResponse>
   */
  repoGet(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoGet(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGet(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Repository>): void;
  repoGet(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.RepoGetResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoGetOperationSpec,
      callback) as Promise<Models.RepoGetResponse>;
  }

  /**
   * @summary Delete a repository
   * @param owner owner of the repo to delete
   * @param repo name of the repo to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoDeleteResponse>
   */
  repoDelete(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoDeleteResponse>;
  /**
   * @param owner owner of the repo to delete
   * @param repo name of the repo to delete
   * @param callback The callback
   */
  repoDelete(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo to delete
   * @param repo name of the repo to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDelete(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDelete(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoDeleteResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoDeleteOperationSpec,
      callback) as Promise<Models.RepoDeleteResponse>;
  }

  /**
   * @summary Edit a repository's properties. Only fields that are set will be changed.
   * @param owner owner of the repo to edit
   * @param repo name of the repo to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoEditResponse>
   */
  repoEdit(owner: string, repo: string, options?: Models.GiteaAPIRepoEditOptionalParams): Promise<Models.RepoEditResponse>;
  /**
   * @param owner owner of the repo to edit
   * @param repo name of the repo to edit
   * @param callback The callback
   */
  repoEdit(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param owner owner of the repo to edit
   * @param repo name of the repo to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  repoEdit(owner: string, repo: string, options: Models.GiteaAPIRepoEditOptionalParams, callback: msRest.ServiceCallback<Models.Repository>): void;
  repoEdit(owner: string, repo: string, options?: Models.GiteaAPIRepoEditOptionalParams | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.RepoEditResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoEditOperationSpec,
      callback) as Promise<Models.RepoEditResponse>;
  }

  /**
   * @summary Get an archive of a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param archive archive to download, consisting of a git reference and archive
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoGetArchive(owner: string, repo: string, archive: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param archive archive to download, consisting of a git reference and archive
   * @param callback The callback
   */
  repoGetArchive(owner: string, repo: string, archive: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param archive archive to download, consisting of a git reference and archive
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetArchive(owner: string, repo: string, archive: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoGetArchive(owner: string, repo: string, archive: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        archive,
        options
      },
      repoGetArchiveOperationSpec,
      callback);
  }

  /**
   * @summary List branch protections for a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListBranchProtectionResponse>
   */
  repoListBranchProtection(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoListBranchProtectionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListBranchProtection(owner: string, repo: string, callback: msRest.ServiceCallback<Models.BranchProtection[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListBranchProtection(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.BranchProtection[]>): void;
  repoListBranchProtection(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.BranchProtection[]>, callback?: msRest.ServiceCallback<Models.BranchProtection[]>): Promise<Models.RepoListBranchProtectionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListBranchProtectionOperationSpec,
      callback) as Promise<Models.RepoListBranchProtectionResponse>;
  }

  /**
   * @summary Create a branch protections for a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreateBranchProtectionResponse>
   */
  repoCreateBranchProtection(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateBranchProtectionOptionalParams): Promise<Models.RepoCreateBranchProtectionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoCreateBranchProtection(owner: string, repo: string, callback: msRest.ServiceCallback<Models.BranchProtection>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreateBranchProtection(owner: string, repo: string, options: Models.GiteaAPIRepoCreateBranchProtectionOptionalParams, callback: msRest.ServiceCallback<Models.BranchProtection>): void;
  repoCreateBranchProtection(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateBranchProtectionOptionalParams | msRest.ServiceCallback<Models.BranchProtection>, callback?: msRest.ServiceCallback<Models.BranchProtection>): Promise<Models.RepoCreateBranchProtectionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoCreateBranchProtectionOperationSpec,
      callback) as Promise<Models.RepoCreateBranchProtectionResponse>;
  }

  /**
   * @summary Get a specific branch protection for the repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetBranchProtectionResponse>
   */
  repoGetBranchProtection(owner: string, repo: string, name: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetBranchProtectionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param callback The callback
   */
  repoGetBranchProtection(owner: string, repo: string, name: string, callback: msRest.ServiceCallback<Models.BranchProtection>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetBranchProtection(owner: string, repo: string, name: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.BranchProtection>): void;
  repoGetBranchProtection(owner: string, repo: string, name: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.BranchProtection>, callback?: msRest.ServiceCallback<Models.BranchProtection>): Promise<Models.RepoGetBranchProtectionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        name,
        options
      },
      repoGetBranchProtectionOperationSpec,
      callback) as Promise<Models.RepoGetBranchProtectionResponse>;
  }

  /**
   * @summary Delete a specific branch protection for the repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoDeleteBranchProtection(owner: string, repo: string, name: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param callback The callback
   */
  repoDeleteBranchProtection(owner: string, repo: string, name: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteBranchProtection(owner: string, repo: string, name: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteBranchProtection(owner: string, repo: string, name: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        name,
        options
      },
      repoDeleteBranchProtectionOperationSpec,
      callback);
  }

  /**
   * @summary Edit a branch protections for a repository. Only fields that are set will be changed
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoEditBranchProtectionResponse>
   */
  repoEditBranchProtection(owner: string, repo: string, name: string, options?: Models.GiteaAPIRepoEditBranchProtectionOptionalParams): Promise<Models.RepoEditBranchProtectionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param callback The callback
   */
  repoEditBranchProtection(owner: string, repo: string, name: string, callback: msRest.ServiceCallback<Models.BranchProtection>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param name name of protected branch
   * @param options The optional parameters
   * @param callback The callback
   */
  repoEditBranchProtection(owner: string, repo: string, name: string, options: Models.GiteaAPIRepoEditBranchProtectionOptionalParams, callback: msRest.ServiceCallback<Models.BranchProtection>): void;
  repoEditBranchProtection(owner: string, repo: string, name: string, options?: Models.GiteaAPIRepoEditBranchProtectionOptionalParams | msRest.ServiceCallback<Models.BranchProtection>, callback?: msRest.ServiceCallback<Models.BranchProtection>): Promise<Models.RepoEditBranchProtectionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        name,
        options
      },
      repoEditBranchProtectionOperationSpec,
      callback) as Promise<Models.RepoEditBranchProtectionResponse>;
  }

  /**
   * @summary List a repository's branches
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListBranchesResponse>
   */
  repoListBranches(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoListBranchesResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListBranches(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Branch[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListBranches(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Branch[]>): void;
  repoListBranches(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Branch[]>, callback?: msRest.ServiceCallback<Models.Branch[]>): Promise<Models.RepoListBranchesResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListBranchesOperationSpec,
      callback) as Promise<Models.RepoListBranchesResponse>;
  }

  /**
   * @summary Retrieve a specific branch from a repository, including its effective branch protection
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param branch branch to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetBranchResponse>
   */
  repoGetBranch(owner: string, repo: string, branch: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetBranchResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param branch branch to get
   * @param callback The callback
   */
  repoGetBranch(owner: string, repo: string, branch: string, callback: msRest.ServiceCallback<Models.Branch>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param branch branch to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetBranch(owner: string, repo: string, branch: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Branch>): void;
  repoGetBranch(owner: string, repo: string, branch: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Branch>, callback?: msRest.ServiceCallback<Models.Branch>): Promise<Models.RepoGetBranchResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        branch,
        options
      },
      repoGetBranchOperationSpec,
      callback) as Promise<Models.RepoGetBranchResponse>;
  }

  /**
   * @summary Delete a specific branch from a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param branch branch to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoDeleteBranchResponse>
   */
  repoDeleteBranch(owner: string, repo: string, branch: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoDeleteBranchResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param branch branch to delete
   * @param callback The callback
   */
  repoDeleteBranch(owner: string, repo: string, branch: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param branch branch to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteBranch(owner: string, repo: string, branch: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteBranch(owner: string, repo: string, branch: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoDeleteBranchResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        branch,
        options
      },
      repoDeleteBranchOperationSpec,
      callback) as Promise<Models.RepoDeleteBranchResponse>;
  }

  /**
   * @summary List a repository's collaborators
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListCollaboratorsResponse>
   */
  repoListCollaborators(owner: string, repo: string, options?: Models.GiteaAPIRepoListCollaboratorsOptionalParams): Promise<Models.RepoListCollaboratorsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListCollaborators(owner: string, repo: string, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListCollaborators(owner: string, repo: string, options: Models.GiteaAPIRepoListCollaboratorsOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  repoListCollaborators(owner: string, repo: string, options?: Models.GiteaAPIRepoListCollaboratorsOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.RepoListCollaboratorsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListCollaboratorsOperationSpec,
      callback) as Promise<Models.RepoListCollaboratorsResponse>;
  }

  /**
   * @summary Check if a user is a collaborator of a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCheckCollaboratorResponse>
   */
  repoCheckCollaborator(owner: string, repo: string, collaborator: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoCheckCollaboratorResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator
   * @param callback The callback
   */
  repoCheckCollaborator(owner: string, repo: string, collaborator: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCheckCollaborator(owner: string, repo: string, collaborator: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoCheckCollaborator(owner: string, repo: string, collaborator: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoCheckCollaboratorResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        collaborator,
        options
      },
      repoCheckCollaboratorOperationSpec,
      callback) as Promise<Models.RepoCheckCollaboratorResponse>;
  }

  /**
   * @summary Add a collaborator to a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator to add
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoAddCollaboratorResponse>
   */
  repoAddCollaborator(owner: string, repo: string, collaborator: string, options?: Models.GiteaAPIRepoAddCollaboratorOptionalParams): Promise<Models.RepoAddCollaboratorResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator to add
   * @param callback The callback
   */
  repoAddCollaborator(owner: string, repo: string, collaborator: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator to add
   * @param options The optional parameters
   * @param callback The callback
   */
  repoAddCollaborator(owner: string, repo: string, collaborator: string, options: Models.GiteaAPIRepoAddCollaboratorOptionalParams, callback: msRest.ServiceCallback<void>): void;
  repoAddCollaborator(owner: string, repo: string, collaborator: string, options?: Models.GiteaAPIRepoAddCollaboratorOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoAddCollaboratorResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        collaborator,
        options
      },
      repoAddCollaboratorOperationSpec,
      callback) as Promise<Models.RepoAddCollaboratorResponse>;
  }

  /**
   * @summary Delete a collaborator from a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoDeleteCollaboratorResponse>
   */
  repoDeleteCollaborator(owner: string, repo: string, collaborator: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoDeleteCollaboratorResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator to delete
   * @param callback The callback
   */
  repoDeleteCollaborator(owner: string, repo: string, collaborator: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param collaborator username of the collaborator to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteCollaborator(owner: string, repo: string, collaborator: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteCollaborator(owner: string, repo: string, collaborator: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoDeleteCollaboratorResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        collaborator,
        options
      },
      repoDeleteCollaboratorOperationSpec,
      callback) as Promise<Models.RepoDeleteCollaboratorResponse>;
  }

  /**
   * @summary Get a list of all commits from a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetAllCommitsResponse>
   */
  repoGetAllCommits(owner: string, repo: string, options?: Models.GiteaAPIRepoGetAllCommitsOptionalParams): Promise<Models.RepoGetAllCommitsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoGetAllCommits(owner: string, repo: string, callback: msRest.ServiceCallback<any>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetAllCommits(owner: string, repo: string, options: Models.GiteaAPIRepoGetAllCommitsOptionalParams, callback: msRest.ServiceCallback<any>): void;
  repoGetAllCommits(owner: string, repo: string, options?: Models.GiteaAPIRepoGetAllCommitsOptionalParams | msRest.ServiceCallback<any>, callback?: msRest.ServiceCallback<any>): Promise<Models.RepoGetAllCommitsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoGetAllCommitsOperationSpec,
      callback) as Promise<Models.RepoGetAllCommitsResponse>;
  }

  /**
   * @summary Get a commit's combined status, by branch/tag/commit reference
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param ref name of branch/tag/commit
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetCombinedStatusByRefResponse>
   */
  repoGetCombinedStatusByRef(owner: string, repo: string, ref: string, options?: Models.GiteaAPIRepoGetCombinedStatusByRefOptionalParams): Promise<Models.RepoGetCombinedStatusByRefResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param ref name of branch/tag/commit
   * @param callback The callback
   */
  repoGetCombinedStatusByRef(owner: string, repo: string, ref: string, callback: msRest.ServiceCallback<Models.Status>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param ref name of branch/tag/commit
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetCombinedStatusByRef(owner: string, repo: string, ref: string, options: Models.GiteaAPIRepoGetCombinedStatusByRefOptionalParams, callback: msRest.ServiceCallback<Models.Status>): void;
  repoGetCombinedStatusByRef(owner: string, repo: string, ref: string, options?: Models.GiteaAPIRepoGetCombinedStatusByRefOptionalParams | msRest.ServiceCallback<Models.Status>, callback?: msRest.ServiceCallback<Models.Status>): Promise<Models.RepoGetCombinedStatusByRefResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        ref,
        options
      },
      repoGetCombinedStatusByRefOperationSpec,
      callback) as Promise<Models.RepoGetCombinedStatusByRefResponse>;
  }

  /**
   * @summary Gets the metadata of all the entries of the root dir
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetContentsListResponse>
   */
  repoGetContentsList(owner: string, repo: string, options?: Models.GiteaAPIRepoGetContentsListOptionalParams): Promise<Models.RepoGetContentsListResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoGetContentsList(owner: string, repo: string, callback: msRest.ServiceCallback<Models.ContentsResponse[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetContentsList(owner: string, repo: string, options: Models.GiteaAPIRepoGetContentsListOptionalParams, callback: msRest.ServiceCallback<Models.ContentsResponse[]>): void;
  repoGetContentsList(owner: string, repo: string, options?: Models.GiteaAPIRepoGetContentsListOptionalParams | msRest.ServiceCallback<Models.ContentsResponse[]>, callback?: msRest.ServiceCallback<Models.ContentsResponse[]>): Promise<Models.RepoGetContentsListResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoGetContentsListOperationSpec,
      callback) as Promise<Models.RepoGetContentsListResponse>;
  }

  /**
   * @summary Gets the metadata and contents (if a file) of an entry in a repository, or a list of
   * entries if a dir
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the dir, file, symlink or submodule in the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetContentsResponse>
   */
  repoGetContents(owner: string, repo: string, filepath: string, options?: Models.GiteaAPIRepoGetContentsOptionalParams): Promise<Models.RepoGetContentsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the dir, file, symlink or submodule in the repo
   * @param callback The callback
   */
  repoGetContents(owner: string, repo: string, filepath: string, callback: msRest.ServiceCallback<Models.ContentsResponse>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the dir, file, symlink or submodule in the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetContents(owner: string, repo: string, filepath: string, options: Models.GiteaAPIRepoGetContentsOptionalParams, callback: msRest.ServiceCallback<Models.ContentsResponse>): void;
  repoGetContents(owner: string, repo: string, filepath: string, options?: Models.GiteaAPIRepoGetContentsOptionalParams | msRest.ServiceCallback<Models.ContentsResponse>, callback?: msRest.ServiceCallback<Models.ContentsResponse>): Promise<Models.RepoGetContentsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        filepath,
        options
      },
      repoGetContentsOperationSpec,
      callback) as Promise<Models.RepoGetContentsResponse>;
  }

  /**
   * @summary Update a file in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to update
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoUpdateFileResponse>
   */
  repoUpdateFile(owner: string, repo: string, filepath: string, body: Models.UpdateFileOptions, options?: msRest.RequestOptionsBase): Promise<Models.RepoUpdateFileResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to update
   * @param body
   * @param callback The callback
   */
  repoUpdateFile(owner: string, repo: string, filepath: string, body: Models.UpdateFileOptions, callback: msRest.ServiceCallback<Models.FileResponse>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to update
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  repoUpdateFile(owner: string, repo: string, filepath: string, body: Models.UpdateFileOptions, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.FileResponse>): void;
  repoUpdateFile(owner: string, repo: string, filepath: string, body: Models.UpdateFileOptions, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.FileResponse>, callback?: msRest.ServiceCallback<Models.FileResponse>): Promise<Models.RepoUpdateFileResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        filepath,
        body,
        options
      },
      repoUpdateFileOperationSpec,
      callback) as Promise<Models.RepoUpdateFileResponse>;
  }

  /**
   * @summary Create a file in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to create
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreateFileResponse>
   */
  repoCreateFile(owner: string, repo: string, filepath: string, body: Models.CreateFileOptions, options?: msRest.RequestOptionsBase): Promise<Models.RepoCreateFileResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to create
   * @param body
   * @param callback The callback
   */
  repoCreateFile(owner: string, repo: string, filepath: string, body: Models.CreateFileOptions, callback: msRest.ServiceCallback<Models.FileResponse>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to create
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreateFile(owner: string, repo: string, filepath: string, body: Models.CreateFileOptions, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.FileResponse>): void;
  repoCreateFile(owner: string, repo: string, filepath: string, body: Models.CreateFileOptions, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.FileResponse>, callback?: msRest.ServiceCallback<Models.FileResponse>): Promise<Models.RepoCreateFileResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        filepath,
        body,
        options
      },
      repoCreateFileOperationSpec,
      callback) as Promise<Models.RepoCreateFileResponse>;
  }

  /**
   * @summary Delete a file in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to delete
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoDeleteFileResponse>
   */
  repoDeleteFile(owner: string, repo: string, filepath: string, body: Models.DeleteFileOptions, options?: msRest.RequestOptionsBase): Promise<Models.RepoDeleteFileResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to delete
   * @param body
   * @param callback The callback
   */
  repoDeleteFile(owner: string, repo: string, filepath: string, body: Models.DeleteFileOptions, callback: msRest.ServiceCallback<Models.FileDeleteResponse>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath path of the file to delete
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteFile(owner: string, repo: string, filepath: string, body: Models.DeleteFileOptions, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.FileDeleteResponse>): void;
  repoDeleteFile(owner: string, repo: string, filepath: string, body: Models.DeleteFileOptions, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.FileDeleteResponse>, callback?: msRest.ServiceCallback<Models.FileDeleteResponse>): Promise<Models.RepoDeleteFileResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        filepath,
        body,
        options
      },
      repoDeleteFileOperationSpec,
      callback) as Promise<Models.RepoDeleteFileResponse>;
  }

  /**
   * @summary Get the EditorConfig definitions of a file in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath filepath of file to get
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoGetEditorConfig(owner: string, repo: string, filepath: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath filepath of file to get
   * @param callback The callback
   */
  repoGetEditorConfig(owner: string, repo: string, filepath: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath filepath of file to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetEditorConfig(owner: string, repo: string, filepath: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoGetEditorConfig(owner: string, repo: string, filepath: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        filepath,
        options
      },
      repoGetEditorConfigOperationSpec,
      callback);
  }

  /**
   * @summary List a repository's forks
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.ListForksResponse>
   */
  listForks(owner: string, repo: string, options?: Models.GiteaAPIListForksOptionalParams): Promise<Models.ListForksResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  listForks(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  listForks(owner: string, repo: string, options: Models.GiteaAPIListForksOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  listForks(owner: string, repo: string, options?: Models.GiteaAPIListForksOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.ListForksResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      listForksOperationSpec,
      callback) as Promise<Models.ListForksResponse>;
  }

  /**
   * @summary Fork a repository
   * @param owner owner of the repo to fork
   * @param repo name of the repo to fork
   * @param [options] The optional parameters
   * @returns Promise<Models.CreateForkResponse>
   */
  createFork(owner: string, repo: string, options?: Models.GiteaAPICreateForkOptionalParams): Promise<Models.CreateForkResponse>;
  /**
   * @param owner owner of the repo to fork
   * @param repo name of the repo to fork
   * @param callback The callback
   */
  createFork(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param owner owner of the repo to fork
   * @param repo name of the repo to fork
   * @param options The optional parameters
   * @param callback The callback
   */
  createFork(owner: string, repo: string, options: Models.GiteaAPICreateForkOptionalParams, callback: msRest.ServiceCallback<Models.Repository>): void;
  createFork(owner: string, repo: string, options?: Models.GiteaAPICreateForkOptionalParams | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.CreateForkResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      createForkOperationSpec,
      callback) as Promise<Models.CreateForkResponse>;
  }

  /**
   * @summary Gets the blob of a repository.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param [options] The optional parameters
   * @returns Promise<Models.GetBlobResponse>
   */
  getBlob(owner: string, repo: string, sha: string, options?: msRest.RequestOptionsBase): Promise<Models.GetBlobResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param callback The callback
   */
  getBlob(owner: string, repo: string, sha: string, callback: msRest.ServiceCallback<Models.GitBlobResponse>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param options The optional parameters
   * @param callback The callback
   */
  getBlob(owner: string, repo: string, sha: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.GitBlobResponse>): void;
  getBlob(owner: string, repo: string, sha: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.GitBlobResponse>, callback?: msRest.ServiceCallback<Models.GitBlobResponse>): Promise<Models.GetBlobResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        sha,
        options
      },
      getBlobOperationSpec,
      callback) as Promise<Models.GetBlobResponse>;
  }

  /**
   * @summary Get a single commit from a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha a git ref or commit sha
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetSingleCommitResponse>
   */
  repoGetSingleCommit(owner: string, repo: string, sha: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetSingleCommitResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha a git ref or commit sha
   * @param callback The callback
   */
  repoGetSingleCommit(owner: string, repo: string, sha: string, callback: msRest.ServiceCallback<Models.Commit>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha a git ref or commit sha
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetSingleCommit(owner: string, repo: string, sha: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Commit>): void;
  repoGetSingleCommit(owner: string, repo: string, sha: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Commit>, callback?: msRest.ServiceCallback<Models.Commit>): Promise<Models.RepoGetSingleCommitResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        sha,
        options
      },
      repoGetSingleCommitOperationSpec,
      callback) as Promise<Models.RepoGetSingleCommitResponse>;
  }

  /**
   * @summary Get specified ref or filtered repository's refs
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListAllGitRefsResponse>
   */
  repoListAllGitRefs(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoListAllGitRefsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListAllGitRefs(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Reference[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListAllGitRefs(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Reference[]>): void;
  repoListAllGitRefs(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Reference[]>, callback?: msRest.ServiceCallback<Models.Reference[]>): Promise<Models.RepoListAllGitRefsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListAllGitRefsOperationSpec,
      callback) as Promise<Models.RepoListAllGitRefsResponse>;
  }

  /**
   * @summary Get specified ref or filtered repository's refs
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param ref part or full name of the ref
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListGitRefsResponse>
   */
  repoListGitRefs(owner: string, repo: string, ref: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoListGitRefsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param ref part or full name of the ref
   * @param callback The callback
   */
  repoListGitRefs(owner: string, repo: string, ref: string, callback: msRest.ServiceCallback<Models.Reference[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param ref part or full name of the ref
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListGitRefs(owner: string, repo: string, ref: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Reference[]>): void;
  repoListGitRefs(owner: string, repo: string, ref: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Reference[]>, callback?: msRest.ServiceCallback<Models.Reference[]>): Promise<Models.RepoListGitRefsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        ref,
        options
      },
      repoListGitRefsOperationSpec,
      callback) as Promise<Models.RepoListGitRefsResponse>;
  }

  /**
   * @summary Gets the tag object of an annotated tag (not lightweight tags)
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the tag. The Git tags API only supports annotated tag objects, not lightweight
   * tags.
   * @param [options] The optional parameters
   * @returns Promise<Models.GetTagResponse>
   */
  getTag(owner: string, repo: string, sha: string, options?: msRest.RequestOptionsBase): Promise<Models.GetTagResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the tag. The Git tags API only supports annotated tag objects, not lightweight
   * tags.
   * @param callback The callback
   */
  getTag(owner: string, repo: string, sha: string, callback: msRest.ServiceCallback<Models.AnnotatedTag>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the tag. The Git tags API only supports annotated tag objects, not lightweight
   * tags.
   * @param options The optional parameters
   * @param callback The callback
   */
  getTag(owner: string, repo: string, sha: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AnnotatedTag>): void;
  getTag(owner: string, repo: string, sha: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.AnnotatedTag>, callback?: msRest.ServiceCallback<Models.AnnotatedTag>): Promise<Models.GetTagResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        sha,
        options
      },
      getTagOperationSpec,
      callback) as Promise<Models.GetTagResponse>;
  }

  /**
   * @summary Gets the tree of a repository.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param [options] The optional parameters
   * @returns Promise<Models.GetTreeResponse>
   */
  getTree(owner: string, repo: string, sha: string, options?: Models.GiteaAPIGetTreeOptionalParams): Promise<Models.GetTreeResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param callback The callback
   */
  getTree(owner: string, repo: string, sha: string, callback: msRest.ServiceCallback<Models.GitTreeResponse>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param options The optional parameters
   * @param callback The callback
   */
  getTree(owner: string, repo: string, sha: string, options: Models.GiteaAPIGetTreeOptionalParams, callback: msRest.ServiceCallback<Models.GitTreeResponse>): void;
  getTree(owner: string, repo: string, sha: string, options?: Models.GiteaAPIGetTreeOptionalParams | msRest.ServiceCallback<Models.GitTreeResponse>, callback?: msRest.ServiceCallback<Models.GitTreeResponse>): Promise<Models.GetTreeResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        sha,
        options
      },
      getTreeOperationSpec,
      callback) as Promise<Models.GetTreeResponse>;
  }

  /**
   * @summary List the hooks in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListHooksResponse>
   */
  repoListHooks(owner: string, repo: string, options?: Models.GiteaAPIRepoListHooksOptionalParams): Promise<Models.RepoListHooksResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListHooks(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Hook[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListHooks(owner: string, repo: string, options: Models.GiteaAPIRepoListHooksOptionalParams, callback: msRest.ServiceCallback<Models.Hook[]>): void;
  repoListHooks(owner: string, repo: string, options?: Models.GiteaAPIRepoListHooksOptionalParams | msRest.ServiceCallback<Models.Hook[]>, callback?: msRest.ServiceCallback<Models.Hook[]>): Promise<Models.RepoListHooksResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListHooksOperationSpec,
      callback) as Promise<Models.RepoListHooksResponse>;
  }

  /**
   * @summary Create a hook
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreateHookResponse>
   */
  repoCreateHook(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateHookOptionalParams): Promise<Models.RepoCreateHookResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoCreateHook(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Hook>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreateHook(owner: string, repo: string, options: Models.GiteaAPIRepoCreateHookOptionalParams, callback: msRest.ServiceCallback<Models.Hook>): void;
  repoCreateHook(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateHookOptionalParams | msRest.ServiceCallback<Models.Hook>, callback?: msRest.ServiceCallback<Models.Hook>): Promise<Models.RepoCreateHookResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoCreateHookOperationSpec,
      callback) as Promise<Models.RepoCreateHookResponse>;
  }

  /**
   * @summary List the Git hooks in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListGitHooksResponse>
   */
  repoListGitHooks(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoListGitHooksResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListGitHooks(owner: string, repo: string, callback: msRest.ServiceCallback<Models.GitHook[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListGitHooks(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.GitHook[]>): void;
  repoListGitHooks(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.GitHook[]>, callback?: msRest.ServiceCallback<Models.GitHook[]>): Promise<Models.RepoListGitHooksResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListGitHooksOperationSpec,
      callback) as Promise<Models.RepoListGitHooksResponse>;
  }

  /**
   * @summary Get a Git hook
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetGitHookResponse>
   */
  repoGetGitHook(owner: string, repo: string, id: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetGitHookResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param callback The callback
   */
  repoGetGitHook(owner: string, repo: string, id: string, callback: msRest.ServiceCallback<Models.GitHook>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetGitHook(owner: string, repo: string, id: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.GitHook>): void;
  repoGetGitHook(owner: string, repo: string, id: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.GitHook>, callback?: msRest.ServiceCallback<Models.GitHook>): Promise<Models.RepoGetGitHookResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoGetGitHookOperationSpec,
      callback) as Promise<Models.RepoGetGitHookResponse>;
  }

  /**
   * @summary Delete a Git hook in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoDeleteGitHook(owner: string, repo: string, id: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param callback The callback
   */
  repoDeleteGitHook(owner: string, repo: string, id: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteGitHook(owner: string, repo: string, id: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteGitHook(owner: string, repo: string, id: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoDeleteGitHookOperationSpec,
      callback);
  }

  /**
   * @summary Edit a Git hook in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoEditGitHookResponse>
   */
  repoEditGitHook(owner: string, repo: string, id: string, options?: Models.GiteaAPIRepoEditGitHookOptionalParams): Promise<Models.RepoEditGitHookResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param callback The callback
   */
  repoEditGitHook(owner: string, repo: string, id: string, callback: msRest.ServiceCallback<Models.GitHook>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoEditGitHook(owner: string, repo: string, id: string, options: Models.GiteaAPIRepoEditGitHookOptionalParams, callback: msRest.ServiceCallback<Models.GitHook>): void;
  repoEditGitHook(owner: string, repo: string, id: string, options?: Models.GiteaAPIRepoEditGitHookOptionalParams | msRest.ServiceCallback<Models.GitHook>, callback?: msRest.ServiceCallback<Models.GitHook>): Promise<Models.RepoEditGitHookResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoEditGitHookOperationSpec,
      callback) as Promise<Models.RepoEditGitHookResponse>;
  }

  /**
   * @summary Get a hook
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetHookResponse>
   */
  repoGetHook(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetHookResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param callback The callback
   */
  repoGetHook(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Hook>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetHook(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Hook>): void;
  repoGetHook(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Hook>, callback?: msRest.ServiceCallback<Models.Hook>): Promise<Models.RepoGetHookResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoGetHookOperationSpec,
      callback) as Promise<Models.RepoGetHookResponse>;
  }

  /**
   * @summary Delete a hook in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoDeleteHook(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to delete
   * @param callback The callback
   */
  repoDeleteHook(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteHook(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteHook(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoDeleteHookOperationSpec,
      callback);
  }

  /**
   * @summary Edit a hook in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id index of the hook
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoEditHookResponse>
   */
  repoEditHook(owner: string, repo: string, id: number, options?: Models.GiteaAPIRepoEditHookOptionalParams): Promise<Models.RepoEditHookResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id index of the hook
   * @param callback The callback
   */
  repoEditHook(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Hook>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id index of the hook
   * @param options The optional parameters
   * @param callback The callback
   */
  repoEditHook(owner: string, repo: string, id: number, options: Models.GiteaAPIRepoEditHookOptionalParams, callback: msRest.ServiceCallback<Models.Hook>): void;
  repoEditHook(owner: string, repo: string, id: number, options?: Models.GiteaAPIRepoEditHookOptionalParams | msRest.ServiceCallback<Models.Hook>, callback?: msRest.ServiceCallback<Models.Hook>): Promise<Models.RepoEditHookResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoEditHookOperationSpec,
      callback) as Promise<Models.RepoEditHookResponse>;
  }

  /**
   * @summary Test a push webhook
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to test
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoTestHook(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to test
   * @param callback The callback
   */
  repoTestHook(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the hook to test
   * @param options The optional parameters
   * @param callback The callback
   */
  repoTestHook(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoTestHook(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoTestHookOperationSpec,
      callback);
  }

  /**
   * @summary List a repository's issues
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueListIssuesResponse>
   */
  issueListIssues(owner: string, repo: string, options?: Models.GiteaAPIIssueListIssuesOptionalParams): Promise<Models.IssueListIssuesResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  issueListIssues(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Issue[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  issueListIssues(owner: string, repo: string, options: Models.GiteaAPIIssueListIssuesOptionalParams, callback: msRest.ServiceCallback<Models.Issue[]>): void;
  issueListIssues(owner: string, repo: string, options?: Models.GiteaAPIIssueListIssuesOptionalParams | msRest.ServiceCallback<Models.Issue[]>, callback?: msRest.ServiceCallback<Models.Issue[]>): Promise<Models.IssueListIssuesResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      issueListIssuesOperationSpec,
      callback) as Promise<Models.IssueListIssuesResponse>;
  }

  /**
   * @summary Create an issue. If using deadline only the date will be taken into account, and time
   * of day ignored.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueCreateIssueResponse>
   */
  issueCreateIssue(owner: string, repo: string, options?: Models.GiteaAPIIssueCreateIssueOptionalParams): Promise<Models.IssueCreateIssueResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  issueCreateIssue(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Issue>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  issueCreateIssue(owner: string, repo: string, options: Models.GiteaAPIIssueCreateIssueOptionalParams, callback: msRest.ServiceCallback<Models.Issue>): void;
  issueCreateIssue(owner: string, repo: string, options?: Models.GiteaAPIIssueCreateIssueOptionalParams | msRest.ServiceCallback<Models.Issue>, callback?: msRest.ServiceCallback<Models.Issue>): Promise<Models.IssueCreateIssueResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      issueCreateIssueOperationSpec,
      callback) as Promise<Models.IssueCreateIssueResponse>;
  }

  /**
   * @summary List all comments in a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetRepoCommentsResponse>
   */
  issueGetRepoComments(owner: string, repo: string, options?: Models.GiteaAPIIssueGetRepoCommentsOptionalParams): Promise<Models.IssueGetRepoCommentsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  issueGetRepoComments(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Comment[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetRepoComments(owner: string, repo: string, options: Models.GiteaAPIIssueGetRepoCommentsOptionalParams, callback: msRest.ServiceCallback<Models.Comment[]>): void;
  issueGetRepoComments(owner: string, repo: string, options?: Models.GiteaAPIIssueGetRepoCommentsOptionalParams | msRest.ServiceCallback<Models.Comment[]>, callback?: msRest.ServiceCallback<Models.Comment[]>): Promise<Models.IssueGetRepoCommentsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      issueGetRepoCommentsOperationSpec,
      callback) as Promise<Models.IssueGetRepoCommentsResponse>;
  }

  /**
   * @summary Get a comment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetCommentResponse>
   */
  issueGetComment(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueGetCommentResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment
   * @param callback The callback
   */
  issueGetComment(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Comment>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetComment(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Comment>): void;
  issueGetComment(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Comment>, callback?: msRest.ServiceCallback<Models.Comment>): Promise<Models.IssueGetCommentResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueGetCommentOperationSpec,
      callback) as Promise<Models.IssueGetCommentResponse>;
  }

  /**
   * @summary Delete a comment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of comment to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueDeleteCommentResponse>
   */
  issueDeleteComment(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueDeleteCommentResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of comment to delete
   * @param callback The callback
   */
  issueDeleteComment(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of comment to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteComment(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueDeleteComment(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueDeleteCommentResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueDeleteCommentOperationSpec,
      callback) as Promise<Models.IssueDeleteCommentResponse>;
  }

  /**
   * @summary Edit a comment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueEditCommentResponse>
   */
  issueEditComment(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueEditCommentOptionalParams): Promise<Models.IssueEditCommentResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param callback The callback
   */
  issueEditComment(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Comment>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  issueEditComment(owner: string, repo: string, id: number, options: Models.GiteaAPIIssueEditCommentOptionalParams, callback: msRest.ServiceCallback<Models.Comment>): void;
  issueEditComment(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueEditCommentOptionalParams | msRest.ServiceCallback<Models.Comment>, callback?: msRest.ServiceCallback<Models.Comment>): Promise<Models.IssueEditCommentResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueEditCommentOperationSpec,
      callback) as Promise<Models.IssueEditCommentResponse>;
  }

  /**
   * @summary Get a list of reactions from a comment of an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetCommentReactionsResponse>
   */
  issueGetCommentReactions(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueGetCommentReactionsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param callback The callback
   */
  issueGetCommentReactions(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Reaction[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetCommentReactions(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Reaction[]>): void;
  issueGetCommentReactions(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Reaction[]>, callback?: msRest.ServiceCallback<Models.Reaction[]>): Promise<Models.IssueGetCommentReactionsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueGetCommentReactionsOperationSpec,
      callback) as Promise<Models.IssueGetCommentReactionsResponse>;
  }

  /**
   * @summary Add a reaction to a comment of an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.IssuePostCommentReactionResponse>
   */
  issuePostCommentReaction(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssuePostCommentReactionOptionalParams): Promise<Models.IssuePostCommentReactionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param callback The callback
   */
  issuePostCommentReaction(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Reaction>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  issuePostCommentReaction(owner: string, repo: string, id: number, options: Models.GiteaAPIIssuePostCommentReactionOptionalParams, callback: msRest.ServiceCallback<Models.Reaction>): void;
  issuePostCommentReaction(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssuePostCommentReactionOptionalParams | msRest.ServiceCallback<Models.Reaction>, callback?: msRest.ServiceCallback<Models.Reaction>): Promise<Models.IssuePostCommentReactionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issuePostCommentReactionOperationSpec,
      callback) as Promise<Models.IssuePostCommentReactionResponse>;
  }

  /**
   * @summary Remove a reaction from a comment of an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueDeleteCommentReactionResponse>
   */
  issueDeleteCommentReaction(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueDeleteCommentReactionOptionalParams): Promise<Models.IssueDeleteCommentReactionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param callback The callback
   */
  issueDeleteCommentReaction(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the comment to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteCommentReaction(owner: string, repo: string, id: number, options: Models.GiteaAPIIssueDeleteCommentReactionOptionalParams, callback: msRest.ServiceCallback<void>): void;
  issueDeleteCommentReaction(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueDeleteCommentReactionOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueDeleteCommentReactionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueDeleteCommentReactionOperationSpec,
      callback) as Promise<Models.IssueDeleteCommentReactionResponse>;
  }

  /**
   * @summary Get an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to get
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetIssueResponse>
   */
  issueGetIssue(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueGetIssueResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to get
   * @param callback The callback
   */
  issueGetIssue(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Issue>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to get
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetIssue(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Issue>): void;
  issueGetIssue(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Issue>, callback?: msRest.ServiceCallback<Models.Issue>): Promise<Models.IssueGetIssueResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueGetIssueOperationSpec,
      callback) as Promise<Models.IssueGetIssueResponse>;
  }

  /**
   * @summary Edit an issue. If using deadline only the date will be taken into account, and time of
   * day ignored.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueEditIssueResponse>
   */
  issueEditIssue(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueEditIssueOptionalParams): Promise<Models.IssueEditIssueResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to edit
   * @param callback The callback
   */
  issueEditIssue(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Issue>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  issueEditIssue(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueEditIssueOptionalParams, callback: msRest.ServiceCallback<Models.Issue>): void;
  issueEditIssue(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueEditIssueOptionalParams | msRest.ServiceCallback<Models.Issue>, callback?: msRest.ServiceCallback<Models.Issue>): Promise<Models.IssueEditIssueResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueEditIssueOperationSpec,
      callback) as Promise<Models.IssueEditIssueResponse>;
  }

  /**
   * @summary List all comments on an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetCommentsResponse>
   */
  issueGetComments(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueGetCommentsOptionalParams): Promise<Models.IssueGetCommentsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueGetComments(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Comment[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetComments(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueGetCommentsOptionalParams, callback: msRest.ServiceCallback<Models.Comment[]>): void;
  issueGetComments(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueGetCommentsOptionalParams | msRest.ServiceCallback<Models.Comment[]>, callback?: msRest.ServiceCallback<Models.Comment[]>): Promise<Models.IssueGetCommentsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueGetCommentsOperationSpec,
      callback) as Promise<Models.IssueGetCommentsResponse>;
  }

  /**
   * @summary Add a comment to an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueCreateCommentResponse>
   */
  issueCreateComment(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueCreateCommentOptionalParams): Promise<Models.IssueCreateCommentResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueCreateComment(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Comment>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueCreateComment(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueCreateCommentOptionalParams, callback: msRest.ServiceCallback<Models.Comment>): void;
  issueCreateComment(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueCreateCommentOptionalParams | msRest.ServiceCallback<Models.Comment>, callback?: msRest.ServiceCallback<Models.Comment>): Promise<Models.IssueCreateCommentResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueCreateCommentOperationSpec,
      callback) as Promise<Models.IssueCreateCommentResponse>;
  }

  /**
   * @summary Delete a comment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index this parameter is ignored
   * @param id id of comment to delete
   * @param [options] The optional parameters
   * @deprecated This operation is deprecated. Please do not use it any longer.
   * @returns Promise<Models.IssueDeleteCommentDeprecatedResponse>
   */
  issueDeleteCommentDeprecated(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueDeleteCommentDeprecatedResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index this parameter is ignored
   * @param id id of comment to delete
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  issueDeleteCommentDeprecated(owner: string, repo: string, index: number, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index this parameter is ignored
   * @param id id of comment to delete
   * @param options The optional parameters
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  issueDeleteCommentDeprecated(owner: string, repo: string, index: number, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueDeleteCommentDeprecated(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueDeleteCommentDeprecatedResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        options
      },
      issueDeleteCommentDeprecatedOperationSpec,
      callback) as Promise<Models.IssueDeleteCommentDeprecatedResponse>;
  }

  /**
   * @summary Edit a comment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index this parameter is ignored
   * @param id id of the comment to edit
   * @param [options] The optional parameters
   * @deprecated This operation is deprecated. Please do not use it any longer.
   * @returns Promise<Models.IssueEditCommentDeprecatedResponse>
   */
  issueEditCommentDeprecated(owner: string, repo: string, index: number, id: number, options?: Models.GiteaAPIIssueEditCommentDeprecatedOptionalParams): Promise<Models.IssueEditCommentDeprecatedResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index this parameter is ignored
   * @param id id of the comment to edit
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  issueEditCommentDeprecated(owner: string, repo: string, index: number, id: number, callback: msRest.ServiceCallback<Models.Comment>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index this parameter is ignored
   * @param id id of the comment to edit
   * @param options The optional parameters
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  issueEditCommentDeprecated(owner: string, repo: string, index: number, id: number, options: Models.GiteaAPIIssueEditCommentDeprecatedOptionalParams, callback: msRest.ServiceCallback<Models.Comment>): void;
  issueEditCommentDeprecated(owner: string, repo: string, index: number, id: number, options?: Models.GiteaAPIIssueEditCommentDeprecatedOptionalParams | msRest.ServiceCallback<Models.Comment>, callback?: msRest.ServiceCallback<Models.Comment>): Promise<Models.IssueEditCommentDeprecatedResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        options
      },
      issueEditCommentDeprecatedOperationSpec,
      callback) as Promise<Models.IssueEditCommentDeprecatedResponse>;
  }

  /**
   * @summary Set an issue deadline. If set to null, the deadline is deleted. If using deadline only
   * the date will be taken into account, and time of day ignored.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to create or update a deadline on
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueEditIssueDeadlineResponse>
   */
  issueEditIssueDeadline(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueEditIssueDeadlineOptionalParams): Promise<Models.IssueEditIssueDeadlineResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to create or update a deadline on
   * @param callback The callback
   */
  issueEditIssueDeadline(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.IssueDeadline>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to create or update a deadline on
   * @param options The optional parameters
   * @param callback The callback
   */
  issueEditIssueDeadline(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueEditIssueDeadlineOptionalParams, callback: msRest.ServiceCallback<Models.IssueDeadline>): void;
  issueEditIssueDeadline(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueEditIssueDeadlineOptionalParams | msRest.ServiceCallback<Models.IssueDeadline>, callback?: msRest.ServiceCallback<Models.IssueDeadline>): Promise<Models.IssueEditIssueDeadlineResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueEditIssueDeadlineOperationSpec,
      callback) as Promise<Models.IssueEditIssueDeadlineResponse>;
  }

  /**
   * @summary Get an issue's labels
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetLabelsResponse>
   */
  issueGetLabels(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueGetLabelsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueGetLabels(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Label[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetLabels(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Label[]>): void;
  issueGetLabels(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Label[]>, callback?: msRest.ServiceCallback<Models.Label[]>): Promise<Models.IssueGetLabelsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueGetLabelsOperationSpec,
      callback) as Promise<Models.IssueGetLabelsResponse>;
  }

  /**
   * @summary Replace an issue's labels
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueReplaceLabelsResponse>
   */
  issueReplaceLabels(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueReplaceLabelsOptionalParams): Promise<Models.IssueReplaceLabelsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueReplaceLabels(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Label[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueReplaceLabels(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueReplaceLabelsOptionalParams, callback: msRest.ServiceCallback<Models.Label[]>): void;
  issueReplaceLabels(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueReplaceLabelsOptionalParams | msRest.ServiceCallback<Models.Label[]>, callback?: msRest.ServiceCallback<Models.Label[]>): Promise<Models.IssueReplaceLabelsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueReplaceLabelsOperationSpec,
      callback) as Promise<Models.IssueReplaceLabelsResponse>;
  }

  /**
   * @summary Add a label to an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueAddLabelResponse>
   */
  issueAddLabel(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueAddLabelOptionalParams): Promise<Models.IssueAddLabelResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueAddLabel(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Label[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueAddLabel(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueAddLabelOptionalParams, callback: msRest.ServiceCallback<Models.Label[]>): void;
  issueAddLabel(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueAddLabelOptionalParams | msRest.ServiceCallback<Models.Label[]>, callback?: msRest.ServiceCallback<Models.Label[]>): Promise<Models.IssueAddLabelResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueAddLabelOperationSpec,
      callback) as Promise<Models.IssueAddLabelResponse>;
  }

  /**
   * @summary Remove all labels from an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueClearLabelsResponse>
   */
  issueClearLabels(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueClearLabelsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueClearLabels(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueClearLabels(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueClearLabels(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueClearLabelsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueClearLabelsOperationSpec,
      callback) as Promise<Models.IssueClearLabelsResponse>;
  }

  /**
   * @summary Remove a label from an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param id id of the label to remove
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueRemoveLabelResponse>
   */
  issueRemoveLabel(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueRemoveLabelResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param id id of the label to remove
   * @param callback The callback
   */
  issueRemoveLabel(owner: string, repo: string, index: number, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param id id of the label to remove
   * @param options The optional parameters
   * @param callback The callback
   */
  issueRemoveLabel(owner: string, repo: string, index: number, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueRemoveLabel(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueRemoveLabelResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        options
      },
      issueRemoveLabelOperationSpec,
      callback) as Promise<Models.IssueRemoveLabelResponse>;
  }

  /**
   * @summary Get a list reactions of an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetIssueReactionsResponse>
   */
  issueGetIssueReactions(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueGetIssueReactionsOptionalParams): Promise<Models.IssueGetIssueReactionsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueGetIssueReactions(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Reaction[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetIssueReactions(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueGetIssueReactionsOptionalParams, callback: msRest.ServiceCallback<Models.Reaction[]>): void;
  issueGetIssueReactions(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueGetIssueReactionsOptionalParams | msRest.ServiceCallback<Models.Reaction[]>, callback?: msRest.ServiceCallback<Models.Reaction[]>): Promise<Models.IssueGetIssueReactionsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueGetIssueReactionsOperationSpec,
      callback) as Promise<Models.IssueGetIssueReactionsResponse>;
  }

  /**
   * @summary Add a reaction to an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssuePostIssueReactionResponse>
   */
  issuePostIssueReaction(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssuePostIssueReactionOptionalParams): Promise<Models.IssuePostIssueReactionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issuePostIssueReaction(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.Reaction>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issuePostIssueReaction(owner: string, repo: string, index: number, options: Models.GiteaAPIIssuePostIssueReactionOptionalParams, callback: msRest.ServiceCallback<Models.Reaction>): void;
  issuePostIssueReaction(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssuePostIssueReactionOptionalParams | msRest.ServiceCallback<Models.Reaction>, callback?: msRest.ServiceCallback<Models.Reaction>): Promise<Models.IssuePostIssueReactionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issuePostIssueReactionOperationSpec,
      callback) as Promise<Models.IssuePostIssueReactionResponse>;
  }

  /**
   * @summary Remove a reaction from an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueDeleteIssueReactionResponse>
   */
  issueDeleteIssueReaction(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueDeleteIssueReactionOptionalParams): Promise<Models.IssueDeleteIssueReactionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueDeleteIssueReaction(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteIssueReaction(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueDeleteIssueReactionOptionalParams, callback: msRest.ServiceCallback<void>): void;
  issueDeleteIssueReaction(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueDeleteIssueReactionOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueDeleteIssueReactionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueDeleteIssueReactionOperationSpec,
      callback) as Promise<Models.IssueDeleteIssueReactionResponse>;
  }

  /**
   * @summary Delete an issue's existing stopwatch.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to stop the stopwatch on
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  issueDeleteStopWatch(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to stop the stopwatch on
   * @param callback The callback
   */
  issueDeleteStopWatch(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to stop the stopwatch on
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteStopWatch(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueDeleteStopWatch(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueDeleteStopWatchOperationSpec,
      callback);
  }

  /**
   * @summary Start stopwatch on an issue.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to create the stopwatch on
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  issueStartStopWatch(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to create the stopwatch on
   * @param callback The callback
   */
  issueStartStopWatch(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to create the stopwatch on
   * @param options The optional parameters
   * @param callback The callback
   */
  issueStartStopWatch(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueStartStopWatch(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueStartStopWatchOperationSpec,
      callback);
  }

  /**
   * @summary Stop an issue's existing stopwatch.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to stop the stopwatch on
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  issueStopStopWatch(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to stop the stopwatch on
   * @param callback The callback
   */
  issueStopStopWatch(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to stop the stopwatch on
   * @param options The optional parameters
   * @param callback The callback
   */
  issueStopStopWatch(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueStopStopWatch(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueStopStopWatchOperationSpec,
      callback);
  }

  /**
   * @summary Get users who subscribed on an issue.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueSubscriptionsResponse>
   */
  issueSubscriptions(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueSubscriptionsOptionalParams): Promise<Models.IssueSubscriptionsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueSubscriptions(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueSubscriptions(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueSubscriptionsOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  issueSubscriptions(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueSubscriptionsOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.IssueSubscriptionsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueSubscriptionsOperationSpec,
      callback) as Promise<Models.IssueSubscriptionsResponse>;
  }

  /**
   * @summary Check if user is subscribed to an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueCheckSubscriptionResponse>
   */
  issueCheckSubscription(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueCheckSubscriptionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueCheckSubscription(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.WatchInfo>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueCheckSubscription(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.WatchInfo>): void;
  issueCheckSubscription(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.WatchInfo>, callback?: msRest.ServiceCallback<Models.WatchInfo>): Promise<Models.IssueCheckSubscriptionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueCheckSubscriptionOperationSpec,
      callback) as Promise<Models.IssueCheckSubscriptionResponse>;
  }

  /**
   * @summary Subscribe user to issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param user user to subscribe
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  issueAddSubscription(owner: string, repo: string, index: number, user: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param user user to subscribe
   * @param callback The callback
   */
  issueAddSubscription(owner: string, repo: string, index: number, user: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param user user to subscribe
   * @param options The optional parameters
   * @param callback The callback
   */
  issueAddSubscription(owner: string, repo: string, index: number, user: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueAddSubscription(owner: string, repo: string, index: number, user: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        user,
        options
      },
      issueAddSubscriptionOperationSpec,
      callback);
  }

  /**
   * @summary Unsubscribe user from issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param user user witch unsubscribe
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  issueDeleteSubscription(owner: string, repo: string, index: number, user: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param user user witch unsubscribe
   * @param callback The callback
   */
  issueDeleteSubscription(owner: string, repo: string, index: number, user: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param user user witch unsubscribe
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteSubscription(owner: string, repo: string, index: number, user: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueDeleteSubscription(owner: string, repo: string, index: number, user: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        user,
        options
      },
      issueDeleteSubscriptionOperationSpec,
      callback);
  }

  /**
   * @summary List an issue's tracked times
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueTrackedTimesResponse>
   */
  issueTrackedTimes(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueTrackedTimesOptionalParams): Promise<Models.IssueTrackedTimesResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueTrackedTimes(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueTrackedTimes(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueTrackedTimesOptionalParams, callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  issueTrackedTimes(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueTrackedTimesOptionalParams | msRest.ServiceCallback<Models.TrackedTime[]>, callback?: msRest.ServiceCallback<Models.TrackedTime[]>): Promise<Models.IssueTrackedTimesResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueTrackedTimesOperationSpec,
      callback) as Promise<Models.IssueTrackedTimesResponse>;
  }

  /**
   * @summary Add tracked time to a issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueAddTimeResponse>
   */
  issueAddTime(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueAddTimeOptionalParams): Promise<Models.IssueAddTimeResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param callback The callback
   */
  issueAddTime(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.TrackedTime>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param options The optional parameters
   * @param callback The callback
   */
  issueAddTime(owner: string, repo: string, index: number, options: Models.GiteaAPIIssueAddTimeOptionalParams, callback: msRest.ServiceCallback<Models.TrackedTime>): void;
  issueAddTime(owner: string, repo: string, index: number, options?: Models.GiteaAPIIssueAddTimeOptionalParams | msRest.ServiceCallback<Models.TrackedTime>, callback?: msRest.ServiceCallback<Models.TrackedTime>): Promise<Models.IssueAddTimeResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueAddTimeOperationSpec,
      callback) as Promise<Models.IssueAddTimeResponse>;
  }

  /**
   * @summary Reset a tracked time of an issue
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to add tracked time to
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueResetTimeResponse>
   */
  issueResetTime(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueResetTimeResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to add tracked time to
   * @param callback The callback
   */
  issueResetTime(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue to add tracked time to
   * @param options The optional parameters
   * @param callback The callback
   */
  issueResetTime(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueResetTime(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueResetTimeResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      issueResetTimeOperationSpec,
      callback) as Promise<Models.IssueResetTimeResponse>;
  }

  /**
   * @summary Delete specific tracked time
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param id id of time to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueDeleteTimeResponse>
   */
  issueDeleteTime(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueDeleteTimeResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param id id of time to delete
   * @param callback The callback
   */
  issueDeleteTime(owner: string, repo: string, index: number, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the issue
   * @param id id of time to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteTime(owner: string, repo: string, index: number, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueDeleteTime(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.IssueDeleteTimeResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        options
      },
      issueDeleteTimeOperationSpec,
      callback) as Promise<Models.IssueDeleteTimeResponse>;
  }

  /**
   * @summary List a repository's keys
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListKeysResponse>
   */
  repoListKeys(owner: string, repo: string, options?: Models.GiteaAPIRepoListKeysOptionalParams): Promise<Models.RepoListKeysResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListKeys(owner: string, repo: string, callback: msRest.ServiceCallback<Models.DeployKey[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListKeys(owner: string, repo: string, options: Models.GiteaAPIRepoListKeysOptionalParams, callback: msRest.ServiceCallback<Models.DeployKey[]>): void;
  repoListKeys(owner: string, repo: string, options?: Models.GiteaAPIRepoListKeysOptionalParams | msRest.ServiceCallback<Models.DeployKey[]>, callback?: msRest.ServiceCallback<Models.DeployKey[]>): Promise<Models.RepoListKeysResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListKeysOperationSpec,
      callback) as Promise<Models.RepoListKeysResponse>;
  }

  /**
   * @summary Add a key to a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreateKeyResponse>
   */
  repoCreateKey(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateKeyOptionalParams): Promise<Models.RepoCreateKeyResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoCreateKey(owner: string, repo: string, callback: msRest.ServiceCallback<Models.DeployKey>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreateKey(owner: string, repo: string, options: Models.GiteaAPIRepoCreateKeyOptionalParams, callback: msRest.ServiceCallback<Models.DeployKey>): void;
  repoCreateKey(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateKeyOptionalParams | msRest.ServiceCallback<Models.DeployKey>, callback?: msRest.ServiceCallback<Models.DeployKey>): Promise<Models.RepoCreateKeyResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoCreateKeyOperationSpec,
      callback) as Promise<Models.RepoCreateKeyResponse>;
  }

  /**
   * @summary Get a repository's key by id
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the key to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetKeyResponse>
   */
  repoGetKey(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetKeyResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the key to get
   * @param callback The callback
   */
  repoGetKey(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.DeployKey>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the key to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetKey(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.DeployKey>): void;
  repoGetKey(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.DeployKey>, callback?: msRest.ServiceCallback<Models.DeployKey>): Promise<Models.RepoGetKeyResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoGetKeyOperationSpec,
      callback) as Promise<Models.RepoGetKeyResponse>;
  }

  /**
   * @summary Delete a key from a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the key to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoDeleteKeyResponse>
   */
  repoDeleteKey(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoDeleteKeyResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the key to delete
   * @param callback The callback
   */
  repoDeleteKey(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the key to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteKey(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteKey(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoDeleteKeyResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoDeleteKeyOperationSpec,
      callback) as Promise<Models.RepoDeleteKeyResponse>;
  }

  /**
   * @summary Get all of a repository's labels
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueListLabelsResponse>
   */
  issueListLabels(owner: string, repo: string, options?: Models.GiteaAPIIssueListLabelsOptionalParams): Promise<Models.IssueListLabelsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  issueListLabels(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Label[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  issueListLabels(owner: string, repo: string, options: Models.GiteaAPIIssueListLabelsOptionalParams, callback: msRest.ServiceCallback<Models.Label[]>): void;
  issueListLabels(owner: string, repo: string, options?: Models.GiteaAPIIssueListLabelsOptionalParams | msRest.ServiceCallback<Models.Label[]>, callback?: msRest.ServiceCallback<Models.Label[]>): Promise<Models.IssueListLabelsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      issueListLabelsOperationSpec,
      callback) as Promise<Models.IssueListLabelsResponse>;
  }

  /**
   * @summary Create a label
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueCreateLabelResponse>
   */
  issueCreateLabel(owner: string, repo: string, options?: Models.GiteaAPIIssueCreateLabelOptionalParams): Promise<Models.IssueCreateLabelResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  issueCreateLabel(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Label>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  issueCreateLabel(owner: string, repo: string, options: Models.GiteaAPIIssueCreateLabelOptionalParams, callback: msRest.ServiceCallback<Models.Label>): void;
  issueCreateLabel(owner: string, repo: string, options?: Models.GiteaAPIIssueCreateLabelOptionalParams | msRest.ServiceCallback<Models.Label>, callback?: msRest.ServiceCallback<Models.Label>): Promise<Models.IssueCreateLabelResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      issueCreateLabelOperationSpec,
      callback) as Promise<Models.IssueCreateLabelResponse>;
  }

  /**
   * @summary Get a single label
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to get
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetLabelResponse>
   */
  issueGetLabel(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueGetLabelResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to get
   * @param callback The callback
   */
  issueGetLabel(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Label>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to get
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetLabel(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Label>): void;
  issueGetLabel(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Label>, callback?: msRest.ServiceCallback<Models.Label>): Promise<Models.IssueGetLabelResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueGetLabelOperationSpec,
      callback) as Promise<Models.IssueGetLabelResponse>;
  }

  /**
   * @summary Delete a label
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  issueDeleteLabel(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to delete
   * @param callback The callback
   */
  issueDeleteLabel(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteLabel(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueDeleteLabel(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueDeleteLabelOperationSpec,
      callback);
  }

  /**
   * @summary Update a label
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueEditLabelResponse>
   */
  issueEditLabel(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueEditLabelOptionalParams): Promise<Models.IssueEditLabelResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to edit
   * @param callback The callback
   */
  issueEditLabel(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Label>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the label to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  issueEditLabel(owner: string, repo: string, id: number, options: Models.GiteaAPIIssueEditLabelOptionalParams, callback: msRest.ServiceCallback<Models.Label>): void;
  issueEditLabel(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueEditLabelOptionalParams | msRest.ServiceCallback<Models.Label>, callback?: msRest.ServiceCallback<Models.Label>): Promise<Models.IssueEditLabelResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueEditLabelOperationSpec,
      callback) as Promise<Models.IssueEditLabelResponse>;
  }

  /**
   * @summary Get all of a repository's opened milestones
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetMilestonesListResponse>
   */
  issueGetMilestonesList(owner: string, repo: string, options?: Models.GiteaAPIIssueGetMilestonesListOptionalParams): Promise<Models.IssueGetMilestonesListResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  issueGetMilestonesList(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Milestone[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetMilestonesList(owner: string, repo: string, options: Models.GiteaAPIIssueGetMilestonesListOptionalParams, callback: msRest.ServiceCallback<Models.Milestone[]>): void;
  issueGetMilestonesList(owner: string, repo: string, options?: Models.GiteaAPIIssueGetMilestonesListOptionalParams | msRest.ServiceCallback<Models.Milestone[]>, callback?: msRest.ServiceCallback<Models.Milestone[]>): Promise<Models.IssueGetMilestonesListResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      issueGetMilestonesListOperationSpec,
      callback) as Promise<Models.IssueGetMilestonesListResponse>;
  }

  /**
   * @summary Create a milestone
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueCreateMilestoneResponse>
   */
  issueCreateMilestone(owner: string, repo: string, options?: Models.GiteaAPIIssueCreateMilestoneOptionalParams): Promise<Models.IssueCreateMilestoneResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  issueCreateMilestone(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Milestone>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  issueCreateMilestone(owner: string, repo: string, options: Models.GiteaAPIIssueCreateMilestoneOptionalParams, callback: msRest.ServiceCallback<Models.Milestone>): void;
  issueCreateMilestone(owner: string, repo: string, options?: Models.GiteaAPIIssueCreateMilestoneOptionalParams | msRest.ServiceCallback<Models.Milestone>, callback?: msRest.ServiceCallback<Models.Milestone>): Promise<Models.IssueCreateMilestoneResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      issueCreateMilestoneOperationSpec,
      callback) as Promise<Models.IssueCreateMilestoneResponse>;
  }

  /**
   * @summary Get a milestone
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueGetMilestoneResponse>
   */
  issueGetMilestone(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.IssueGetMilestoneResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone
   * @param callback The callback
   */
  issueGetMilestone(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Milestone>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone
   * @param options The optional parameters
   * @param callback The callback
   */
  issueGetMilestone(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Milestone>): void;
  issueGetMilestone(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Milestone>, callback?: msRest.ServiceCallback<Models.Milestone>): Promise<Models.IssueGetMilestoneResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueGetMilestoneOperationSpec,
      callback) as Promise<Models.IssueGetMilestoneResponse>;
  }

  /**
   * @summary Delete a milestone
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  issueDeleteMilestone(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone to delete
   * @param callback The callback
   */
  issueDeleteMilestone(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  issueDeleteMilestone(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  issueDeleteMilestone(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueDeleteMilestoneOperationSpec,
      callback);
  }

  /**
   * @summary Update a milestone
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone
   * @param [options] The optional parameters
   * @returns Promise<Models.IssueEditMilestoneResponse>
   */
  issueEditMilestone(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueEditMilestoneOptionalParams): Promise<Models.IssueEditMilestoneResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone
   * @param callback The callback
   */
  issueEditMilestone(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Milestone>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the milestone
   * @param options The optional parameters
   * @param callback The callback
   */
  issueEditMilestone(owner: string, repo: string, id: number, options: Models.GiteaAPIIssueEditMilestoneOptionalParams, callback: msRest.ServiceCallback<Models.Milestone>): void;
  issueEditMilestone(owner: string, repo: string, id: number, options?: Models.GiteaAPIIssueEditMilestoneOptionalParams | msRest.ServiceCallback<Models.Milestone>, callback?: msRest.ServiceCallback<Models.Milestone>): Promise<Models.IssueEditMilestoneResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      issueEditMilestoneOperationSpec,
      callback) as Promise<Models.IssueEditMilestoneResponse>;
  }

  /**
   * @summary Sync a mirrored repository
   * @param owner owner of the repo to sync
   * @param repo name of the repo to sync
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoMirrorSyncResponse>
   */
  repoMirrorSync(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoMirrorSyncResponse>;
  /**
   * @param owner owner of the repo to sync
   * @param repo name of the repo to sync
   * @param callback The callback
   */
  repoMirrorSync(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo to sync
   * @param repo name of the repo to sync
   * @param options The optional parameters
   * @param callback The callback
   */
  repoMirrorSync(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoMirrorSync(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoMirrorSyncResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoMirrorSyncOperationSpec,
      callback) as Promise<Models.RepoMirrorSyncResponse>;
  }

  /**
   * @summary List users's notification threads on a specific repo
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.NotifyGetRepoListResponse>
   */
  notifyGetRepoList(owner: string, repo: string, options?: Models.GiteaAPINotifyGetRepoListOptionalParams): Promise<Models.NotifyGetRepoListResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  notifyGetRepoList(owner: string, repo: string, callback: msRest.ServiceCallback<Models.NotificationThread[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  notifyGetRepoList(owner: string, repo: string, options: Models.GiteaAPINotifyGetRepoListOptionalParams, callback: msRest.ServiceCallback<Models.NotificationThread[]>): void;
  notifyGetRepoList(owner: string, repo: string, options?: Models.GiteaAPINotifyGetRepoListOptionalParams | msRest.ServiceCallback<Models.NotificationThread[]>, callback?: msRest.ServiceCallback<Models.NotificationThread[]>): Promise<Models.NotifyGetRepoListResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      notifyGetRepoListOperationSpec,
      callback) as Promise<Models.NotifyGetRepoListResponse>;
  }

  /**
   * @summary Mark notification threads as read on a specific repo
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  notifyReadRepoList(owner: string, repo: string, options?: Models.GiteaAPINotifyReadRepoListOptionalParams): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  notifyReadRepoList(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  notifyReadRepoList(owner: string, repo: string, options: Models.GiteaAPINotifyReadRepoListOptionalParams, callback: msRest.ServiceCallback<void>): void;
  notifyReadRepoList(owner: string, repo: string, options?: Models.GiteaAPINotifyReadRepoListOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      notifyReadRepoListOperationSpec,
      callback);
  }

  /**
   * @summary List a repo's pull requests
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListPullRequestsResponse>
   */
  repoListPullRequests(owner: string, repo: string, options?: Models.GiteaAPIRepoListPullRequestsOptionalParams): Promise<Models.RepoListPullRequestsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListPullRequests(owner: string, repo: string, callback: msRest.ServiceCallback<Models.PullRequest[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListPullRequests(owner: string, repo: string, options: Models.GiteaAPIRepoListPullRequestsOptionalParams, callback: msRest.ServiceCallback<Models.PullRequest[]>): void;
  repoListPullRequests(owner: string, repo: string, options?: Models.GiteaAPIRepoListPullRequestsOptionalParams | msRest.ServiceCallback<Models.PullRequest[]>, callback?: msRest.ServiceCallback<Models.PullRequest[]>): Promise<Models.RepoListPullRequestsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListPullRequestsOperationSpec,
      callback) as Promise<Models.RepoListPullRequestsResponse>;
  }

  /**
   * @summary Create a pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreatePullRequestResponse>
   */
  repoCreatePullRequest(owner: string, repo: string, options?: Models.GiteaAPIRepoCreatePullRequestOptionalParams): Promise<Models.RepoCreatePullRequestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoCreatePullRequest(owner: string, repo: string, callback: msRest.ServiceCallback<Models.PullRequest>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreatePullRequest(owner: string, repo: string, options: Models.GiteaAPIRepoCreatePullRequestOptionalParams, callback: msRest.ServiceCallback<Models.PullRequest>): void;
  repoCreatePullRequest(owner: string, repo: string, options?: Models.GiteaAPIRepoCreatePullRequestOptionalParams | msRest.ServiceCallback<Models.PullRequest>, callback?: msRest.ServiceCallback<Models.PullRequest>): Promise<Models.RepoCreatePullRequestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoCreatePullRequestOperationSpec,
      callback) as Promise<Models.RepoCreatePullRequestResponse>;
  }

  /**
   * @summary Get a pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetPullRequestResponse>
   */
  repoGetPullRequest(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetPullRequestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to get
   * @param callback The callback
   */
  repoGetPullRequest(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.PullRequest>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetPullRequest(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.PullRequest>): void;
  repoGetPullRequest(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.PullRequest>, callback?: msRest.ServiceCallback<Models.PullRequest>): Promise<Models.RepoGetPullRequestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      repoGetPullRequestOperationSpec,
      callback) as Promise<Models.RepoGetPullRequestResponse>;
  }

  /**
   * @summary Update a pull request. If using deadline only the date will be taken into account, and
   * time of day ignored.
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoEditPullRequestResponse>
   */
  repoEditPullRequest(owner: string, repo: string, index: number, options?: Models.GiteaAPIRepoEditPullRequestOptionalParams): Promise<Models.RepoEditPullRequestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to edit
   * @param callback The callback
   */
  repoEditPullRequest(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.PullRequest>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  repoEditPullRequest(owner: string, repo: string, index: number, options: Models.GiteaAPIRepoEditPullRequestOptionalParams, callback: msRest.ServiceCallback<Models.PullRequest>): void;
  repoEditPullRequest(owner: string, repo: string, index: number, options?: Models.GiteaAPIRepoEditPullRequestOptionalParams | msRest.ServiceCallback<Models.PullRequest>, callback?: msRest.ServiceCallback<Models.PullRequest>): Promise<Models.RepoEditPullRequestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      repoEditPullRequestOperationSpec,
      callback) as Promise<Models.RepoEditPullRequestResponse>;
  }

  /**
   * @summary Check if a pull request has been merged
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoPullRequestIsMerged(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param callback The callback
   */
  repoPullRequestIsMerged(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param options The optional parameters
   * @param callback The callback
   */
  repoPullRequestIsMerged(owner: string, repo: string, index: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoPullRequestIsMerged(owner: string, repo: string, index: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      repoPullRequestIsMergedOperationSpec,
      callback);
  }

  /**
   * @summary Merge a pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to merge
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoMergePullRequestResponse>
   */
  repoMergePullRequest(owner: string, repo: string, index: number, options?: Models.GiteaAPIRepoMergePullRequestOptionalParams): Promise<Models.RepoMergePullRequestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to merge
   * @param callback The callback
   */
  repoMergePullRequest(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request to merge
   * @param options The optional parameters
   * @param callback The callback
   */
  repoMergePullRequest(owner: string, repo: string, index: number, options: Models.GiteaAPIRepoMergePullRequestOptionalParams, callback: msRest.ServiceCallback<void>): void;
  repoMergePullRequest(owner: string, repo: string, index: number, options?: Models.GiteaAPIRepoMergePullRequestOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoMergePullRequestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      repoMergePullRequestOperationSpec,
      callback) as Promise<Models.RepoMergePullRequestResponse>;
  }

  /**
   * @summary List all reviews for a pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListPullReviewsResponse>
   */
  repoListPullReviews(owner: string, repo: string, index: number, options?: Models.GiteaAPIRepoListPullReviewsOptionalParams): Promise<Models.RepoListPullReviewsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param callback The callback
   */
  repoListPullReviews(owner: string, repo: string, index: number, callback: msRest.ServiceCallback<Models.PullReview[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListPullReviews(owner: string, repo: string, index: number, options: Models.GiteaAPIRepoListPullReviewsOptionalParams, callback: msRest.ServiceCallback<Models.PullReview[]>): void;
  repoListPullReviews(owner: string, repo: string, index: number, options?: Models.GiteaAPIRepoListPullReviewsOptionalParams | msRest.ServiceCallback<Models.PullReview[]>, callback?: msRest.ServiceCallback<Models.PullReview[]>): Promise<Models.RepoListPullReviewsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        options
      },
      repoListPullReviewsOperationSpec,
      callback) as Promise<Models.RepoListPullReviewsResponse>;
  }

  /**
   * @summary Create a review to an pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreatePullReviewResponse>
   */
  repoCreatePullReview(owner: string, repo: string, index: number, body: Models.CreatePullReviewOptions, options?: msRest.RequestOptionsBase): Promise<Models.RepoCreatePullReviewResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param body
   * @param callback The callback
   */
  repoCreatePullReview(owner: string, repo: string, index: number, body: Models.CreatePullReviewOptions, callback: msRest.ServiceCallback<Models.PullReview>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreatePullReview(owner: string, repo: string, index: number, body: Models.CreatePullReviewOptions, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.PullReview>): void;
  repoCreatePullReview(owner: string, repo: string, index: number, body: Models.CreatePullReviewOptions, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.PullReview>, callback?: msRest.ServiceCallback<Models.PullReview>): Promise<Models.RepoCreatePullReviewResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        body,
        options
      },
      repoCreatePullReviewOperationSpec,
      callback) as Promise<Models.RepoCreatePullReviewResponse>;
  }

  /**
   * @summary Get a specific review for a pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetPullReviewResponse>
   */
  repoGetPullReview(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetPullReviewResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param callback The callback
   */
  repoGetPullReview(owner: string, repo: string, index: number, id: number, callback: msRest.ServiceCallback<Models.PullReview>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetPullReview(owner: string, repo: string, index: number, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.PullReview>): void;
  repoGetPullReview(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.PullReview>, callback?: msRest.ServiceCallback<Models.PullReview>): Promise<Models.RepoGetPullReviewResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        options
      },
      repoGetPullReviewOperationSpec,
      callback) as Promise<Models.RepoGetPullReviewResponse>;
  }

  /**
   * @summary Submit a pending review to an pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoSubmitPullReviewResponse>
   */
  repoSubmitPullReview(owner: string, repo: string, index: number, id: number, body: Models.SubmitPullReviewOptions, options?: msRest.RequestOptionsBase): Promise<Models.RepoSubmitPullReviewResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param body
   * @param callback The callback
   */
  repoSubmitPullReview(owner: string, repo: string, index: number, id: number, body: Models.SubmitPullReviewOptions, callback: msRest.ServiceCallback<Models.PullReview>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  repoSubmitPullReview(owner: string, repo: string, index: number, id: number, body: Models.SubmitPullReviewOptions, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.PullReview>): void;
  repoSubmitPullReview(owner: string, repo: string, index: number, id: number, body: Models.SubmitPullReviewOptions, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.PullReview>, callback?: msRest.ServiceCallback<Models.PullReview>): Promise<Models.RepoSubmitPullReviewResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        body,
        options
      },
      repoSubmitPullReviewOperationSpec,
      callback) as Promise<Models.RepoSubmitPullReviewResponse>;
  }

  /**
   * @summary Delete a specific review from a pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoDeletePullReviewResponse>
   */
  repoDeletePullReview(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoDeletePullReviewResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param callback The callback
   */
  repoDeletePullReview(owner: string, repo: string, index: number, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeletePullReview(owner: string, repo: string, index: number, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeletePullReview(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoDeletePullReviewResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        options
      },
      repoDeletePullReviewOperationSpec,
      callback) as Promise<Models.RepoDeletePullReviewResponse>;
  }

  /**
   * @summary Get a specific review for a pull request
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetPullReviewCommentsResponse>
   */
  repoGetPullReviewComments(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetPullReviewCommentsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param callback The callback
   */
  repoGetPullReviewComments(owner: string, repo: string, index: number, id: number, callback: msRest.ServiceCallback<Models.PullReviewComment[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param index index of the pull request
   * @param id id of the review
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetPullReviewComments(owner: string, repo: string, index: number, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.PullReviewComment[]>): void;
  repoGetPullReviewComments(owner: string, repo: string, index: number, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.PullReviewComment[]>, callback?: msRest.ServiceCallback<Models.PullReviewComment[]>): Promise<Models.RepoGetPullReviewCommentsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        index,
        id,
        options
      },
      repoGetPullReviewCommentsOperationSpec,
      callback) as Promise<Models.RepoGetPullReviewCommentsResponse>;
  }

  /**
   * @summary Get a file from a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath filepath of the file to get
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoGetRawFile(owner: string, repo: string, filepath: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath filepath of the file to get
   * @param callback The callback
   */
  repoGetRawFile(owner: string, repo: string, filepath: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param filepath filepath of the file to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetRawFile(owner: string, repo: string, filepath: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoGetRawFile(owner: string, repo: string, filepath: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        filepath,
        options
      },
      repoGetRawFileOperationSpec,
      callback);
  }

  /**
   * @summary List a repo's releases
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListReleasesResponse>
   */
  repoListReleases(owner: string, repo: string, options?: Models.GiteaAPIRepoListReleasesOptionalParams): Promise<Models.RepoListReleasesResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListReleases(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Release[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListReleases(owner: string, repo: string, options: Models.GiteaAPIRepoListReleasesOptionalParams, callback: msRest.ServiceCallback<Models.Release[]>): void;
  repoListReleases(owner: string, repo: string, options?: Models.GiteaAPIRepoListReleasesOptionalParams | msRest.ServiceCallback<Models.Release[]>, callback?: msRest.ServiceCallback<Models.Release[]>): Promise<Models.RepoListReleasesResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListReleasesOperationSpec,
      callback) as Promise<Models.RepoListReleasesResponse>;
  }

  /**
   * @summary Create a release
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreateReleaseResponse>
   */
  repoCreateRelease(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateReleaseOptionalParams): Promise<Models.RepoCreateReleaseResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoCreateRelease(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Release>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreateRelease(owner: string, repo: string, options: Models.GiteaAPIRepoCreateReleaseOptionalParams, callback: msRest.ServiceCallback<Models.Release>): void;
  repoCreateRelease(owner: string, repo: string, options?: Models.GiteaAPIRepoCreateReleaseOptionalParams | msRest.ServiceCallback<Models.Release>, callback?: msRest.ServiceCallback<Models.Release>): Promise<Models.RepoCreateReleaseResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoCreateReleaseOperationSpec,
      callback) as Promise<Models.RepoCreateReleaseResponse>;
  }

  /**
   * @summary Get a release
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetReleaseResponse>
   */
  repoGetRelease(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetReleaseResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to get
   * @param callback The callback
   */
  repoGetRelease(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Release>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetRelease(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Release>): void;
  repoGetRelease(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Release>, callback?: msRest.ServiceCallback<Models.Release>): Promise<Models.RepoGetReleaseResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoGetReleaseOperationSpec,
      callback) as Promise<Models.RepoGetReleaseResponse>;
  }

  /**
   * @summary Delete a release
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoDeleteRelease(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to delete
   * @param callback The callback
   */
  repoDeleteRelease(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteRelease(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteRelease(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoDeleteReleaseOperationSpec,
      callback);
  }

  /**
   * @summary Update a release
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoEditReleaseResponse>
   */
  repoEditRelease(owner: string, repo: string, id: number, options?: Models.GiteaAPIRepoEditReleaseOptionalParams): Promise<Models.RepoEditReleaseResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to edit
   * @param callback The callback
   */
  repoEditRelease(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Release>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  repoEditRelease(owner: string, repo: string, id: number, options: Models.GiteaAPIRepoEditReleaseOptionalParams, callback: msRest.ServiceCallback<Models.Release>): void;
  repoEditRelease(owner: string, repo: string, id: number, options?: Models.GiteaAPIRepoEditReleaseOptionalParams | msRest.ServiceCallback<Models.Release>, callback?: msRest.ServiceCallback<Models.Release>): Promise<Models.RepoEditReleaseResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoEditReleaseOperationSpec,
      callback) as Promise<Models.RepoEditReleaseResponse>;
  }

  /**
   * @summary List release's attachments
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListReleaseAttachmentsResponse>
   */
  repoListReleaseAttachments(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoListReleaseAttachmentsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param callback The callback
   */
  repoListReleaseAttachments(owner: string, repo: string, id: number, callback: msRest.ServiceCallback<Models.Attachment[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListReleaseAttachments(owner: string, repo: string, id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Attachment[]>): void;
  repoListReleaseAttachments(owner: string, repo: string, id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Attachment[]>, callback?: msRest.ServiceCallback<Models.Attachment[]>): Promise<Models.RepoListReleaseAttachmentsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        options
      },
      repoListReleaseAttachmentsOperationSpec,
      callback) as Promise<Models.RepoListReleaseAttachmentsResponse>;
  }

  /**
   * @summary Create a release attachment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachment attachment to upload
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreateReleaseAttachmentResponse>
   */
  repoCreateReleaseAttachment(owner: string, repo: string, id: number, attachment: msRest.HttpRequestBody, options?: Models.GiteaAPIRepoCreateReleaseAttachmentOptionalParams): Promise<Models.RepoCreateReleaseAttachmentResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachment attachment to upload
   * @param callback The callback
   */
  repoCreateReleaseAttachment(owner: string, repo: string, id: number, attachment: msRest.HttpRequestBody, callback: msRest.ServiceCallback<Models.Attachment>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachment attachment to upload
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreateReleaseAttachment(owner: string, repo: string, id: number, attachment: msRest.HttpRequestBody, options: Models.GiteaAPIRepoCreateReleaseAttachmentOptionalParams, callback: msRest.ServiceCallback<Models.Attachment>): void;
  repoCreateReleaseAttachment(owner: string, repo: string, id: number, attachment: msRest.HttpRequestBody, options?: Models.GiteaAPIRepoCreateReleaseAttachmentOptionalParams | msRest.ServiceCallback<Models.Attachment>, callback?: msRest.ServiceCallback<Models.Attachment>): Promise<Models.RepoCreateReleaseAttachmentResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        attachment,
        options
      },
      repoCreateReleaseAttachmentOperationSpec,
      callback) as Promise<Models.RepoCreateReleaseAttachmentResponse>;
  }

  /**
   * @summary Get a release attachment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetReleaseAttachmentResponse>
   */
  repoGetReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetReleaseAttachmentResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to get
   * @param callback The callback
   */
  repoGetReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, callback: msRest.ServiceCallback<Models.Attachment>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Attachment>): void;
  repoGetReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Attachment>, callback?: msRest.ServiceCallback<Models.Attachment>): Promise<Models.RepoGetReleaseAttachmentResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        attachmentId,
        options
      },
      repoGetReleaseAttachmentOperationSpec,
      callback) as Promise<Models.RepoGetReleaseAttachmentResponse>;
  }

  /**
   * @summary Delete a release attachment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  repoDeleteReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to delete
   * @param callback The callback
   */
  repoDeleteReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        attachmentId,
        options
      },
      repoDeleteReleaseAttachmentOperationSpec,
      callback);
  }

  /**
   * @summary Edit a release attachment
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoEditReleaseAttachmentResponse>
   */
  repoEditReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options?: Models.GiteaAPIRepoEditReleaseAttachmentOptionalParams): Promise<Models.RepoEditReleaseAttachmentResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to edit
   * @param callback The callback
   */
  repoEditReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, callback: msRest.ServiceCallback<Models.Attachment>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param id id of the release
   * @param attachmentId id of the attachment to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  repoEditReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options: Models.GiteaAPIRepoEditReleaseAttachmentOptionalParams, callback: msRest.ServiceCallback<Models.Attachment>): void;
  repoEditReleaseAttachment(owner: string, repo: string, id: number, attachmentId: number, options?: Models.GiteaAPIRepoEditReleaseAttachmentOptionalParams | msRest.ServiceCallback<Models.Attachment>, callback?: msRest.ServiceCallback<Models.Attachment>): Promise<Models.RepoEditReleaseAttachmentResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        id,
        attachmentId,
        options
      },
      repoEditReleaseAttachmentOperationSpec,
      callback) as Promise<Models.RepoEditReleaseAttachmentResponse>;
  }

  /**
   * @summary Get signing-key.gpg for given repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoSigningKeyResponse>
   */
  repoSigningKey(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoSigningKeyResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoSigningKey(owner: string, repo: string, callback: msRest.ServiceCallback<string>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoSigningKey(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<string>): void;
  repoSigningKey(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<string>, callback?: msRest.ServiceCallback<string>): Promise<Models.RepoSigningKeyResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoSigningKeyOperationSpec,
      callback) as Promise<Models.RepoSigningKeyResponse>;
  }

  /**
   * @summary List a repo's stargazers
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListStargazersResponse>
   */
  repoListStargazers(owner: string, repo: string, options?: Models.GiteaAPIRepoListStargazersOptionalParams): Promise<Models.RepoListStargazersResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListStargazers(owner: string, repo: string, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListStargazers(owner: string, repo: string, options: Models.GiteaAPIRepoListStargazersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  repoListStargazers(owner: string, repo: string, options?: Models.GiteaAPIRepoListStargazersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.RepoListStargazersResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListStargazersOperationSpec,
      callback) as Promise<Models.RepoListStargazersResponse>;
  }

  /**
   * @summary Get a commit's statuses
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListStatusesResponse>
   */
  repoListStatuses(owner: string, repo: string, sha: string, options?: Models.GiteaAPIRepoListStatusesOptionalParams): Promise<Models.RepoListStatusesResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param callback The callback
   */
  repoListStatuses(owner: string, repo: string, sha: string, callback: msRest.ServiceCallback<Models.Status[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListStatuses(owner: string, repo: string, sha: string, options: Models.GiteaAPIRepoListStatusesOptionalParams, callback: msRest.ServiceCallback<Models.Status[]>): void;
  repoListStatuses(owner: string, repo: string, sha: string, options?: Models.GiteaAPIRepoListStatusesOptionalParams | msRest.ServiceCallback<Models.Status[]>, callback?: msRest.ServiceCallback<Models.Status[]>): Promise<Models.RepoListStatusesResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        sha,
        options
      },
      repoListStatusesOperationSpec,
      callback) as Promise<Models.RepoListStatusesResponse>;
  }

  /**
   * @summary Create a commit status
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoCreateStatusResponse>
   */
  repoCreateStatus(owner: string, repo: string, sha: string, options?: Models.GiteaAPIRepoCreateStatusOptionalParams): Promise<Models.RepoCreateStatusResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param callback The callback
   */
  repoCreateStatus(owner: string, repo: string, sha: string, callback: msRest.ServiceCallback<Models.Status>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param sha sha of the commit
   * @param options The optional parameters
   * @param callback The callback
   */
  repoCreateStatus(owner: string, repo: string, sha: string, options: Models.GiteaAPIRepoCreateStatusOptionalParams, callback: msRest.ServiceCallback<Models.Status>): void;
  repoCreateStatus(owner: string, repo: string, sha: string, options?: Models.GiteaAPIRepoCreateStatusOptionalParams | msRest.ServiceCallback<Models.Status>, callback?: msRest.ServiceCallback<Models.Status>): Promise<Models.RepoCreateStatusResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        sha,
        options
      },
      repoCreateStatusOperationSpec,
      callback) as Promise<Models.RepoCreateStatusResponse>;
  }

  /**
   * @summary List a repo's watchers
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListSubscribersResponse>
   */
  repoListSubscribers(owner: string, repo: string, options?: Models.GiteaAPIRepoListSubscribersOptionalParams): Promise<Models.RepoListSubscribersResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListSubscribers(owner: string, repo: string, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListSubscribers(owner: string, repo: string, options: Models.GiteaAPIRepoListSubscribersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  repoListSubscribers(owner: string, repo: string, options?: Models.GiteaAPIRepoListSubscribersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.RepoListSubscribersResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListSubscribersOperationSpec,
      callback) as Promise<Models.RepoListSubscribersResponse>;
  }

  /**
   * @summary Check if the current user is watching a repo
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentCheckSubscriptionResponse>
   */
  userCurrentCheckSubscription(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.UserCurrentCheckSubscriptionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  userCurrentCheckSubscription(owner: string, repo: string, callback: msRest.ServiceCallback<Models.WatchInfo>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentCheckSubscription(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.WatchInfo>): void;
  userCurrentCheckSubscription(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.WatchInfo>, callback?: msRest.ServiceCallback<Models.WatchInfo>): Promise<Models.UserCurrentCheckSubscriptionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      userCurrentCheckSubscriptionOperationSpec,
      callback) as Promise<Models.UserCurrentCheckSubscriptionResponse>;
  }

  /**
   * @summary Watch a repo
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentPutSubscriptionResponse>
   */
  userCurrentPutSubscription(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.UserCurrentPutSubscriptionResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  userCurrentPutSubscription(owner: string, repo: string, callback: msRest.ServiceCallback<Models.WatchInfo>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentPutSubscription(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.WatchInfo>): void;
  userCurrentPutSubscription(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.WatchInfo>, callback?: msRest.ServiceCallback<Models.WatchInfo>): Promise<Models.UserCurrentPutSubscriptionResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      userCurrentPutSubscriptionOperationSpec,
      callback) as Promise<Models.UserCurrentPutSubscriptionResponse>;
  }

  /**
   * @summary Unwatch a repo
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCurrentDeleteSubscription(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  userCurrentDeleteSubscription(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentDeleteSubscription(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentDeleteSubscription(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      userCurrentDeleteSubscriptionOperationSpec,
      callback);
  }

  /**
   * @summary List a repository's tags
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListTagsResponse>
   */
  repoListTags(owner: string, repo: string, options?: Models.GiteaAPIRepoListTagsOptionalParams): Promise<Models.RepoListTagsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListTags(owner: string, repo: string, callback: msRest.ServiceCallback<Models.Tag[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListTags(owner: string, repo: string, options: Models.GiteaAPIRepoListTagsOptionalParams, callback: msRest.ServiceCallback<Models.Tag[]>): void;
  repoListTags(owner: string, repo: string, options?: Models.GiteaAPIRepoListTagsOptionalParams | msRest.ServiceCallback<Models.Tag[]>, callback?: msRest.ServiceCallback<Models.Tag[]>): Promise<Models.RepoListTagsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListTagsOperationSpec,
      callback) as Promise<Models.RepoListTagsResponse>;
  }

  /**
   * @summary List a repo's tracked times
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoTrackedTimesResponse>
   */
  repoTrackedTimes(owner: string, repo: string, options?: Models.GiteaAPIRepoTrackedTimesOptionalParams): Promise<Models.RepoTrackedTimesResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoTrackedTimes(owner: string, repo: string, callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoTrackedTimes(owner: string, repo: string, options: Models.GiteaAPIRepoTrackedTimesOptionalParams, callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  repoTrackedTimes(owner: string, repo: string, options?: Models.GiteaAPIRepoTrackedTimesOptionalParams | msRest.ServiceCallback<Models.TrackedTime[]>, callback?: msRest.ServiceCallback<Models.TrackedTime[]>): Promise<Models.RepoTrackedTimesResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoTrackedTimesOperationSpec,
      callback) as Promise<Models.RepoTrackedTimesResponse>;
  }

  /**
   * @summary List a user's tracked times in a repo
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param user username of user
   * @param [options] The optional parameters
   * @deprecated This operation is deprecated. Please do not use it any longer.
   * @returns Promise<Models.UserTrackedTimesResponse>
   */
  userTrackedTimes(owner: string, repo: string, user: string, options?: msRest.RequestOptionsBase): Promise<Models.UserTrackedTimesResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param user username of user
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  userTrackedTimes(owner: string, repo: string, user: string, callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param user username of user
   * @param options The optional parameters
   * @param callback The callback
   * @deprecated This operation is deprecated. Please do not use it any longer.
   */
  userTrackedTimes(owner: string, repo: string, user: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  userTrackedTimes(owner: string, repo: string, user: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.TrackedTime[]>, callback?: msRest.ServiceCallback<Models.TrackedTime[]>): Promise<Models.UserTrackedTimesResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        user,
        options
      },
      userTrackedTimesOperationSpec,
      callback) as Promise<Models.UserTrackedTimesResponse>;
  }

  /**
   * @summary Get list of topics that a repository has
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoListTopicsResponse>
   */
  repoListTopics(owner: string, repo: string, options?: Models.GiteaAPIRepoListTopicsOptionalParams): Promise<Models.RepoListTopicsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoListTopics(owner: string, repo: string, callback: msRest.ServiceCallback<Models.TopicName>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoListTopics(owner: string, repo: string, options: Models.GiteaAPIRepoListTopicsOptionalParams, callback: msRest.ServiceCallback<Models.TopicName>): void;
  repoListTopics(owner: string, repo: string, options?: Models.GiteaAPIRepoListTopicsOptionalParams | msRest.ServiceCallback<Models.TopicName>, callback?: msRest.ServiceCallback<Models.TopicName>): Promise<Models.RepoListTopicsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoListTopicsOperationSpec,
      callback) as Promise<Models.RepoListTopicsResponse>;
  }

  /**
   * @summary Replace list of topics for a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoUpdateTopicsResponse>
   */
  repoUpdateTopics(owner: string, repo: string, options?: Models.GiteaAPIRepoUpdateTopicsOptionalParams): Promise<Models.RepoUpdateTopicsResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  repoUpdateTopics(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  repoUpdateTopics(owner: string, repo: string, options: Models.GiteaAPIRepoUpdateTopicsOptionalParams, callback: msRest.ServiceCallback<void>): void;
  repoUpdateTopics(owner: string, repo: string, options?: Models.GiteaAPIRepoUpdateTopicsOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoUpdateTopicsResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      repoUpdateTopicsOperationSpec,
      callback) as Promise<Models.RepoUpdateTopicsResponse>;
  }

  /**
   * @summary Add a topic to a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param topic name of the topic to add
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoAddTopícResponse>
   */
  repoAddTopíc(owner: string, repo: string, topic: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoAddTopícResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param topic name of the topic to add
   * @param callback The callback
   */
  repoAddTopíc(owner: string, repo: string, topic: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param topic name of the topic to add
   * @param options The optional parameters
   * @param callback The callback
   */
  repoAddTopíc(owner: string, repo: string, topic: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoAddTopíc(owner: string, repo: string, topic: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoAddTopícResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        topic,
        options
      },
      repoAddTopícOperationSpec,
      callback) as Promise<Models.RepoAddTopícResponse>;
  }

  /**
   * @summary Delete a topic from a repository
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param topic name of the topic to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoDeleteTopicResponse>
   */
  repoDeleteTopic(owner: string, repo: string, topic: string, options?: msRest.RequestOptionsBase): Promise<Models.RepoDeleteTopicResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param topic name of the topic to delete
   * @param callback The callback
   */
  repoDeleteTopic(owner: string, repo: string, topic: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param topic name of the topic to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  repoDeleteTopic(owner: string, repo: string, topic: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  repoDeleteTopic(owner: string, repo: string, topic: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.RepoDeleteTopicResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        topic,
        options
      },
      repoDeleteTopicOperationSpec,
      callback) as Promise<Models.RepoDeleteTopicResponse>;
  }

  /**
   * @summary Transfer a repo ownership
   * @param owner owner of the repo to transfer
   * @param repo name of the repo to transfer
   * @param body Transfer Options
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoTransferResponse>
   */
  repoTransfer(owner: string, repo: string, body: Models.TransferRepoOption, options?: msRest.RequestOptionsBase): Promise<Models.RepoTransferResponse>;
  /**
   * @param owner owner of the repo to transfer
   * @param repo name of the repo to transfer
   * @param body Transfer Options
   * @param callback The callback
   */
  repoTransfer(owner: string, repo: string, body: Models.TransferRepoOption, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param owner owner of the repo to transfer
   * @param repo name of the repo to transfer
   * @param body Transfer Options
   * @param options The optional parameters
   * @param callback The callback
   */
  repoTransfer(owner: string, repo: string, body: Models.TransferRepoOption, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Repository>): void;
  repoTransfer(owner: string, repo: string, body: Models.TransferRepoOption, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.RepoTransferResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        body,
        options
      },
      repoTransferOperationSpec,
      callback) as Promise<Models.RepoTransferResponse>;
  }

  /**
   * @summary Get a repository by id
   * @param id id of the repo to get
   * @param [options] The optional parameters
   * @returns Promise<Models.RepoGetByIDResponse>
   */
  repoGetByID(id: number, options?: msRest.RequestOptionsBase): Promise<Models.RepoGetByIDResponse>;
  /**
   * @param id id of the repo to get
   * @param callback The callback
   */
  repoGetByID(id: number, callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param id id of the repo to get
   * @param options The optional parameters
   * @param callback The callback
   */
  repoGetByID(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Repository>): void;
  repoGetByID(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.RepoGetByIDResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      repoGetByIDOperationSpec,
      callback) as Promise<Models.RepoGetByIDResponse>;
  }

  /**
   * @summary Get default signing-key.gpg
   * @param [options] The optional parameters
   * @returns Promise<Models.GetSigningKeyResponse>
   */
  getSigningKey(options?: msRest.RequestOptionsBase): Promise<Models.GetSigningKeyResponse>;
  /**
   * @param callback The callback
   */
  getSigningKey(callback: msRest.ServiceCallback<string>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  getSigningKey(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<string>): void;
  getSigningKey(options?: msRest.RequestOptionsBase | msRest.ServiceCallback<string>, callback?: msRest.ServiceCallback<string>): Promise<Models.GetSigningKeyResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      getSigningKeyOperationSpec,
      callback) as Promise<Models.GetSigningKeyResponse>;
  }

  /**
   * @summary Get a team
   * @param id id of the team to get
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgGetTeamResponse>
   */
  orgGetTeam(id: number, options?: msRest.RequestOptionsBase): Promise<Models.OrgGetTeamResponse>;
  /**
   * @param id id of the team to get
   * @param callback The callback
   */
  orgGetTeam(id: number, callback: msRest.ServiceCallback<Models.Team>): void;
  /**
   * @param id id of the team to get
   * @param options The optional parameters
   * @param callback The callback
   */
  orgGetTeam(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Team>): void;
  orgGetTeam(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Team>, callback?: msRest.ServiceCallback<Models.Team>): Promise<Models.OrgGetTeamResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      orgGetTeamOperationSpec,
      callback) as Promise<Models.OrgGetTeamResponse>;
  }

  /**
   * @summary Delete a team
   * @param id id of the team to delete
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgDeleteTeam(id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param id id of the team to delete
   * @param callback The callback
   */
  orgDeleteTeam(id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of the team to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  orgDeleteTeam(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgDeleteTeam(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      orgDeleteTeamOperationSpec,
      callback);
  }

  /**
   * @summary Edit a team
   * @param id id of the team to edit
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgEditTeamResponse>
   */
  orgEditTeam(id: number, options?: Models.GiteaAPIOrgEditTeamOptionalParams): Promise<Models.OrgEditTeamResponse>;
  /**
   * @param id id of the team to edit
   * @param callback The callback
   */
  orgEditTeam(id: number, callback: msRest.ServiceCallback<Models.Team>): void;
  /**
   * @param id id of the team to edit
   * @param options The optional parameters
   * @param callback The callback
   */
  orgEditTeam(id: number, options: Models.GiteaAPIOrgEditTeamOptionalParams, callback: msRest.ServiceCallback<Models.Team>): void;
  orgEditTeam(id: number, options?: Models.GiteaAPIOrgEditTeamOptionalParams | msRest.ServiceCallback<Models.Team>, callback?: msRest.ServiceCallback<Models.Team>): Promise<Models.OrgEditTeamResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      orgEditTeamOperationSpec,
      callback) as Promise<Models.OrgEditTeamResponse>;
  }

  /**
   * @summary List a team's members
   * @param id id of the team
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListTeamMembersResponse>
   */
  orgListTeamMembers(id: number, options?: Models.GiteaAPIOrgListTeamMembersOptionalParams): Promise<Models.OrgListTeamMembersResponse>;
  /**
   * @param id id of the team
   * @param callback The callback
   */
  orgListTeamMembers(id: number, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param id id of the team
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListTeamMembers(id: number, options: Models.GiteaAPIOrgListTeamMembersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  orgListTeamMembers(id: number, options?: Models.GiteaAPIOrgListTeamMembersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.OrgListTeamMembersResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      orgListTeamMembersOperationSpec,
      callback) as Promise<Models.OrgListTeamMembersResponse>;
  }

  /**
   * @summary List a particular member of team
   * @param id id of the team
   * @param username username of the member to list
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListTeamMemberResponse>
   */
  orgListTeamMember(id: number, username: string, options?: msRest.RequestOptionsBase): Promise<Models.OrgListTeamMemberResponse>;
  /**
   * @param id id of the team
   * @param username username of the member to list
   * @param callback The callback
   */
  orgListTeamMember(id: number, username: string, callback: msRest.ServiceCallback<Models.User>): void;
  /**
   * @param id id of the team
   * @param username username of the member to list
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListTeamMember(id: number, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.User>): void;
  orgListTeamMember(id: number, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.User>, callback?: msRest.ServiceCallback<Models.User>): Promise<Models.OrgListTeamMemberResponse> {
    return this.sendOperationRequest(
      {
        id,
        username,
        options
      },
      orgListTeamMemberOperationSpec,
      callback) as Promise<Models.OrgListTeamMemberResponse>;
  }

  /**
   * @summary Add a team member
   * @param id id of the team
   * @param username username of the user to add
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgAddTeamMember(id: number, username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param id id of the team
   * @param username username of the user to add
   * @param callback The callback
   */
  orgAddTeamMember(id: number, username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of the team
   * @param username username of the user to add
   * @param options The optional parameters
   * @param callback The callback
   */
  orgAddTeamMember(id: number, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgAddTeamMember(id: number, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        id,
        username,
        options
      },
      orgAddTeamMemberOperationSpec,
      callback);
  }

  /**
   * @summary Remove a team member
   * @param id id of the team
   * @param username username of the user to remove
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  orgRemoveTeamMember(id: number, username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param id id of the team
   * @param username username of the user to remove
   * @param callback The callback
   */
  orgRemoveTeamMember(id: number, username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of the team
   * @param username username of the user to remove
   * @param options The optional parameters
   * @param callback The callback
   */
  orgRemoveTeamMember(id: number, username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgRemoveTeamMember(id: number, username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        id,
        username,
        options
      },
      orgRemoveTeamMemberOperationSpec,
      callback);
  }

  /**
   * @summary List a team's repos
   * @param id id of the team
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListTeamReposResponse>
   */
  orgListTeamRepos(id: number, options?: Models.GiteaAPIOrgListTeamReposOptionalParams): Promise<Models.OrgListTeamReposResponse>;
  /**
   * @param id id of the team
   * @param callback The callback
   */
  orgListTeamRepos(id: number, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param id id of the team
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListTeamRepos(id: number, options: Models.GiteaAPIOrgListTeamReposOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  orgListTeamRepos(id: number, options?: Models.GiteaAPIOrgListTeamReposOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.OrgListTeamReposResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      orgListTeamReposOperationSpec,
      callback) as Promise<Models.OrgListTeamReposResponse>;
  }

  /**
   * @summary Add a repository to a team
   * @param id id of the team
   * @param org organization that owns the repo to add
   * @param repo name of the repo to add
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgAddTeamRepositoryResponse>
   */
  orgAddTeamRepository(id: number, org: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.OrgAddTeamRepositoryResponse>;
  /**
   * @param id id of the team
   * @param org organization that owns the repo to add
   * @param repo name of the repo to add
   * @param callback The callback
   */
  orgAddTeamRepository(id: number, org: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of the team
   * @param org organization that owns the repo to add
   * @param repo name of the repo to add
   * @param options The optional parameters
   * @param callback The callback
   */
  orgAddTeamRepository(id: number, org: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgAddTeamRepository(id: number, org: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.OrgAddTeamRepositoryResponse> {
    return this.sendOperationRequest(
      {
        id,
        org,
        repo,
        options
      },
      orgAddTeamRepositoryOperationSpec,
      callback) as Promise<Models.OrgAddTeamRepositoryResponse>;
  }

  /**
   * This does not delete the repository, it only removes the repository from the team.
   * @summary Remove a repository from a team
   * @param id id of the team
   * @param org organization that owns the repo to remove
   * @param repo name of the repo to remove
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgRemoveTeamRepositoryResponse>
   */
  orgRemoveTeamRepository(id: number, org: string, repo: string, options?: msRest.RequestOptionsBase): Promise<Models.OrgRemoveTeamRepositoryResponse>;
  /**
   * @param id id of the team
   * @param org organization that owns the repo to remove
   * @param repo name of the repo to remove
   * @param callback The callback
   */
  orgRemoveTeamRepository(id: number, org: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of the team
   * @param org organization that owns the repo to remove
   * @param repo name of the repo to remove
   * @param options The optional parameters
   * @param callback The callback
   */
  orgRemoveTeamRepository(id: number, org: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  orgRemoveTeamRepository(id: number, org: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.OrgRemoveTeamRepositoryResponse> {
    return this.sendOperationRequest(
      {
        id,
        org,
        repo,
        options
      },
      orgRemoveTeamRepositoryOperationSpec,
      callback) as Promise<Models.OrgRemoveTeamRepositoryResponse>;
  }

  /**
   * @summary search topics via keyword
   * @param q keywords to search
   * @param [options] The optional parameters
   * @returns Promise<Models.TopicSearchResponse>
   */
  topicSearch(q: string, options?: Models.GiteaAPITopicSearchOptionalParams): Promise<Models.TopicSearchResponse>;
  /**
   * @param q keywords to search
   * @param callback The callback
   */
  topicSearch(q: string, callback: msRest.ServiceCallback<Models.TopicResponse[]>): void;
  /**
   * @param q keywords to search
   * @param options The optional parameters
   * @param callback The callback
   */
  topicSearch(q: string, options: Models.GiteaAPITopicSearchOptionalParams, callback: msRest.ServiceCallback<Models.TopicResponse[]>): void;
  topicSearch(q: string, options?: Models.GiteaAPITopicSearchOptionalParams | msRest.ServiceCallback<Models.TopicResponse[]>, callback?: msRest.ServiceCallback<Models.TopicResponse[]>): Promise<Models.TopicSearchResponse> {
    return this.sendOperationRequest(
      {
        q,
        options
      },
      topicSearchOperationSpec,
      callback) as Promise<Models.TopicSearchResponse>;
  }

  /**
   * @summary Get the authenticated user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserGetCurrentResponse>
   */
  userGetCurrent(options?: msRest.RequestOptionsBase): Promise<Models.UserGetCurrentResponse>;
  /**
   * @param callback The callback
   */
  userGetCurrent(callback: msRest.ServiceCallback<Models.User>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userGetCurrent(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.User>): void;
  userGetCurrent(options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.User>, callback?: msRest.ServiceCallback<Models.User>): Promise<Models.UserGetCurrentResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userGetCurrentOperationSpec,
      callback) as Promise<Models.UserGetCurrentResponse>;
  }

  /**
   * @summary List the authenticated user's oauth2 applications
   * @param [options] The optional parameters
   * @returns Promise<Models.UserGetOauth2ApplicationResponse>
   */
  userGetOauth2Application(options?: Models.GiteaAPIUserGetOauth2ApplicationOptionalParams): Promise<Models.UserGetOauth2ApplicationResponse>;
  /**
   * @param callback The callback
   */
  userGetOauth2Application(callback: msRest.ServiceCallback<Models.OAuth2Application[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userGetOauth2Application(options: Models.GiteaAPIUserGetOauth2ApplicationOptionalParams, callback: msRest.ServiceCallback<Models.OAuth2Application[]>): void;
  userGetOauth2Application(options?: Models.GiteaAPIUserGetOauth2ApplicationOptionalParams | msRest.ServiceCallback<Models.OAuth2Application[]>, callback?: msRest.ServiceCallback<Models.OAuth2Application[]>): Promise<Models.UserGetOauth2ApplicationResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userGetOauth2ApplicationOperationSpec,
      callback) as Promise<Models.UserGetOauth2ApplicationResponse>;
  }

  /**
   * @summary creates a new OAuth2 application
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCreateOAuth2ApplicationResponse>
   */
  userCreateOAuth2Application(body: Models.CreateOAuth2ApplicationOptions, options?: msRest.RequestOptionsBase): Promise<Models.UserCreateOAuth2ApplicationResponse>;
  /**
   * @param body
   * @param callback The callback
   */
  userCreateOAuth2Application(body: Models.CreateOAuth2ApplicationOptions, callback: msRest.ServiceCallback<Models.OAuth2Application>): void;
  /**
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  userCreateOAuth2Application(body: Models.CreateOAuth2ApplicationOptions, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.OAuth2Application>): void;
  userCreateOAuth2Application(body: Models.CreateOAuth2ApplicationOptions, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.OAuth2Application>, callback?: msRest.ServiceCallback<Models.OAuth2Application>): Promise<Models.UserCreateOAuth2ApplicationResponse> {
    return this.sendOperationRequest(
      {
        body,
        options
      },
      userCreateOAuth2ApplicationOperationSpec,
      callback) as Promise<Models.UserCreateOAuth2ApplicationResponse>;
  }

  /**
   * @summary get an OAuth2 Application
   * @param id Application ID to be found
   * @param [options] The optional parameters
   * @returns Promise<Models.UserGetOAuth2ApplicationResponse>
   */
  userGetOAuth2Application(id: number, options?: msRest.RequestOptionsBase): Promise<Models.UserGetOAuth2ApplicationResponse>;
  /**
   * @param id Application ID to be found
   * @param callback The callback
   */
  userGetOAuth2Application(id: number, callback: msRest.ServiceCallback<Models.OAuth2Application>): void;
  /**
   * @param id Application ID to be found
   * @param options The optional parameters
   * @param callback The callback
   */
  userGetOAuth2Application(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.OAuth2Application>): void;
  userGetOAuth2Application(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.OAuth2Application>, callback?: msRest.ServiceCallback<Models.OAuth2Application>): Promise<Models.UserGetOAuth2ApplicationResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      userGetOAuth2ApplicationOperationSpec,
      callback) as Promise<Models.UserGetOAuth2ApplicationResponse>;
  }

  /**
   * @summary delete an OAuth2 Application
   * @param id token to be deleted
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userDeleteOAuth2Application(id: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param id token to be deleted
   * @param callback The callback
   */
  userDeleteOAuth2Application(id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id token to be deleted
   * @param options The optional parameters
   * @param callback The callback
   */
  userDeleteOAuth2Application(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userDeleteOAuth2Application(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      userDeleteOAuth2ApplicationOperationSpec,
      callback);
  }

  /**
   * @summary update an OAuth2 Application, this includes regenerating the client secret
   * @param id application to be updated
   * @param body
   * @param [options] The optional parameters
   * @returns Promise<Models.UserUpdateOAuth2ApplicationResponse>
   */
  userUpdateOAuth2Application(id: number, body: Models.CreateOAuth2ApplicationOptions, options?: msRest.RequestOptionsBase): Promise<Models.UserUpdateOAuth2ApplicationResponse>;
  /**
   * @param id application to be updated
   * @param body
   * @param callback The callback
   */
  userUpdateOAuth2Application(id: number, body: Models.CreateOAuth2ApplicationOptions, callback: msRest.ServiceCallback<Models.OAuth2Application>): void;
  /**
   * @param id application to be updated
   * @param body
   * @param options The optional parameters
   * @param callback The callback
   */
  userUpdateOAuth2Application(id: number, body: Models.CreateOAuth2ApplicationOptions, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.OAuth2Application>): void;
  userUpdateOAuth2Application(id: number, body: Models.CreateOAuth2ApplicationOptions, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.OAuth2Application>, callback?: msRest.ServiceCallback<Models.OAuth2Application>): Promise<Models.UserUpdateOAuth2ApplicationResponse> {
    return this.sendOperationRequest(
      {
        id,
        body,
        options
      },
      userUpdateOAuth2ApplicationOperationSpec,
      callback) as Promise<Models.UserUpdateOAuth2ApplicationResponse>;
  }

  /**
   * @summary List the authenticated user's email addresses
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListEmailsResponse>
   */
  userListEmails(options?: msRest.RequestOptionsBase): Promise<Models.UserListEmailsResponse>;
  /**
   * @param callback The callback
   */
  userListEmails(callback: msRest.ServiceCallback<Models.Email[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userListEmails(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.Email[]>): void;
  userListEmails(options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.Email[]>, callback?: msRest.ServiceCallback<Models.Email[]>): Promise<Models.UserListEmailsResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userListEmailsOperationSpec,
      callback) as Promise<Models.UserListEmailsResponse>;
  }

  /**
   * @summary Add email addresses
   * @param [options] The optional parameters
   * @returns Promise<Models.UserAddEmailResponse>
   */
  userAddEmail(options?: Models.GiteaAPIUserAddEmailOptionalParams): Promise<Models.UserAddEmailResponse>;
  /**
   * @param callback The callback
   */
  userAddEmail(callback: msRest.ServiceCallback<Models.Email[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userAddEmail(options: Models.GiteaAPIUserAddEmailOptionalParams, callback: msRest.ServiceCallback<Models.Email[]>): void;
  userAddEmail(options?: Models.GiteaAPIUserAddEmailOptionalParams | msRest.ServiceCallback<Models.Email[]>, callback?: msRest.ServiceCallback<Models.Email[]>): Promise<Models.UserAddEmailResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userAddEmailOperationSpec,
      callback) as Promise<Models.UserAddEmailResponse>;
  }

  /**
   * @summary Delete email addresses
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userDeleteEmail(options?: Models.GiteaAPIUserDeleteEmailOptionalParams): Promise<msRest.RestResponse>;
  /**
   * @param callback The callback
   */
  userDeleteEmail(callback: msRest.ServiceCallback<void>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userDeleteEmail(options: Models.GiteaAPIUserDeleteEmailOptionalParams, callback: msRest.ServiceCallback<void>): void;
  userDeleteEmail(options?: Models.GiteaAPIUserDeleteEmailOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userDeleteEmailOperationSpec,
      callback);
  }

  /**
   * @summary List the authenticated user's followers
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentListFollowersResponse>
   */
  userCurrentListFollowers(options?: Models.GiteaAPIUserCurrentListFollowersOptionalParams): Promise<Models.UserCurrentListFollowersResponse>;
  /**
   * @param callback The callback
   */
  userCurrentListFollowers(callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentListFollowers(options: Models.GiteaAPIUserCurrentListFollowersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  userCurrentListFollowers(options?: Models.GiteaAPIUserCurrentListFollowersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.UserCurrentListFollowersResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentListFollowersOperationSpec,
      callback) as Promise<Models.UserCurrentListFollowersResponse>;
  }

  /**
   * @summary List the users that the authenticated user is following
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentListFollowingResponse>
   */
  userCurrentListFollowing(options?: Models.GiteaAPIUserCurrentListFollowingOptionalParams): Promise<Models.UserCurrentListFollowingResponse>;
  /**
   * @param callback The callback
   */
  userCurrentListFollowing(callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentListFollowing(options: Models.GiteaAPIUserCurrentListFollowingOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  userCurrentListFollowing(options?: Models.GiteaAPIUserCurrentListFollowingOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.UserCurrentListFollowingResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentListFollowingOperationSpec,
      callback) as Promise<Models.UserCurrentListFollowingResponse>;
  }

  /**
   * @summary Check whether a user is followed by the authenticated user
   * @param username username of followed user
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCurrentCheckFollowing(username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param username username of followed user
   * @param callback The callback
   */
  userCurrentCheckFollowing(username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param username username of followed user
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentCheckFollowing(username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentCheckFollowing(username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userCurrentCheckFollowingOperationSpec,
      callback);
  }

  /**
   * @summary Follow a user
   * @param username username of user to follow
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCurrentPutFollow(username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param username username of user to follow
   * @param callback The callback
   */
  userCurrentPutFollow(username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param username username of user to follow
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentPutFollow(username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentPutFollow(username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userCurrentPutFollowOperationSpec,
      callback);
  }

  /**
   * @summary Unfollow a user
   * @param username username of user to unfollow
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCurrentDeleteFollow(username: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param username username of user to unfollow
   * @param callback The callback
   */
  userCurrentDeleteFollow(username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param username username of user to unfollow
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentDeleteFollow(username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentDeleteFollow(username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userCurrentDeleteFollowOperationSpec,
      callback);
  }

  /**
   * @summary List the authenticated user's GPG keys
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentListGPGKeysResponse>
   */
  userCurrentListGPGKeys(options?: Models.GiteaAPIUserCurrentListGPGKeysOptionalParams): Promise<Models.UserCurrentListGPGKeysResponse>;
  /**
   * @param callback The callback
   */
  userCurrentListGPGKeys(callback: msRest.ServiceCallback<Models.GPGKey[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentListGPGKeys(options: Models.GiteaAPIUserCurrentListGPGKeysOptionalParams, callback: msRest.ServiceCallback<Models.GPGKey[]>): void;
  userCurrentListGPGKeys(options?: Models.GiteaAPIUserCurrentListGPGKeysOptionalParams | msRest.ServiceCallback<Models.GPGKey[]>, callback?: msRest.ServiceCallback<Models.GPGKey[]>): Promise<Models.UserCurrentListGPGKeysResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentListGPGKeysOperationSpec,
      callback) as Promise<Models.UserCurrentListGPGKeysResponse>;
  }

  /**
   * @summary Create a GPG key
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentPostGPGKeyResponse>
   */
  userCurrentPostGPGKey(options?: Models.GiteaAPIUserCurrentPostGPGKeyOptionalParams): Promise<Models.UserCurrentPostGPGKeyResponse>;
  /**
   * @param callback The callback
   */
  userCurrentPostGPGKey(callback: msRest.ServiceCallback<Models.GPGKey>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentPostGPGKey(options: Models.GiteaAPIUserCurrentPostGPGKeyOptionalParams, callback: msRest.ServiceCallback<Models.GPGKey>): void;
  userCurrentPostGPGKey(options?: Models.GiteaAPIUserCurrentPostGPGKeyOptionalParams | msRest.ServiceCallback<Models.GPGKey>, callback?: msRest.ServiceCallback<Models.GPGKey>): Promise<Models.UserCurrentPostGPGKeyResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentPostGPGKeyOperationSpec,
      callback) as Promise<Models.UserCurrentPostGPGKeyResponse>;
  }

  /**
   * @summary Get a GPG key
   * @param id id of key to get
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentGetGPGKeyResponse>
   */
  userCurrentGetGPGKey(id: number, options?: msRest.RequestOptionsBase): Promise<Models.UserCurrentGetGPGKeyResponse>;
  /**
   * @param id id of key to get
   * @param callback The callback
   */
  userCurrentGetGPGKey(id: number, callback: msRest.ServiceCallback<Models.GPGKey>): void;
  /**
   * @param id id of key to get
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentGetGPGKey(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.GPGKey>): void;
  userCurrentGetGPGKey(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.GPGKey>, callback?: msRest.ServiceCallback<Models.GPGKey>): Promise<Models.UserCurrentGetGPGKeyResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      userCurrentGetGPGKeyOperationSpec,
      callback) as Promise<Models.UserCurrentGetGPGKeyResponse>;
  }

  /**
   * @summary Remove a GPG key
   * @param id id of key to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentDeleteGPGKeyResponse>
   */
  userCurrentDeleteGPGKey(id: number, options?: msRest.RequestOptionsBase): Promise<Models.UserCurrentDeleteGPGKeyResponse>;
  /**
   * @param id id of key to delete
   * @param callback The callback
   */
  userCurrentDeleteGPGKey(id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of key to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentDeleteGPGKey(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentDeleteGPGKey(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.UserCurrentDeleteGPGKeyResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      userCurrentDeleteGPGKeyOperationSpec,
      callback) as Promise<Models.UserCurrentDeleteGPGKeyResponse>;
  }

  /**
   * @summary List the authenticated user's public keys
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentListKeysResponse>
   */
  userCurrentListKeys(options?: Models.GiteaAPIUserCurrentListKeysOptionalParams): Promise<Models.UserCurrentListKeysResponse>;
  /**
   * @param callback The callback
   */
  userCurrentListKeys(callback: msRest.ServiceCallback<Models.PublicKey[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentListKeys(options: Models.GiteaAPIUserCurrentListKeysOptionalParams, callback: msRest.ServiceCallback<Models.PublicKey[]>): void;
  userCurrentListKeys(options?: Models.GiteaAPIUserCurrentListKeysOptionalParams | msRest.ServiceCallback<Models.PublicKey[]>, callback?: msRest.ServiceCallback<Models.PublicKey[]>): Promise<Models.UserCurrentListKeysResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentListKeysOperationSpec,
      callback) as Promise<Models.UserCurrentListKeysResponse>;
  }

  /**
   * @summary Create a public key
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentPostKeyResponse>
   */
  userCurrentPostKey(options?: Models.GiteaAPIUserCurrentPostKeyOptionalParams): Promise<Models.UserCurrentPostKeyResponse>;
  /**
   * @param callback The callback
   */
  userCurrentPostKey(callback: msRest.ServiceCallback<Models.PublicKey>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentPostKey(options: Models.GiteaAPIUserCurrentPostKeyOptionalParams, callback: msRest.ServiceCallback<Models.PublicKey>): void;
  userCurrentPostKey(options?: Models.GiteaAPIUserCurrentPostKeyOptionalParams | msRest.ServiceCallback<Models.PublicKey>, callback?: msRest.ServiceCallback<Models.PublicKey>): Promise<Models.UserCurrentPostKeyResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentPostKeyOperationSpec,
      callback) as Promise<Models.UserCurrentPostKeyResponse>;
  }

  /**
   * @summary Get a public key
   * @param id id of key to get
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentGetKeyResponse>
   */
  userCurrentGetKey(id: number, options?: msRest.RequestOptionsBase): Promise<Models.UserCurrentGetKeyResponse>;
  /**
   * @param id id of key to get
   * @param callback The callback
   */
  userCurrentGetKey(id: number, callback: msRest.ServiceCallback<Models.PublicKey>): void;
  /**
   * @param id id of key to get
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentGetKey(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.PublicKey>): void;
  userCurrentGetKey(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.PublicKey>, callback?: msRest.ServiceCallback<Models.PublicKey>): Promise<Models.UserCurrentGetKeyResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      userCurrentGetKeyOperationSpec,
      callback) as Promise<Models.UserCurrentGetKeyResponse>;
  }

  /**
   * @summary Delete a public key
   * @param id id of key to delete
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentDeleteKeyResponse>
   */
  userCurrentDeleteKey(id: number, options?: msRest.RequestOptionsBase): Promise<Models.UserCurrentDeleteKeyResponse>;
  /**
   * @param id id of key to delete
   * @param callback The callback
   */
  userCurrentDeleteKey(id: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param id id of key to delete
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentDeleteKey(id: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentDeleteKey(id: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.UserCurrentDeleteKeyResponse> {
    return this.sendOperationRequest(
      {
        id,
        options
      },
      userCurrentDeleteKeyOperationSpec,
      callback) as Promise<Models.UserCurrentDeleteKeyResponse>;
  }

  /**
   * @summary List the current user's organizations
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListCurrentUserOrgsResponse>
   */
  orgListCurrentUserOrgs(options?: Models.GiteaAPIOrgListCurrentUserOrgsOptionalParams): Promise<Models.OrgListCurrentUserOrgsResponse>;
  /**
   * @param callback The callback
   */
  orgListCurrentUserOrgs(callback: msRest.ServiceCallback<Models.Organization[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListCurrentUserOrgs(options: Models.GiteaAPIOrgListCurrentUserOrgsOptionalParams, callback: msRest.ServiceCallback<Models.Organization[]>): void;
  orgListCurrentUserOrgs(options?: Models.GiteaAPIOrgListCurrentUserOrgsOptionalParams | msRest.ServiceCallback<Models.Organization[]>, callback?: msRest.ServiceCallback<Models.Organization[]>): Promise<Models.OrgListCurrentUserOrgsResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      orgListCurrentUserOrgsOperationSpec,
      callback) as Promise<Models.OrgListCurrentUserOrgsResponse>;
  }

  /**
   * @summary List the repos that the authenticated user owns or has access to
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentListReposResponse>
   */
  userCurrentListRepos(options?: Models.GiteaAPIUserCurrentListReposOptionalParams): Promise<Models.UserCurrentListReposResponse>;
  /**
   * @param callback The callback
   */
  userCurrentListRepos(callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentListRepos(options: Models.GiteaAPIUserCurrentListReposOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  userCurrentListRepos(options?: Models.GiteaAPIUserCurrentListReposOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.UserCurrentListReposResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentListReposOperationSpec,
      callback) as Promise<Models.UserCurrentListReposResponse>;
  }

  /**
   * @summary Create a repository
   * @param [options] The optional parameters
   * @returns Promise<Models.CreateCurrentUserRepoResponse>
   */
  createCurrentUserRepo(options?: Models.GiteaAPICreateCurrentUserRepoOptionalParams): Promise<Models.CreateCurrentUserRepoResponse>;
  /**
   * @param callback The callback
   */
  createCurrentUserRepo(callback: msRest.ServiceCallback<Models.Repository>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  createCurrentUserRepo(options: Models.GiteaAPICreateCurrentUserRepoOptionalParams, callback: msRest.ServiceCallback<Models.Repository>): void;
  createCurrentUserRepo(options?: Models.GiteaAPICreateCurrentUserRepoOptionalParams | msRest.ServiceCallback<Models.Repository>, callback?: msRest.ServiceCallback<Models.Repository>): Promise<Models.CreateCurrentUserRepoResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      createCurrentUserRepoOperationSpec,
      callback) as Promise<Models.CreateCurrentUserRepoResponse>;
  }

  /**
   * @summary The repos that the authenticated user has starred
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentListStarredResponse>
   */
  userCurrentListStarred(options?: Models.GiteaAPIUserCurrentListStarredOptionalParams): Promise<Models.UserCurrentListStarredResponse>;
  /**
   * @param callback The callback
   */
  userCurrentListStarred(callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentListStarred(options: Models.GiteaAPIUserCurrentListStarredOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  userCurrentListStarred(options?: Models.GiteaAPIUserCurrentListStarredOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.UserCurrentListStarredResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentListStarredOperationSpec,
      callback) as Promise<Models.UserCurrentListStarredResponse>;
  }

  /**
   * @summary Whether the authenticated is starring the repo
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCurrentCheckStarring(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param callback The callback
   */
  userCurrentCheckStarring(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo
   * @param repo name of the repo
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentCheckStarring(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentCheckStarring(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      userCurrentCheckStarringOperationSpec,
      callback);
  }

  /**
   * @summary Star the given repo
   * @param owner owner of the repo to star
   * @param repo name of the repo to star
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCurrentPutStar(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo to star
   * @param repo name of the repo to star
   * @param callback The callback
   */
  userCurrentPutStar(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo to star
   * @param repo name of the repo to star
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentPutStar(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentPutStar(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      userCurrentPutStarOperationSpec,
      callback);
  }

  /**
   * @summary Unstar the given repo
   * @param owner owner of the repo to unstar
   * @param repo name of the repo to unstar
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCurrentDeleteStar(owner: string, repo: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param owner owner of the repo to unstar
   * @param repo name of the repo to unstar
   * @param callback The callback
   */
  userCurrentDeleteStar(owner: string, repo: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param owner owner of the repo to unstar
   * @param repo name of the repo to unstar
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentDeleteStar(owner: string, repo: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCurrentDeleteStar(owner: string, repo: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        owner,
        repo,
        options
      },
      userCurrentDeleteStarOperationSpec,
      callback);
  }

  /**
   * @summary Get list of all existing stopwatches
   * @param [options] The optional parameters
   * @returns Promise<Models.UserGetStopWatchesResponse>
   */
  userGetStopWatches(options?: Models.GiteaAPIUserGetStopWatchesOptionalParams): Promise<Models.UserGetStopWatchesResponse>;
  /**
   * @param callback The callback
   */
  userGetStopWatches(callback: msRest.ServiceCallback<Models.StopWatch[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userGetStopWatches(options: Models.GiteaAPIUserGetStopWatchesOptionalParams, callback: msRest.ServiceCallback<Models.StopWatch[]>): void;
  userGetStopWatches(options?: Models.GiteaAPIUserGetStopWatchesOptionalParams | msRest.ServiceCallback<Models.StopWatch[]>, callback?: msRest.ServiceCallback<Models.StopWatch[]>): Promise<Models.UserGetStopWatchesResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userGetStopWatchesOperationSpec,
      callback) as Promise<Models.UserGetStopWatchesResponse>;
  }

  /**
   * @summary List repositories watched by the authenticated user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentListSubscriptionsResponse>
   */
  userCurrentListSubscriptions(options?: Models.GiteaAPIUserCurrentListSubscriptionsOptionalParams): Promise<Models.UserCurrentListSubscriptionsResponse>;
  /**
   * @param callback The callback
   */
  userCurrentListSubscriptions(callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentListSubscriptions(options: Models.GiteaAPIUserCurrentListSubscriptionsOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  userCurrentListSubscriptions(options?: Models.GiteaAPIUserCurrentListSubscriptionsOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.UserCurrentListSubscriptionsResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentListSubscriptionsOperationSpec,
      callback) as Promise<Models.UserCurrentListSubscriptionsResponse>;
  }

  /**
   * @summary List all the teams a user belongs to
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListTeamsResponse>
   */
  userListTeams(options?: Models.GiteaAPIUserListTeamsOptionalParams): Promise<Models.UserListTeamsResponse>;
  /**
   * @param callback The callback
   */
  userListTeams(callback: msRest.ServiceCallback<Models.Team[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userListTeams(options: Models.GiteaAPIUserListTeamsOptionalParams, callback: msRest.ServiceCallback<Models.Team[]>): void;
  userListTeams(options?: Models.GiteaAPIUserListTeamsOptionalParams | msRest.ServiceCallback<Models.Team[]>, callback?: msRest.ServiceCallback<Models.Team[]>): Promise<Models.UserListTeamsResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userListTeamsOperationSpec,
      callback) as Promise<Models.UserListTeamsResponse>;
  }

  /**
   * @summary List the current user's tracked times
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCurrentTrackedTimesResponse>
   */
  userCurrentTrackedTimes(options?: Models.GiteaAPIUserCurrentTrackedTimesOptionalParams): Promise<Models.UserCurrentTrackedTimesResponse>;
  /**
   * @param callback The callback
   */
  userCurrentTrackedTimes(callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userCurrentTrackedTimes(options: Models.GiteaAPIUserCurrentTrackedTimesOptionalParams, callback: msRest.ServiceCallback<Models.TrackedTime[]>): void;
  userCurrentTrackedTimes(options?: Models.GiteaAPIUserCurrentTrackedTimesOptionalParams | msRest.ServiceCallback<Models.TrackedTime[]>, callback?: msRest.ServiceCallback<Models.TrackedTime[]>): Promise<Models.UserCurrentTrackedTimesResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userCurrentTrackedTimesOperationSpec,
      callback) as Promise<Models.UserCurrentTrackedTimesResponse>;
  }

  /**
   * @summary Search for users
   * @param [options] The optional parameters
   * @returns Promise<Models.UserSearchResponse>
   */
  userSearch(options?: Models.GiteaAPIUserSearchOptionalParams): Promise<Models.UserSearchResponse>;
  /**
   * @param callback The callback
   */
  userSearch(callback: msRest.ServiceCallback<Models.UserSearchOKResponse>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  userSearch(options: Models.GiteaAPIUserSearchOptionalParams, callback: msRest.ServiceCallback<Models.UserSearchOKResponse>): void;
  userSearch(options?: Models.GiteaAPIUserSearchOptionalParams | msRest.ServiceCallback<Models.UserSearchOKResponse>, callback?: msRest.ServiceCallback<Models.UserSearchOKResponse>): Promise<Models.UserSearchResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      userSearchOperationSpec,
      callback) as Promise<Models.UserSearchResponse>;
  }

  /**
   * @summary Check if one user is following another user
   * @param follower username of following user
   * @param followee username of followed user
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userCheckFollowing(follower: string, followee: string, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param follower username of following user
   * @param followee username of followed user
   * @param callback The callback
   */
  userCheckFollowing(follower: string, followee: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param follower username of following user
   * @param followee username of followed user
   * @param options The optional parameters
   * @param callback The callback
   */
  userCheckFollowing(follower: string, followee: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userCheckFollowing(follower: string, followee: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        follower,
        followee,
        options
      },
      userCheckFollowingOperationSpec,
      callback);
  }

  /**
   * @summary Get a user
   * @param username username of user to get
   * @param [options] The optional parameters
   * @returns Promise<Models.UserGetResponse>
   */
  userGet(username: string, options?: msRest.RequestOptionsBase): Promise<Models.UserGetResponse>;
  /**
   * @param username username of user to get
   * @param callback The callback
   */
  userGet(username: string, callback: msRest.ServiceCallback<Models.User>): void;
  /**
   * @param username username of user to get
   * @param options The optional parameters
   * @param callback The callback
   */
  userGet(username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.User>): void;
  userGet(username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.User>, callback?: msRest.ServiceCallback<Models.User>): Promise<Models.UserGetResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userGetOperationSpec,
      callback) as Promise<Models.UserGetResponse>;
  }

  /**
   * @summary List the given user's followers
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListFollowersResponse>
   */
  userListFollowers(username: string, options?: Models.GiteaAPIUserListFollowersOptionalParams): Promise<Models.UserListFollowersResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userListFollowers(username: string, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userListFollowers(username: string, options: Models.GiteaAPIUserListFollowersOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  userListFollowers(username: string, options?: Models.GiteaAPIUserListFollowersOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.UserListFollowersResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userListFollowersOperationSpec,
      callback) as Promise<Models.UserListFollowersResponse>;
  }

  /**
   * @summary List the users that the given user is following
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListFollowingResponse>
   */
  userListFollowing(username: string, options?: Models.GiteaAPIUserListFollowingOptionalParams): Promise<Models.UserListFollowingResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userListFollowing(username: string, callback: msRest.ServiceCallback<Models.User[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userListFollowing(username: string, options: Models.GiteaAPIUserListFollowingOptionalParams, callback: msRest.ServiceCallback<Models.User[]>): void;
  userListFollowing(username: string, options?: Models.GiteaAPIUserListFollowingOptionalParams | msRest.ServiceCallback<Models.User[]>, callback?: msRest.ServiceCallback<Models.User[]>): Promise<Models.UserListFollowingResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userListFollowingOperationSpec,
      callback) as Promise<Models.UserListFollowingResponse>;
  }

  /**
   * @summary List the given user's GPG keys
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListGPGKeysResponse>
   */
  userListGPGKeys(username: string, options?: Models.GiteaAPIUserListGPGKeysOptionalParams): Promise<Models.UserListGPGKeysResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userListGPGKeys(username: string, callback: msRest.ServiceCallback<Models.GPGKey[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userListGPGKeys(username: string, options: Models.GiteaAPIUserListGPGKeysOptionalParams, callback: msRest.ServiceCallback<Models.GPGKey[]>): void;
  userListGPGKeys(username: string, options?: Models.GiteaAPIUserListGPGKeysOptionalParams | msRest.ServiceCallback<Models.GPGKey[]>, callback?: msRest.ServiceCallback<Models.GPGKey[]>): Promise<Models.UserListGPGKeysResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userListGPGKeysOperationSpec,
      callback) as Promise<Models.UserListGPGKeysResponse>;
  }

  /**
   * @summary Get a user's heatmap
   * @param username username of user to get
   * @param [options] The optional parameters
   * @returns Promise<Models.UserGetHeatmapDataResponse>
   */
  userGetHeatmapData(username: string, options?: msRest.RequestOptionsBase): Promise<Models.UserGetHeatmapDataResponse>;
  /**
   * @param username username of user to get
   * @param callback The callback
   */
  userGetHeatmapData(username: string, callback: msRest.ServiceCallback<Models.UserHeatmapData[]>): void;
  /**
   * @param username username of user to get
   * @param options The optional parameters
   * @param callback The callback
   */
  userGetHeatmapData(username: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.UserHeatmapData[]>): void;
  userGetHeatmapData(username: string, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.UserHeatmapData[]>, callback?: msRest.ServiceCallback<Models.UserHeatmapData[]>): Promise<Models.UserGetHeatmapDataResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userGetHeatmapDataOperationSpec,
      callback) as Promise<Models.UserGetHeatmapDataResponse>;
  }

  /**
   * @summary List the given user's public keys
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListKeysResponse>
   */
  userListKeys(username: string, options?: Models.GiteaAPIUserListKeysOptionalParams): Promise<Models.UserListKeysResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userListKeys(username: string, callback: msRest.ServiceCallback<Models.PublicKey[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userListKeys(username: string, options: Models.GiteaAPIUserListKeysOptionalParams, callback: msRest.ServiceCallback<Models.PublicKey[]>): void;
  userListKeys(username: string, options?: Models.GiteaAPIUserListKeysOptionalParams | msRest.ServiceCallback<Models.PublicKey[]>, callback?: msRest.ServiceCallback<Models.PublicKey[]>): Promise<Models.UserListKeysResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userListKeysOperationSpec,
      callback) as Promise<Models.UserListKeysResponse>;
  }

  /**
   * @summary List a user's organizations
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.OrgListUserOrgsResponse>
   */
  orgListUserOrgs(username: string, options?: Models.GiteaAPIOrgListUserOrgsOptionalParams): Promise<Models.OrgListUserOrgsResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  orgListUserOrgs(username: string, callback: msRest.ServiceCallback<Models.Organization[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  orgListUserOrgs(username: string, options: Models.GiteaAPIOrgListUserOrgsOptionalParams, callback: msRest.ServiceCallback<Models.Organization[]>): void;
  orgListUserOrgs(username: string, options?: Models.GiteaAPIOrgListUserOrgsOptionalParams | msRest.ServiceCallback<Models.Organization[]>, callback?: msRest.ServiceCallback<Models.Organization[]>): Promise<Models.OrgListUserOrgsResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      orgListUserOrgsOperationSpec,
      callback) as Promise<Models.OrgListUserOrgsResponse>;
  }

  /**
   * @summary List the repos owned by the given user
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListReposResponse>
   */
  userListRepos(username: string, options?: Models.GiteaAPIUserListReposOptionalParams): Promise<Models.UserListReposResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userListRepos(username: string, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userListRepos(username: string, options: Models.GiteaAPIUserListReposOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  userListRepos(username: string, options?: Models.GiteaAPIUserListReposOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.UserListReposResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userListReposOperationSpec,
      callback) as Promise<Models.UserListReposResponse>;
  }

  /**
   * @summary The repos that the given user has starred
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListStarredResponse>
   */
  userListStarred(username: string, options?: Models.GiteaAPIUserListStarredOptionalParams): Promise<Models.UserListStarredResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userListStarred(username: string, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userListStarred(username: string, options: Models.GiteaAPIUserListStarredOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  userListStarred(username: string, options?: Models.GiteaAPIUserListStarredOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.UserListStarredResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userListStarredOperationSpec,
      callback) as Promise<Models.UserListStarredResponse>;
  }

  /**
   * @summary List the repositories watched by a user
   * @param username username of the user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserListSubscriptionsResponse>
   */
  userListSubscriptions(username: string, options?: Models.GiteaAPIUserListSubscriptionsOptionalParams): Promise<Models.UserListSubscriptionsResponse>;
  /**
   * @param username username of the user
   * @param callback The callback
   */
  userListSubscriptions(username: string, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  /**
   * @param username username of the user
   * @param options The optional parameters
   * @param callback The callback
   */
  userListSubscriptions(username: string, options: Models.GiteaAPIUserListSubscriptionsOptionalParams, callback: msRest.ServiceCallback<Models.Repository[]>): void;
  userListSubscriptions(username: string, options?: Models.GiteaAPIUserListSubscriptionsOptionalParams | msRest.ServiceCallback<Models.Repository[]>, callback?: msRest.ServiceCallback<Models.Repository[]>): Promise<Models.UserListSubscriptionsResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userListSubscriptionsOperationSpec,
      callback) as Promise<Models.UserListSubscriptionsResponse>;
  }

  /**
   * @summary List the authenticated user's access tokens
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserGetTokensResponse>
   */
  userGetTokens(username: string, options?: Models.GiteaAPIUserGetTokensOptionalParams): Promise<Models.UserGetTokensResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userGetTokens(username: string, callback: msRest.ServiceCallback<Models.AccessToken[]>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userGetTokens(username: string, options: Models.GiteaAPIUserGetTokensOptionalParams, callback: msRest.ServiceCallback<Models.AccessToken[]>): void;
  userGetTokens(username: string, options?: Models.GiteaAPIUserGetTokensOptionalParams | msRest.ServiceCallback<Models.AccessToken[]>, callback?: msRest.ServiceCallback<Models.AccessToken[]>): Promise<Models.UserGetTokensResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userGetTokensOperationSpec,
      callback) as Promise<Models.UserGetTokensResponse>;
  }

  /**
   * @summary Create an access token
   * @param username username of user
   * @param [options] The optional parameters
   * @returns Promise<Models.UserCreateTokenResponse>
   */
  userCreateToken(username: string, options?: Models.GiteaAPIUserCreateTokenOptionalParams): Promise<Models.UserCreateTokenResponse>;
  /**
   * @param username username of user
   * @param callback The callback
   */
  userCreateToken(username: string, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param username username of user
   * @param options The optional parameters
   * @param callback The callback
   */
  userCreateToken(username: string, options: Models.GiteaAPIUserCreateTokenOptionalParams, callback: msRest.ServiceCallback<void>): void;
  userCreateToken(username: string, options?: Models.GiteaAPIUserCreateTokenOptionalParams | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<Models.UserCreateTokenResponse> {
    return this.sendOperationRequest(
      {
        username,
        options
      },
      userCreateTokenOperationSpec,
      callback) as Promise<Models.UserCreateTokenResponse>;
  }

  /**
   * @summary delete an access token
   * @param username username of user
   * @param token token to be deleted
   * @param [options] The optional parameters
   * @returns Promise<msRest.RestResponse>
   */
  userDeleteAccessToken(username: string, token: number, options?: msRest.RequestOptionsBase): Promise<msRest.RestResponse>;
  /**
   * @param username username of user
   * @param token token to be deleted
   * @param callback The callback
   */
  userDeleteAccessToken(username: string, token: number, callback: msRest.ServiceCallback<void>): void;
  /**
   * @param username username of user
   * @param token token to be deleted
   * @param options The optional parameters
   * @param callback The callback
   */
  userDeleteAccessToken(username: string, token: number, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<void>): void;
  userDeleteAccessToken(username: string, token: number, options?: msRest.RequestOptionsBase | msRest.ServiceCallback<void>, callback?: msRest.ServiceCallback<void>): Promise<msRest.RestResponse> {
    return this.sendOperationRequest(
      {
        username,
        token,
        options
      },
      userDeleteAccessTokenOperationSpec,
      callback);
  }

  /**
   * @summary Returns the version of the Gitea application
   * @param [options] The optional parameters
   * @returns Promise<Models.GetVersionResponse>
   */
  getVersion(options?: msRest.RequestOptionsBase): Promise<Models.GetVersionResponse>;
  /**
   * @param callback The callback
   */
  getVersion(callback: msRest.ServiceCallback<Models.ServerVersion>): void;
  /**
   * @param options The optional parameters
   * @param callback The callback
   */
  getVersion(options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.ServerVersion>): void;
  getVersion(options?: msRest.RequestOptionsBase | msRest.ServiceCallback<Models.ServerVersion>, callback?: msRest.ServiceCallback<Models.ServerVersion>): Promise<Models.GetVersionResponse> {
    return this.sendOperationRequest(
      {
        options
      },
      getVersionOperationSpec,
      callback) as Promise<Models.GetVersionResponse>;
  }
}

// Operation Specifications
const serializer = new msRest.Serializer(Mappers);
const adminGetAllOrgsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "admin/orgs",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Organization"
            }
          }
        }
      },
      headersMapper: Mappers.AdminGetAllOrgsHeaders
    },
    403: {
      headersMapper: Mappers.AdminGetAllOrgsHeaders
    },
    default: {}
  },
  serializer
};

const adminGetAllUsersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "admin/users",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      },
      headersMapper: Mappers.AdminGetAllUsersHeaders
    },
    403: {
      headersMapper: Mappers.AdminGetAllUsersHeaders
    },
    default: {}
  },
  serializer
};

const adminCreateUserOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "admin/users",
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateUserOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.User,
      headersMapper: Mappers.AdminCreateUserHeaders
    },
    400: {
      headersMapper: Mappers.AdminCreateUserHeaders
    },
    403: {
      headersMapper: Mappers.AdminCreateUserHeaders
    },
    422: {
      headersMapper: Mappers.AdminCreateUserHeaders
    },
    default: {}
  },
  serializer
};

const adminDeleteUserOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "admin/users/{username}",
  urlParameters: [
    Parameters.username
  ],
  responses: {
    204: {
      headersMapper: Mappers.AdminDeleteUserHeaders
    },
    403: {
      headersMapper: Mappers.AdminDeleteUserHeaders
    },
    422: {
      headersMapper: Mappers.AdminDeleteUserHeaders
    },
    default: {}
  },
  serializer
};

const adminEditUserOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "admin/users/{username}",
  urlParameters: [
    Parameters.username
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditUserOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.User,
      headersMapper: Mappers.AdminEditUserHeaders
    },
    403: {
      headersMapper: Mappers.AdminEditUserHeaders
    },
    422: {
      headersMapper: Mappers.AdminEditUserHeaders
    },
    default: {}
  },
  serializer
};

const adminCreatePublicKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "admin/users/{username}/keys",
  urlParameters: [
    Parameters.username
  ],
  requestBody: {
    parameterPath: [
      "options",
      "key"
    ],
    mapper: Mappers.CreateKeyOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.PublicKey,
      headersMapper: Mappers.AdminCreatePublicKeyHeaders
    },
    403: {
      headersMapper: Mappers.AdminCreatePublicKeyHeaders
    },
    422: {
      headersMapper: Mappers.AdminCreatePublicKeyHeaders
    },
    default: {}
  },
  serializer
};

const adminDeleteUserPublicKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "admin/users/{username}/keys/{id}",
  urlParameters: [
    Parameters.username,
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.AdminDeleteUserPublicKeyHeaders
    },
    403: {
      headersMapper: Mappers.AdminDeleteUserPublicKeyHeaders
    },
    404: {
      headersMapper: Mappers.AdminDeleteUserPublicKeyHeaders
    },
    default: {}
  },
  serializer
};

const adminCreateOrgOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "admin/users/{username}/orgs",
  urlParameters: [
    Parameters.username
  ],
  requestBody: {
    parameterPath: "organization",
    mapper: {
      ...Mappers.CreateOrgOption,
      required: true
    }
  },
  responses: {
    201: {
      bodyMapper: Mappers.Organization,
      headersMapper: Mappers.AdminCreateOrgHeaders
    },
    403: {
      headersMapper: Mappers.AdminCreateOrgHeaders
    },
    422: {
      headersMapper: Mappers.AdminCreateOrgHeaders
    },
    default: {}
  },
  serializer
};

const adminCreateRepoOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "admin/users/{username}/repos",
  urlParameters: [
    Parameters.username
  ],
  requestBody: {
    parameterPath: "repository",
    mapper: {
      ...Mappers.CreateRepoOption,
      required: true
    }
  },
  responses: {
    201: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.AdminCreateRepoHeaders
    },
    403: {
      headersMapper: Mappers.AdminCreateRepoHeaders
    },
    404: {
      headersMapper: Mappers.AdminCreateRepoHeaders
    },
    409: {
      headersMapper: Mappers.AdminCreateRepoHeaders
    },
    422: {
      headersMapper: Mappers.AdminCreateRepoHeaders
    },
    default: {}
  },
  serializer
};

const renderMarkdownOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "markdown",
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.MarkdownOption
  },
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "String"
        }
      },
      headersMapper: Mappers.RenderMarkdownHeaders
    },
    422: {
      headersMapper: Mappers.RenderMarkdownHeaders
    },
    default: {}
  },
  serializer
};

const renderMarkdownRawOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "markdown/raw",
  requestBody: {
    parameterPath: "body",
    mapper: {
      required: true,
      serializedName: "body",
      type: {
        name: "String"
      }
    }
  },
  contentType: "text/plain",
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "String"
        }
      },
      headersMapper: Mappers.RenderMarkdownRawHeaders
    },
    422: {
      headersMapper: Mappers.RenderMarkdownRawHeaders
    },
    default: {}
  },
  serializer
};

const notifyGetListOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "notifications",
  queryParameters: [
    Parameters.all,
    Parameters.since,
    Parameters.before,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "NotificationThread"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const notifyReadListOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "notifications",
  queryParameters: [
    Parameters.lastReadAt
  ],
  responses: {
    205: {},
    default: {}
  },
  serializer
};

const notifyNewAvailableOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "notifications/new",
  responses: {
    200: {
      bodyMapper: Mappers.NotificationCount
    },
    default: {}
  },
  serializer
};

const notifyGetThreadOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "notifications/threads/{id}",
  urlParameters: [
    Parameters.id1
  ],
  responses: {
    200: {
      bodyMapper: Mappers.NotificationThread,
      headersMapper: Mappers.NotifyGetThreadHeaders
    },
    403: {
      headersMapper: Mappers.NotifyGetThreadHeaders
    },
    404: {
      headersMapper: Mappers.NotifyGetThreadHeaders
    },
    default: {}
  },
  serializer
};

const notifyReadThreadOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "notifications/threads/{id}",
  urlParameters: [
    Parameters.id1
  ],
  responses: {
    205: {
      headersMapper: Mappers.NotifyReadThreadHeaders
    },
    403: {
      headersMapper: Mappers.NotifyReadThreadHeaders
    },
    404: {
      headersMapper: Mappers.NotifyReadThreadHeaders
    },
    default: {}
  },
  serializer
};

const createOrgRepoDeprecatedOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "org/{org}/repos",
  urlParameters: [
    Parameters.org
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateRepoOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.CreateOrgRepoDeprecatedHeaders
    },
    403: {
      headersMapper: Mappers.CreateOrgRepoDeprecatedHeaders
    },
    422: {
      headersMapper: Mappers.CreateOrgRepoDeprecatedHeaders
    },
    default: {}
  },
  serializer
};

const orgGetAllOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Organization"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgCreateOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "orgs",
  requestBody: {
    parameterPath: "organization",
    mapper: {
      ...Mappers.CreateOrgOption,
      required: true
    }
  },
  responses: {
    201: {
      bodyMapper: Mappers.Organization,
      headersMapper: Mappers.OrgCreateHeaders
    },
    403: {
      headersMapper: Mappers.OrgCreateHeaders
    },
    422: {
      headersMapper: Mappers.OrgCreateHeaders
    },
    default: {}
  },
  serializer
};

const orgGetOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}",
  urlParameters: [
    Parameters.org
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Organization
    },
    default: {}
  },
  serializer
};

const orgDeleteOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "orgs/{org}",
  urlParameters: [
    Parameters.org
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const orgEditOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "orgs/{org}",
  urlParameters: [
    Parameters.org
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.EditOrgOption,
      required: true
    }
  },
  responses: {
    200: {
      bodyMapper: Mappers.Organization
    },
    default: {}
  },
  serializer
};

const orgListHooksOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/hooks",
  urlParameters: [
    Parameters.org
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Hook"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgCreateHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "orgs/{org}/hooks/",
  urlParameters: [
    Parameters.org
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.CreateHookOption,
      required: true
    }
  },
  responses: {
    201: {
      bodyMapper: Mappers.Hook
    },
    default: {}
  },
  serializer
};

const orgGetHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/hooks/{id}",
  urlParameters: [
    Parameters.org,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Hook
    },
    default: {}
  },
  serializer
};

const orgDeleteHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "orgs/{org}/hooks/{id}",
  urlParameters: [
    Parameters.org,
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const orgEditHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "orgs/{org}/hooks/{id}",
  urlParameters: [
    Parameters.org,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditHookOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Hook
    },
    default: {}
  },
  serializer
};

const orgListLabelsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/labels",
  urlParameters: [
    Parameters.org
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Label"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgCreateLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "orgs/{org}/labels",
  urlParameters: [
    Parameters.org
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateLabelOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Label,
      headersMapper: Mappers.OrgCreateLabelHeaders
    },
    422: {
      headersMapper: Mappers.OrgCreateLabelHeaders
    },
    default: {}
  },
  serializer
};

const orgGetLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/labels/{id}",
  urlParameters: [
    Parameters.org,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Label
    },
    default: {}
  },
  serializer
};

const orgDeleteLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "orgs/{org}/labels/{id}",
  urlParameters: [
    Parameters.org,
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const orgEditLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "orgs/{org}/labels/{id}",
  urlParameters: [
    Parameters.org,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditLabelOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Label,
      headersMapper: Mappers.OrgEditLabelHeaders
    },
    422: {
      headersMapper: Mappers.OrgEditLabelHeaders
    },
    default: {}
  },
  serializer
};

const orgListMembersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/members",
  urlParameters: [
    Parameters.org
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgIsMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/members/{username}",
  urlParameters: [
    Parameters.org,
    Parameters.username
  ],
  responses: {
    204: {},
    302: {},
    404: {},
    default: {}
  },
  serializer
};

const orgDeleteMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "orgs/{org}/members/{username}",
  urlParameters: [
    Parameters.org,
    Parameters.username
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const orgListPublicMembersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/public_members",
  urlParameters: [
    Parameters.org
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgIsPublicMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/public_members/{username}",
  urlParameters: [
    Parameters.org,
    Parameters.username
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const orgPublicizeMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "orgs/{org}/public_members/{username}",
  urlParameters: [
    Parameters.org,
    Parameters.username
  ],
  responses: {
    204: {
      headersMapper: Mappers.OrgPublicizeMemberHeaders
    },
    403: {
      headersMapper: Mappers.OrgPublicizeMemberHeaders
    },
    default: {}
  },
  serializer
};

const orgConcealMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "orgs/{org}/public_members/{username}",
  urlParameters: [
    Parameters.org,
    Parameters.username
  ],
  responses: {
    204: {
      headersMapper: Mappers.OrgConcealMemberHeaders
    },
    403: {
      headersMapper: Mappers.OrgConcealMemberHeaders
    },
    default: {}
  },
  serializer
};

const orgListReposOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/repos",
  urlParameters: [
    Parameters.org
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const createOrgRepoOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "orgs/{org}/repos",
  urlParameters: [
    Parameters.org
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateRepoOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.CreateOrgRepoHeaders
    },
    403: {
      headersMapper: Mappers.CreateOrgRepoHeaders
    },
    404: {
      headersMapper: Mappers.CreateOrgRepoHeaders
    },
    default: {}
  },
  serializer
};

const orgListTeamsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/teams",
  urlParameters: [
    Parameters.org
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Team"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgCreateTeamOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "orgs/{org}/teams",
  urlParameters: [
    Parameters.org
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateTeamOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Team,
      headersMapper: Mappers.OrgCreateTeamHeaders
    },
    422: {
      headersMapper: Mappers.OrgCreateTeamHeaders
    },
    default: {}
  },
  serializer
};

const teamSearchOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "orgs/{org}/teams/search",
  urlParameters: [
    Parameters.org
  ],
  queryParameters: [
    Parameters.q0,
    Parameters.includeDesc0,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: Mappers.TeamSearchOKResponse
    },
    default: {}
  },
  serializer
};

const issueSearchIssuesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/issues/search",
  queryParameters: [
    Parameters.state,
    Parameters.labels0,
    Parameters.q0,
    Parameters.priorityRepoId,
    Parameters.type,
    Parameters.page
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Issue"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoMigrateOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/migrate",
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.MigrateRepoForm
  },
  responses: {
    201: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.RepoMigrateHeaders
    },
    403: {
      headersMapper: Mappers.RepoMigrateHeaders
    },
    422: {
      headersMapper: Mappers.RepoMigrateHeaders
    },
    default: {}
  },
  serializer
};

const repoSearchOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/search",
  queryParameters: [
    Parameters.q0,
    Parameters.topic0,
    Parameters.includeDesc1,
    Parameters.uid,
    Parameters.priorityOwnerId,
    Parameters.starredBy,
    Parameters.privateParameter,
    Parameters.isPrivate,
    Parameters.template,
    Parameters.archived,
    Parameters.mode,
    Parameters.exclusive,
    Parameters.sort,
    Parameters.order,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: Mappers.SearchResults,
      headersMapper: Mappers.RepoSearchHeaders
    },
    422: {
      headersMapper: Mappers.RepoSearchHeaders
    },
    default: {}
  },
  serializer
};

const repoGetOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Repository
    },
    default: {}
  },
  serializer
};

const repoDeleteOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoDeleteHeaders
    },
    403: {
      headersMapper: Mappers.RepoDeleteHeaders
    },
    default: {}
  },
  serializer
};

const repoEditOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditRepoOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.RepoEditHeaders
    },
    403: {
      headersMapper: Mappers.RepoEditHeaders
    },
    422: {
      headersMapper: Mappers.RepoEditHeaders
    },
    default: {}
  },
  serializer
};

const repoGetArchiveOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/archive/{archive}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.archive
  ],
  responses: {
    200: {},
    404: {},
    default: {}
  },
  serializer
};

const repoListBranchProtectionOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/branch_protections",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "BranchProtection"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoCreateBranchProtectionOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/branch_protections",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateBranchProtectionOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.BranchProtection,
      headersMapper: Mappers.RepoCreateBranchProtectionHeaders
    },
    403: {
      headersMapper: Mappers.RepoCreateBranchProtectionHeaders
    },
    404: {
      headersMapper: Mappers.RepoCreateBranchProtectionHeaders
    },
    422: {
      headersMapper: Mappers.RepoCreateBranchProtectionHeaders
    },
    default: {}
  },
  serializer
};

const repoGetBranchProtectionOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/branch_protections/{name}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.name0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.BranchProtection
    },
    404: {},
    default: {}
  },
  serializer
};

const repoDeleteBranchProtectionOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/branch_protections/{name}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.name0
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const repoEditBranchProtectionOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/branch_protections/{name}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.name0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditBranchProtectionOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.BranchProtection,
      headersMapper: Mappers.RepoEditBranchProtectionHeaders
    },
    404: {
      headersMapper: Mappers.RepoEditBranchProtectionHeaders
    },
    422: {
      headersMapper: Mappers.RepoEditBranchProtectionHeaders
    },
    default: {}
  },
  serializer
};

const repoListBranchesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/branches",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Branch"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoGetBranchOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/branches/{branch}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.branch
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Branch
    },
    default: {}
  },
  serializer
};

const repoDeleteBranchOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/branches/{branch}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.branch
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoDeleteBranchHeaders
    },
    403: {
      headersMapper: Mappers.RepoDeleteBranchHeaders
    },
    default: {}
  },
  serializer
};

const repoListCollaboratorsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/collaborators",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoCheckCollaboratorOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/collaborators/{collaborator}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.collaborator
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoCheckCollaboratorHeaders
    },
    404: {
      headersMapper: Mappers.RepoCheckCollaboratorHeaders
    },
    422: {
      headersMapper: Mappers.RepoCheckCollaboratorHeaders
    },
    default: {}
  },
  serializer
};

const repoAddCollaboratorOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/collaborators/{collaborator}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.collaborator
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.AddCollaboratorOption
  },
  responses: {
    204: {
      headersMapper: Mappers.RepoAddCollaboratorHeaders
    },
    422: {
      headersMapper: Mappers.RepoAddCollaboratorHeaders
    },
    default: {}
  },
  serializer
};

const repoDeleteCollaboratorOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/collaborators/{collaborator}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.collaborator
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoDeleteCollaboratorHeaders
    },
    422: {
      headersMapper: Mappers.RepoDeleteCollaboratorHeaders
    },
    default: {}
  },
  serializer
};

const repoGetAllCommitsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/commits",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.sha0,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Commit"
            }
          }
        }
      },
      headersMapper: Mappers.RepoGetAllCommitsHeaders
    },
    404: {
      headersMapper: Mappers.RepoGetAllCommitsHeaders
    },
    409: {
      bodyMapper: Mappers.APIError,
      headersMapper: Mappers.RepoGetAllCommitsHeaders
    },
    default: {}
  },
  serializer
};

const repoGetCombinedStatusByRefOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/commits/{ref}/statuses",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.ref0
  ],
  queryParameters: [
    Parameters.page
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Status,
      headersMapper: Mappers.RepoGetCombinedStatusByRefHeaders
    },
    400: {
      headersMapper: Mappers.RepoGetCombinedStatusByRefHeaders
    },
    default: {}
  },
  serializer
};

const repoGetContentsListOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/contents",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.ref1
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "ContentsResponse"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const repoGetContentsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/contents/{filepath}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.filepath
  ],
  queryParameters: [
    Parameters.ref1
  ],
  responses: {
    200: {
      bodyMapper: Mappers.ContentsResponse
    },
    404: {},
    default: {}
  },
  serializer
};

const repoUpdateFileOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/contents/{filepath}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.filepath
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.UpdateFileOptions,
      required: true
    }
  },
  responses: {
    200: {
      bodyMapper: Mappers.FileResponse
    },
    default: {}
  },
  serializer
};

const repoCreateFileOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/contents/{filepath}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.filepath
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.CreateFileOptions,
      required: true
    }
  },
  responses: {
    201: {
      bodyMapper: Mappers.FileResponse
    },
    default: {}
  },
  serializer
};

const repoDeleteFileOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/contents/{filepath}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.filepath
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.DeleteFileOptions,
      required: true
    }
  },
  responses: {
    200: {
      bodyMapper: Mappers.FileDeleteResponse,
      headersMapper: Mappers.RepoDeleteFileHeaders
    },
    400: {
      headersMapper: Mappers.RepoDeleteFileHeaders
    },
    403: {
      headersMapper: Mappers.RepoDeleteFileHeaders
    },
    404: {
      headersMapper: Mappers.RepoDeleteFileHeaders
    },
    default: {}
  },
  serializer
};

const repoGetEditorConfigOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/editorconfig/{filepath}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.filepath
  ],
  responses: {
    200: {},
    404: {},
    default: {}
  },
  serializer
};

const listForksOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/forks",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const createForkOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/forks",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateForkOption
  },
  responses: {
    202: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.CreateForkHeaders
    },
    403: {
      headersMapper: Mappers.CreateForkHeaders
    },
    422: {
      headersMapper: Mappers.CreateForkHeaders
    },
    default: {}
  },
  serializer
};

const getBlobOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/git/blobs/{sha}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.sha1
  ],
  responses: {
    200: {
      bodyMapper: Mappers.GitBlobResponse,
      headersMapper: Mappers.GetBlobHeaders
    },
    400: {
      headersMapper: Mappers.GetBlobHeaders
    },
    default: {}
  },
  serializer
};

const repoGetSingleCommitOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/git/commits/{sha}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.sha1
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Commit,
      headersMapper: Mappers.RepoGetSingleCommitHeaders
    },
    404: {
      headersMapper: Mappers.RepoGetSingleCommitHeaders
    },
    422: {
      headersMapper: Mappers.RepoGetSingleCommitHeaders
    },
    default: {}
  },
  serializer
};

const repoListAllGitRefsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/git/refs",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Reference"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const repoListGitRefsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/git/refs/{ref}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.ref0
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Reference"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const getTagOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/git/tags/{sha}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.sha1
  ],
  responses: {
    200: {
      bodyMapper: Mappers.AnnotatedTag,
      headersMapper: Mappers.GetTagHeaders
    },
    400: {
      headersMapper: Mappers.GetTagHeaders
    },
    default: {}
  },
  serializer
};

const getTreeOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/git/trees/{sha}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.sha1
  ],
  queryParameters: [
    Parameters.recursive,
    Parameters.page,
    Parameters.perPage
  ],
  responses: {
    200: {
      bodyMapper: Mappers.GitTreeResponse,
      headersMapper: Mappers.GetTreeHeaders
    },
    400: {
      headersMapper: Mappers.GetTreeHeaders
    },
    default: {}
  },
  serializer
};

const repoListHooksOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/hooks",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Hook"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoCreateHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/hooks",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateHookOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Hook
    },
    default: {}
  },
  serializer
};

const repoListGitHooksOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/hooks/git",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "GitHook"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoGetGitHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/hooks/git/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id1
  ],
  responses: {
    200: {
      bodyMapper: Mappers.GitHook
    },
    404: {},
    default: {}
  },
  serializer
};

const repoDeleteGitHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/hooks/git/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id1
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const repoEditGitHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/hooks/git/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id1
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditGitHookOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.GitHook
    },
    404: {},
    default: {}
  },
  serializer
};

const repoGetHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/hooks/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Hook
    },
    404: {},
    default: {}
  },
  serializer
};

const repoDeleteHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/hooks/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const repoEditHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/hooks/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditHookOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Hook
    },
    default: {}
  },
  serializer
};

const repoTestHookOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/hooks/{id}/tests",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const issueListIssuesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.state,
    Parameters.labels0,
    Parameters.q0,
    Parameters.type,
    Parameters.milestones,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Issue"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const issueCreateIssueOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateIssueOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Issue,
      headersMapper: Mappers.IssueCreateIssueHeaders
    },
    403: {
      headersMapper: Mappers.IssueCreateIssueHeaders
    },
    412: {
      headersMapper: Mappers.IssueCreateIssueHeaders
    },
    422: {
      headersMapper: Mappers.IssueCreateIssueHeaders
    },
    default: {}
  },
  serializer
};

const issueGetRepoCommentsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/comments",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.since,
    Parameters.before,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Comment"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const issueGetCommentOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/comments/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Comment,
      headersMapper: Mappers.IssueGetCommentHeaders
    },
    204: {
      headersMapper: Mappers.IssueGetCommentHeaders
    },
    403: {
      headersMapper: Mappers.IssueGetCommentHeaders
    },
    404: {
      headersMapper: Mappers.IssueGetCommentHeaders
    },
    default: {}
  },
  serializer
};

const issueDeleteCommentOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/comments/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.IssueDeleteCommentHeaders
    },
    403: {
      headersMapper: Mappers.IssueDeleteCommentHeaders
    },
    404: {
      headersMapper: Mappers.IssueDeleteCommentHeaders
    },
    default: {}
  },
  serializer
};

const issueEditCommentOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/issues/comments/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditIssueCommentOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Comment,
      headersMapper: Mappers.IssueEditCommentHeaders
    },
    204: {
      headersMapper: Mappers.IssueEditCommentHeaders
    },
    403: {
      headersMapper: Mappers.IssueEditCommentHeaders
    },
    404: {
      headersMapper: Mappers.IssueEditCommentHeaders
    },
    default: {}
  },
  serializer
};

const issueGetCommentReactionsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/comments/{id}/reactions",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Reaction"
            }
          }
        }
      },
      headersMapper: Mappers.IssueGetCommentReactionsHeaders
    },
    403: {
      headersMapper: Mappers.IssueGetCommentReactionsHeaders
    },
    default: {}
  },
  serializer
};

const issuePostCommentReactionOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/comments/{id}/reactions",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "content"
    ],
    mapper: Mappers.EditReactionOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Reaction,
      headersMapper: Mappers.IssuePostCommentReactionHeaders
    },
    201: {
      bodyMapper: Mappers.Reaction,
      headersMapper: Mappers.IssuePostCommentReactionHeaders
    },
    403: {
      headersMapper: Mappers.IssuePostCommentReactionHeaders
    },
    default: {}
  },
  serializer
};

const issueDeleteCommentReactionOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/comments/{id}/reactions",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "content"
    ],
    mapper: Mappers.EditReactionOption
  },
  responses: {
    200: {
      headersMapper: Mappers.IssueDeleteCommentReactionHeaders
    },
    403: {
      headersMapper: Mappers.IssueDeleteCommentReactionHeaders
    },
    default: {}
  },
  serializer
};

const issueGetIssueOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/{index}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Issue
    },
    404: {},
    default: {}
  },
  serializer
};

const issueEditIssueOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/issues/{index}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditIssueOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Issue,
      headersMapper: Mappers.IssueEditIssueHeaders
    },
    403: {
      headersMapper: Mappers.IssueEditIssueHeaders
    },
    404: {
      headersMapper: Mappers.IssueEditIssueHeaders
    },
    412: {
      headersMapper: Mappers.IssueEditIssueHeaders
    },
    default: {}
  },
  serializer
};

const issueGetCommentsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/{index}/comments",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  queryParameters: [
    Parameters.since,
    Parameters.before
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Comment"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const issueCreateCommentOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/{index}/comments",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateIssueCommentOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Comment,
      headersMapper: Mappers.IssueCreateCommentHeaders
    },
    403: {
      headersMapper: Mappers.IssueCreateCommentHeaders
    },
    default: {}
  },
  serializer
};

const issueDeleteCommentDeprecatedOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/comments/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.IssueDeleteCommentDeprecatedHeaders
    },
    403: {
      headersMapper: Mappers.IssueDeleteCommentDeprecatedHeaders
    },
    404: {
      headersMapper: Mappers.IssueDeleteCommentDeprecatedHeaders
    },
    default: {}
  },
  serializer
};

const issueEditCommentDeprecatedOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/issues/{index}/comments/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditIssueCommentOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Comment,
      headersMapper: Mappers.IssueEditCommentDeprecatedHeaders
    },
    204: {
      headersMapper: Mappers.IssueEditCommentDeprecatedHeaders
    },
    403: {
      headersMapper: Mappers.IssueEditCommentDeprecatedHeaders
    },
    404: {
      headersMapper: Mappers.IssueEditCommentDeprecatedHeaders
    },
    default: {}
  },
  serializer
};

const issueEditIssueDeadlineOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/{index}/deadline",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditDeadlineOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.IssueDeadline,
      headersMapper: Mappers.IssueEditIssueDeadlineHeaders
    },
    403: {
      headersMapper: Mappers.IssueEditIssueDeadlineHeaders
    },
    404: {
      headersMapper: Mappers.IssueEditIssueDeadlineHeaders
    },
    default: {}
  },
  serializer
};

const issueGetLabelsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/{index}/labels",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Label"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const issueReplaceLabelsOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/issues/{index}/labels",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.IssueLabelsOption
  },
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Label"
            }
          }
        }
      },
      headersMapper: Mappers.IssueReplaceLabelsHeaders
    },
    403: {
      headersMapper: Mappers.IssueReplaceLabelsHeaders
    },
    default: {}
  },
  serializer
};

const issueAddLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/{index}/labels",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.IssueLabelsOption
  },
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Label"
            }
          }
        }
      },
      headersMapper: Mappers.IssueAddLabelHeaders
    },
    403: {
      headersMapper: Mappers.IssueAddLabelHeaders
    },
    default: {}
  },
  serializer
};

const issueClearLabelsOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/labels",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    204: {
      headersMapper: Mappers.IssueClearLabelsHeaders
    },
    403: {
      headersMapper: Mappers.IssueClearLabelsHeaders
    },
    default: {}
  },
  serializer
};

const issueRemoveLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/labels/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.IssueRemoveLabelHeaders
    },
    403: {
      headersMapper: Mappers.IssueRemoveLabelHeaders
    },
    422: {
      headersMapper: Mappers.IssueRemoveLabelHeaders
    },
    default: {}
  },
  serializer
};

const issueGetIssueReactionsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/{index}/reactions",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Reaction"
            }
          }
        }
      },
      headersMapper: Mappers.IssueGetIssueReactionsHeaders
    },
    403: {
      headersMapper: Mappers.IssueGetIssueReactionsHeaders
    },
    default: {}
  },
  serializer
};

const issuePostIssueReactionOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/{index}/reactions",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "content"
    ],
    mapper: Mappers.EditReactionOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Reaction,
      headersMapper: Mappers.IssuePostIssueReactionHeaders
    },
    201: {
      bodyMapper: Mappers.Reaction,
      headersMapper: Mappers.IssuePostIssueReactionHeaders
    },
    403: {
      headersMapper: Mappers.IssuePostIssueReactionHeaders
    },
    default: {}
  },
  serializer
};

const issueDeleteIssueReactionOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/reactions",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "content"
    ],
    mapper: Mappers.EditReactionOption
  },
  responses: {
    200: {
      headersMapper: Mappers.IssueDeleteIssueReactionHeaders
    },
    403: {
      headersMapper: Mappers.IssueDeleteIssueReactionHeaders
    },
    default: {}
  },
  serializer
};

const issueDeleteStopWatchOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/stopwatch/delete",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    204: {},
    403: {},
    404: {},
    409: {},
    default: {}
  },
  serializer
};

const issueStartStopWatchOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/{index}/stopwatch/start",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    201: {},
    403: {},
    404: {},
    409: {},
    default: {}
  },
  serializer
};

const issueStopStopWatchOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/{index}/stopwatch/stop",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    201: {},
    403: {},
    404: {},
    409: {},
    default: {}
  },
  serializer
};

const issueSubscriptionsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/{index}/subscriptions",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const issueCheckSubscriptionOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/{index}/subscriptions/check",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    200: {
      bodyMapper: Mappers.WatchInfo
    },
    404: {},
    default: {}
  },
  serializer
};

const issueAddSubscriptionOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/issues/{index}/subscriptions/{user}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.user0
  ],
  responses: {
    200: {},
    201: {},
    304: {},
    404: {},
    default: {}
  },
  serializer
};

const issueDeleteSubscriptionOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/subscriptions/{user}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.user0
  ],
  responses: {
    200: {},
    201: {},
    304: {},
    404: {},
    default: {}
  },
  serializer
};

const issueTrackedTimesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/issues/{index}/times",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  queryParameters: [
    Parameters.since,
    Parameters.before,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "TrackedTime"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const issueAddTimeOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/issues/{index}/times",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.AddTimeOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.TrackedTime,
      headersMapper: Mappers.IssueAddTimeHeaders
    },
    400: {
      headersMapper: Mappers.IssueAddTimeHeaders
    },
    403: {
      headersMapper: Mappers.IssueAddTimeHeaders
    },
    default: {}
  },
  serializer
};

const issueResetTimeOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/times",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    204: {
      headersMapper: Mappers.IssueResetTimeHeaders
    },
    400: {
      headersMapper: Mappers.IssueResetTimeHeaders
    },
    403: {
      headersMapper: Mappers.IssueResetTimeHeaders
    },
    default: {}
  },
  serializer
};

const issueDeleteTimeOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/issues/{index}/times/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.IssueDeleteTimeHeaders
    },
    400: {
      headersMapper: Mappers.IssueDeleteTimeHeaders
    },
    403: {
      headersMapper: Mappers.IssueDeleteTimeHeaders
    },
    default: {}
  },
  serializer
};

const repoListKeysOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/keys",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.keyId,
    Parameters.fingerprint,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "DeployKey"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoCreateKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/keys",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateKeyOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.DeployKey,
      headersMapper: Mappers.RepoCreateKeyHeaders
    },
    422: {
      headersMapper: Mappers.RepoCreateKeyHeaders
    },
    default: {}
  },
  serializer
};

const repoGetKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/keys/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.DeployKey
    },
    default: {}
  },
  serializer
};

const repoDeleteKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/keys/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoDeleteKeyHeaders
    },
    403: {
      headersMapper: Mappers.RepoDeleteKeyHeaders
    },
    default: {}
  },
  serializer
};

const issueListLabelsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/labels",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Label"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const issueCreateLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/labels",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateLabelOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Label,
      headersMapper: Mappers.IssueCreateLabelHeaders
    },
    422: {
      headersMapper: Mappers.IssueCreateLabelHeaders
    },
    default: {}
  },
  serializer
};

const issueGetLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/labels/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Label
    },
    default: {}
  },
  serializer
};

const issueDeleteLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/labels/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const issueEditLabelOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/labels/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditLabelOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Label,
      headersMapper: Mappers.IssueEditLabelHeaders
    },
    422: {
      headersMapper: Mappers.IssueEditLabelHeaders
    },
    default: {}
  },
  serializer
};

const issueGetMilestonesListOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/milestones",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.state,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Milestone"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const issueCreateMilestoneOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/milestones",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateMilestoneOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Milestone
    },
    default: {}
  },
  serializer
};

const issueGetMilestoneOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/milestones/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Milestone
    },
    default: {}
  },
  serializer
};

const issueDeleteMilestoneOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/milestones/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const issueEditMilestoneOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/milestones/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditMilestoneOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Milestone
    },
    default: {}
  },
  serializer
};

const repoMirrorSyncOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/mirror-sync",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      headersMapper: Mappers.RepoMirrorSyncHeaders
    },
    403: {
      headersMapper: Mappers.RepoMirrorSyncHeaders
    },
    default: {}
  },
  serializer
};

const notifyGetRepoListOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/notifications",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.all,
    Parameters.since,
    Parameters.before,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "NotificationThread"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const notifyReadRepoListOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/notifications",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.lastReadAt
  ],
  responses: {
    205: {},
    default: {}
  },
  serializer
};

const repoListPullRequestsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/pulls",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.state,
    Parameters.sort,
    Parameters.milestone,
    Parameters.labels1,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "PullRequest"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoCreatePullRequestOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/pulls",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreatePullRequestOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.PullRequest,
      headersMapper: Mappers.RepoCreatePullRequestHeaders
    },
    409: {
      headersMapper: Mappers.RepoCreatePullRequestHeaders
    },
    422: {
      headersMapper: Mappers.RepoCreatePullRequestHeaders
    },
    default: {}
  },
  serializer
};

const repoGetPullRequestOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/pulls/{index}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    200: {
      bodyMapper: Mappers.PullRequest
    },
    404: {},
    default: {}
  },
  serializer
};

const repoEditPullRequestOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/pulls/{index}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditPullRequestOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.PullRequest,
      headersMapper: Mappers.RepoEditPullRequestHeaders
    },
    403: {
      headersMapper: Mappers.RepoEditPullRequestHeaders
    },
    412: {
      headersMapper: Mappers.RepoEditPullRequestHeaders
    },
    422: {
      headersMapper: Mappers.RepoEditPullRequestHeaders
    },
    default: {}
  },
  serializer
};

const repoPullRequestIsMergedOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/pulls/{index}/merge",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const repoMergePullRequestOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/pulls/{index}/merge",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.MergePullRequestOption
  },
  responses: {
    200: {
      headersMapper: Mappers.RepoMergePullRequestHeaders
    },
    405: {
      headersMapper: Mappers.RepoMergePullRequestHeaders
    },
    409: {
      headersMapper: Mappers.RepoMergePullRequestHeaders
    },
    default: {}
  },
  serializer
};

const repoListPullReviewsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/pulls/{index}/reviews",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "PullReview"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const repoCreatePullReviewOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/pulls/{index}/reviews",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.CreatePullReviewOptions,
      required: true
    }
  },
  responses: {
    200: {
      bodyMapper: Mappers.PullReview,
      headersMapper: Mappers.RepoCreatePullReviewHeaders
    },
    404: {
      headersMapper: Mappers.RepoCreatePullReviewHeaders
    },
    422: {
      headersMapper: Mappers.RepoCreatePullReviewHeaders
    },
    default: {}
  },
  serializer
};

const repoGetPullReviewOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/pulls/{index}/reviews/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.PullReview
    },
    404: {},
    default: {}
  },
  serializer
};

const repoSubmitPullReviewOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/pulls/{index}/reviews/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.SubmitPullReviewOptions,
      required: true
    }
  },
  responses: {
    200: {
      bodyMapper: Mappers.PullReview,
      headersMapper: Mappers.RepoSubmitPullReviewHeaders
    },
    404: {
      headersMapper: Mappers.RepoSubmitPullReviewHeaders
    },
    422: {
      headersMapper: Mappers.RepoSubmitPullReviewHeaders
    },
    default: {}
  },
  serializer
};

const repoDeletePullReviewOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/pulls/{index}/reviews/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoDeletePullReviewHeaders
    },
    403: {
      headersMapper: Mappers.RepoDeletePullReviewHeaders
    },
    404: {
      headersMapper: Mappers.RepoDeletePullReviewHeaders
    },
    default: {}
  },
  serializer
};

const repoGetPullReviewCommentsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/pulls/{index}/reviews/{id}/comments",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.index,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "PullReviewComment"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const repoGetRawFileOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/raw/{filepath}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.filepath
  ],
  responses: {
    200: {},
    404: {},
    default: {}
  },
  serializer
};

const repoListReleasesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/releases",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.perPage,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Release"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoCreateReleaseOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/releases",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateReleaseOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Release,
      headersMapper: Mappers.RepoCreateReleaseHeaders
    },
    409: {
      headersMapper: Mappers.RepoCreateReleaseHeaders
    },
    default: {}
  },
  serializer
};

const repoGetReleaseOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/releases/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Release
    },
    default: {}
  },
  serializer
};

const repoDeleteReleaseOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/releases/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const repoEditReleaseOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/releases/{id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditReleaseOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Release
    },
    default: {}
  },
  serializer
};

const repoListReleaseAttachmentsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/releases/{id}/assets",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Attachment"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoCreateReleaseAttachmentOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/releases/{id}/assets",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0
  ],
  queryParameters: [
    Parameters.name1
  ],
  formDataParameters: [
    Parameters.attachment
  ],
  contentType: "multipart/form-data",
  responses: {
    201: {
      bodyMapper: Mappers.Attachment,
      headersMapper: Mappers.RepoCreateReleaseAttachmentHeaders
    },
    400: {
      headersMapper: Mappers.RepoCreateReleaseAttachmentHeaders
    },
    default: {}
  },
  serializer
};

const repoGetReleaseAttachmentOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/releases/{id}/assets/{attachment_id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0,
    Parameters.attachmentId
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Attachment
    },
    default: {}
  },
  serializer
};

const repoDeleteReleaseAttachmentOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/releases/{id}/assets/{attachment_id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0,
    Parameters.attachmentId
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const repoEditReleaseAttachmentOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "repos/{owner}/{repo}/releases/{id}/assets/{attachment_id}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.id0,
    Parameters.attachmentId
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditAttachmentOptions
  },
  responses: {
    201: {
      bodyMapper: Mappers.Attachment
    },
    default: {}
  },
  serializer
};

const repoSigningKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/signing-key.gpg",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "String"
        }
      }
    },
    default: {}
  },
  serializer
};

const repoListStargazersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/stargazers",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoListStatusesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/statuses/{sha}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.sha1
  ],
  queryParameters: [
    Parameters.sort,
    Parameters.state,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Status"
            }
          }
        }
      },
      headersMapper: Mappers.RepoListStatusesHeaders
    },
    400: {
      headersMapper: Mappers.RepoListStatusesHeaders
    },
    default: {}
  },
  serializer
};

const repoCreateStatusOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/statuses/{sha}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.sha1
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateStatusOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Status,
      headersMapper: Mappers.RepoCreateStatusHeaders
    },
    400: {
      headersMapper: Mappers.RepoCreateStatusHeaders
    },
    default: {}
  },
  serializer
};

const repoListSubscribersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/subscribers",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentCheckSubscriptionOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/subscription",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: Mappers.WatchInfo
    },
    404: {},
    default: {}
  },
  serializer
};

const userCurrentPutSubscriptionOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/subscription",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    200: {
      bodyMapper: Mappers.WatchInfo
    },
    default: {}
  },
  serializer
};

const userCurrentDeleteSubscriptionOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/subscription",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const repoListTagsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/tags",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Tag"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const repoTrackedTimesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/times",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.user1,
    Parameters.since,
    Parameters.before,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "TrackedTime"
            }
          }
        }
      },
      headersMapper: Mappers.RepoTrackedTimesHeaders
    },
    400: {
      headersMapper: Mappers.RepoTrackedTimesHeaders
    },
    403: {
      headersMapper: Mappers.RepoTrackedTimesHeaders
    },
    default: {}
  },
  serializer
};

const userTrackedTimesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/times/{user}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.user0
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "TrackedTime"
            }
          }
        }
      },
      headersMapper: Mappers.UserTrackedTimesHeaders
    },
    400: {
      headersMapper: Mappers.UserTrackedTimesHeaders
    },
    403: {
      headersMapper: Mappers.UserTrackedTimesHeaders
    },
    default: {}
  },
  serializer
};

const repoListTopicsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repos/{owner}/{repo}/topics",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: Mappers.TopicName
    },
    default: {}
  },
  serializer
};

const repoUpdateTopicsOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/topics",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.RepoTopicOptions
  },
  responses: {
    204: {
      headersMapper: Mappers.RepoUpdateTopicsHeaders
    },
    422: {
      headersMapper: Mappers.RepoUpdateTopicsHeaders
    },
    default: {}
  },
  serializer
};

const repoAddTopícOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "repos/{owner}/{repo}/topics/{topic}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.topic1
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoAddTopícHeaders
    },
    422: {
      headersMapper: Mappers.RepoAddTopícHeaders
    },
    default: {}
  },
  serializer
};

const repoDeleteTopicOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "repos/{owner}/{repo}/topics/{topic}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo,
    Parameters.topic1
  ],
  responses: {
    204: {
      headersMapper: Mappers.RepoDeleteTopicHeaders
    },
    422: {
      headersMapper: Mappers.RepoDeleteTopicHeaders
    },
    default: {}
  },
  serializer
};

const repoTransferOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "repos/{owner}/{repo}/transfer",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.TransferRepoOption,
      required: true
    }
  },
  responses: {
    202: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.RepoTransferHeaders
    },
    403: {
      headersMapper: Mappers.RepoTransferHeaders
    },
    404: {
      headersMapper: Mappers.RepoTransferHeaders
    },
    422: {
      headersMapper: Mappers.RepoTransferHeaders
    },
    default: {}
  },
  serializer
};

const repoGetByIDOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "repositories/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Repository
    },
    default: {}
  },
  serializer
};

const getSigningKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "signing-key.gpg",
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "String"
        }
      }
    },
    default: {}
  },
  serializer
};

const orgGetTeamOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "teams/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.Team
    },
    default: {}
  },
  serializer
};

const orgDeleteTeamOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "teams/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const orgEditTeamOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "teams/{id}",
  urlParameters: [
    Parameters.id0
  ],
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.EditTeamOption
  },
  responses: {
    200: {
      bodyMapper: Mappers.Team
    },
    default: {}
  },
  serializer
};

const orgListTeamMembersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "teams/{id}/members",
  urlParameters: [
    Parameters.id0
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgListTeamMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "teams/{id}/members/{username}",
  urlParameters: [
    Parameters.id0,
    Parameters.username
  ],
  responses: {
    200: {
      bodyMapper: Mappers.User
    },
    404: {},
    default: {}
  },
  serializer
};

const orgAddTeamMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "teams/{id}/members/{username}",
  urlParameters: [
    Parameters.id0,
    Parameters.username
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const orgRemoveTeamMemberOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "teams/{id}/members/{username}",
  urlParameters: [
    Parameters.id0,
    Parameters.username
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const orgListTeamReposOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "teams/{id}/repos",
  urlParameters: [
    Parameters.id0
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgAddTeamRepositoryOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "teams/{id}/repos/{org}/{repo}",
  urlParameters: [
    Parameters.id0,
    Parameters.org,
    Parameters.repo
  ],
  responses: {
    204: {
      headersMapper: Mappers.OrgAddTeamRepositoryHeaders
    },
    403: {
      headersMapper: Mappers.OrgAddTeamRepositoryHeaders
    },
    default: {}
  },
  serializer
};

const orgRemoveTeamRepositoryOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "teams/{id}/repos/{org}/{repo}",
  urlParameters: [
    Parameters.id0,
    Parameters.org,
    Parameters.repo
  ],
  responses: {
    204: {
      headersMapper: Mappers.OrgRemoveTeamRepositoryHeaders
    },
    403: {
      headersMapper: Mappers.OrgRemoveTeamRepositoryHeaders
    },
    default: {}
  },
  serializer
};

const topicSearchOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "topics/search",
  queryParameters: [
    Parameters.q1,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "TopicResponse"
            }
          }
        }
      },
      headersMapper: Mappers.TopicSearchHeaders
    },
    403: {
      headersMapper: Mappers.TopicSearchHeaders
    },
    default: {}
  },
  serializer
};

const userGetCurrentOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user",
  responses: {
    200: {
      bodyMapper: Mappers.User
    },
    default: {}
  },
  serializer
};

const userGetOauth2ApplicationOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/applications/oauth2",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "OAuth2Application"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCreateOAuth2ApplicationOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "user/applications/oauth2",
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.CreateOAuth2ApplicationOptions,
      required: true
    }
  },
  responses: {
    201: {
      bodyMapper: Mappers.OAuth2Application
    },
    default: {}
  },
  serializer
};

const userGetOAuth2ApplicationOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/applications/oauth2/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.OAuth2Application
    },
    default: {}
  },
  serializer
};

const userDeleteOAuth2ApplicationOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "user/applications/oauth2/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const userUpdateOAuth2ApplicationOperationSpec: msRest.OperationSpec = {
  httpMethod: "PATCH",
  path: "user/applications/oauth2/{id}",
  urlParameters: [
    Parameters.id0
  ],
  requestBody: {
    parameterPath: "body",
    mapper: {
      ...Mappers.CreateOAuth2ApplicationOptions,
      required: true
    }
  },
  responses: {
    200: {
      bodyMapper: Mappers.OAuth2Application
    },
    default: {}
  },
  serializer
};

const userListEmailsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/emails",
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Email"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userAddEmailOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "user/emails",
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateEmailOption
  },
  responses: {
    201: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Email"
            }
          }
        }
      },
      headersMapper: Mappers.UserAddEmailHeaders
    },
    422: {
      headersMapper: Mappers.UserAddEmailHeaders
    },
    default: {}
  },
  serializer
};

const userDeleteEmailOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "user/emails",
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.DeleteEmailOption
  },
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const userCurrentListFollowersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/followers",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentListFollowingOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/following",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentCheckFollowingOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/following/{username}",
  urlParameters: [
    Parameters.username
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const userCurrentPutFollowOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "user/following/{username}",
  urlParameters: [
    Parameters.username
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const userCurrentDeleteFollowOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "user/following/{username}",
  urlParameters: [
    Parameters.username
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const userCurrentListGPGKeysOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/gpg_keys",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "GPGKey"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentPostGPGKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "user/gpg_keys",
  requestBody: {
    parameterPath: [
      "options",
      "form"
    ],
    mapper: Mappers.CreateGPGKeyOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.GPGKey,
      headersMapper: Mappers.UserCurrentPostGPGKeyHeaders
    },
    422: {
      headersMapper: Mappers.UserCurrentPostGPGKeyHeaders
    },
    default: {}
  },
  serializer
};

const userCurrentGetGPGKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/gpg_keys/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.GPGKey
    },
    404: {},
    default: {}
  },
  serializer
};

const userCurrentDeleteGPGKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "user/gpg_keys/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.UserCurrentDeleteGPGKeyHeaders
    },
    403: {
      headersMapper: Mappers.UserCurrentDeleteGPGKeyHeaders
    },
    default: {}
  },
  serializer
};

const userCurrentListKeysOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/keys",
  queryParameters: [
    Parameters.fingerprint,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "PublicKey"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentPostKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "user/keys",
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateKeyOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.PublicKey,
      headersMapper: Mappers.UserCurrentPostKeyHeaders
    },
    422: {
      headersMapper: Mappers.UserCurrentPostKeyHeaders
    },
    default: {}
  },
  serializer
};

const userCurrentGetKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/keys/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    200: {
      bodyMapper: Mappers.PublicKey
    },
    404: {},
    default: {}
  },
  serializer
};

const userCurrentDeleteKeyOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "user/keys/{id}",
  urlParameters: [
    Parameters.id0
  ],
  responses: {
    204: {
      headersMapper: Mappers.UserCurrentDeleteKeyHeaders
    },
    403: {
      headersMapper: Mappers.UserCurrentDeleteKeyHeaders
    },
    404: {
      headersMapper: Mappers.UserCurrentDeleteKeyHeaders
    },
    default: {}
  },
  serializer
};

const orgListCurrentUserOrgsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/orgs",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Organization"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentListReposOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/repos",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const createCurrentUserRepoOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "user/repos",
  requestBody: {
    parameterPath: [
      "options",
      "body"
    ],
    mapper: Mappers.CreateRepoOption
  },
  responses: {
    201: {
      bodyMapper: Mappers.Repository,
      headersMapper: Mappers.CreateCurrentUserRepoHeaders
    },
    409: {
      headersMapper: Mappers.CreateCurrentUserRepoHeaders
    },
    422: {
      headersMapper: Mappers.CreateCurrentUserRepoHeaders
    },
    default: {}
  },
  serializer
};

const userCurrentListStarredOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/starred",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentCheckStarringOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/starred/{owner}/{repo}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const userCurrentPutStarOperationSpec: msRest.OperationSpec = {
  httpMethod: "PUT",
  path: "user/starred/{owner}/{repo}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const userCurrentDeleteStarOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "user/starred/{owner}/{repo}",
  urlParameters: [
    Parameters.owner,
    Parameters.repo
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const userGetStopWatchesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/stopwatches",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "StopWatch"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentListSubscriptionsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/subscriptions",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userListTeamsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/teams",
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Team"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCurrentTrackedTimesOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "user/times",
  queryParameters: [
    Parameters.since,
    Parameters.before
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "TrackedTime"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userSearchOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/search",
  queryParameters: [
    Parameters.q0,
    Parameters.uid,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: Mappers.UserSearchOKResponse
    },
    default: {}
  },
  serializer
};

const userCheckFollowingOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{follower}/following/{followee}",
  urlParameters: [
    Parameters.follower,
    Parameters.followee
  ],
  responses: {
    204: {},
    404: {},
    default: {}
  },
  serializer
};

const userGetOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}",
  urlParameters: [
    Parameters.username
  ],
  responses: {
    200: {
      bodyMapper: Mappers.User
    },
    404: {},
    default: {}
  },
  serializer
};

const userListFollowersOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/followers",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userListFollowingOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/following",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "User"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userListGPGKeysOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/gpg_keys",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "GPGKey"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userGetHeatmapDataOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/heatmap",
  urlParameters: [
    Parameters.username
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "UserHeatmapData"
            }
          }
        }
      }
    },
    404: {},
    default: {}
  },
  serializer
};

const userListKeysOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/keys",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.fingerprint,
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "PublicKey"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const orgListUserOrgsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/orgs",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Organization"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userListReposOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/repos",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userListStarredOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/starred",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userListSubscriptionsOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/subscriptions",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "Repository"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userGetTokensOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "users/{username}/tokens",
  urlParameters: [
    Parameters.username
  ],
  queryParameters: [
    Parameters.page,
    Parameters.limit
  ],
  responses: {
    200: {
      bodyMapper: {
        serializedName: "parsedResponse",
        type: {
          name: "Sequence",
          element: {
            type: {
              name: "Composite",
              className: "AccessToken"
            }
          }
        }
      }
    },
    default: {}
  },
  serializer
};

const userCreateTokenOperationSpec: msRest.OperationSpec = {
  httpMethod: "POST",
  path: "users/{username}/tokens",
  urlParameters: [
    Parameters.username
  ],
  requestBody: {
    parameterPath: [
      "options",
      "accessToken"
    ],
    mapper: Mappers.AccessTokenModel
  },
  responses: {
    200: {
      headersMapper: Mappers.UserCreateTokenHeaders
    },
    default: {}
  },
  serializer
};

const userDeleteAccessTokenOperationSpec: msRest.OperationSpec = {
  httpMethod: "DELETE",
  path: "users/{username}/tokens/{token}",
  urlParameters: [
    Parameters.username,
    Parameters.token
  ],
  responses: {
    204: {},
    default: {}
  },
  serializer
};

const getVersionOperationSpec: msRest.OperationSpec = {
  httpMethod: "GET",
  path: "version",
  responses: {
    200: {
      bodyMapper: Mappers.ServerVersion
    },
    default: {}
  },
  serializer
};

export {
  GiteaAPI,
  GiteaAPIContext,
  Models as GiteaAPIModels,
  Mappers as GiteaAPIMappers
};
